# ML ADDs

Machine learning ADDs provide models and model generation for the machine learning ADDs project.

<!--
## Getting Started

```
generators/generate_all.py
```

which generates all figures for the models. Run it in the `generators` directory using:

```
python .\generate_all.py
```
-->

<!--
You might want to comment out 
```
...
```
at the end of the `main()` method or change the the `deployDir`.
-->

### Prerequisites / Installing

The [PlantUML](http://plantuml.com/download) jar file and  
[Codeable Models](https://github.com/uzdun/CodeableModels/) 
are required and the PYTHONPATH must be correctly set:

* The directory containing `codeableModels` and `plantUMLRenderer` must be on the PYTHONPATH.
* The directory containing this project must be on the PYTHONPATH.

See plantUMLRenderer directory in [Codeable Models](https://github.com/uzdun/CodeableModels/) for instructions how
to set up the plant UML jar. Without further configuration it is assumed to be in the default directory:

```
self.directory = "../_generated"
self.plant_uml_jar_path = "../../libs/plantuml.jar"
```

### Generating the models:

Assuming the following:
- This project is located in `/home/user/dev/add/ml-adds`.
- `CodeableModels` is located in `/home/user/dev/add/CodeableModels`.
- `plant_uml.jar` is located in `/home/user/dev/add/libs`.
- The values of neither `self.directory` nor `self.plant_uml_jar_path` have been changed.

Then the models can be generated as follows:

```
export PYTHONPATH="/home/user/dev/add/CodeableModels:/home/user/dev/add/ml-adds"

python /home/user/dev/add/ml-adds/generators/generate_all.py
```
<!--
## Running the tests

TBD

## Deployment

TBD
-->

## Built With

* [Codeable Models](https://github.com/uzdun/CodeableModels/) - Modelling platform
* [PlantUML](http://plantuml.com/download) - Generate figures


## Contributing

Please read [CONTRIBUTING.md] for details on our code of conduct, and the process for
submitting pull requests to us.

## Versioning

We use [SemVer](http://semver.org/) for versioning. For the versions available, see
the [tags on this repository](https://github.com/uzdun/MAPModels/tags).

## Authors

* **Uwe Zdun** - *Initial work* - [https://github.com/uzdun/](https://github.com/uzdun/)
* **Stephen John Warnett** - *Additional work*

## License

This project is licensed under the Apache 2.0 License - see the [LICENSE](LICENSE)
file for details

<!--
## Acknowledgments

*
-->
