# MS Security


## Decision: How to integrate a machine learning model in an application?
**Evidences:** s1, s2, s3, s4, s5, s6, s7, s9, s11, s12, s13, s14, s16, s19, s20, s25, s34

**Context:** Machine Learning Model and Application

### **Solution Options**
#### Solution 1: Model as a service
**Evidences:** s1, s2, s3, s4, s5, s6, s7, s9, s11, s13, s14, s16, s19, s20, s34

**Forces:**
- Division of labour (++) [s1, s3, s4, s5, s7, s20]
- Distributed development (++) [s1, s4, s5]
- Independent development (++) [s1, s3, s4, s5, s6, s7, s19]
- Scalability (++) [s1, s2, s3, s4, s5, s7, s11, s12, s13]
- Offline support (-) [s2, s6, s9, s11, s12, s13, s19]
- Online support (+) [s2, s6, s9, s11, s12, s13, s19]
- Model portability (++) [s2]
- Low latency (+) [s2, s4, s6, s16]
- Data throughput (+) [s2, s4, s6, s9, s12]
- Encapsulation (++) [s3]
- Separation of concerns (++) [s3, s5]
- Modularity (++) [s7, s16, s19, s25]
- Reusability (++) [s7, s13, s19, s25]
- Loose coupling (++) [s2, s5, s6, s7, s16, s19]
- Production-ready development (++) [s4, s13, s16, s19]
- Simplified deployment (+) [s20]
- Simplified model updates (+) [s20]
- Improved client heterogeneity (+) [s20]
- Improved support for numerous clients (+) [s20]
- Facilitates testing in production (+) [s20]
- Model consistency (+) [s25]

#### Solution 2: Model in monolith
**Evidences:** s1, s2, s3, s5, s13, s16, s19, s20

**Forces:**
- Division of labour (-) [s1, s3, s4, s5, s7, s20]
- Distributed development (-) [s1, s4, s5]
- Independent development (-) [s1, s3, s4, s5, s6, s7, s19]
- Scalability (-) [s1, s2, s3, s4, s5, s7, s11, s12, s13]
- Offline support (++) [s2, s6, s9, s11, s12, s13, s19]
- Online support (o) [s2, s6, s9, s11, s12, s13, s19]
- Model portability (--) [s2]
- Low latency (o) [s2, s4, s6, s16]
- Data throughput (-) [s2, s4, s6, s9, s12]
- Encapsulation (--) [s3]
- Separation of concerns (--) [s3, s5]
- Modularity (--) [s7, s16, s19, s25]
- Reusability (-) [s7, s13, s19, s25]
- Loose coupling (--) [s2, s5, s6, s7, s16, s19]
- Production-ready development (o) [s4, s13, s16, s19]
- Simplified deployment (o) [s20]
- Simplified model updates (o) [s20]
- Improved client heterogeneity (o) [s20]
- Improved support for numerous clients (o) [s20]
- Facilitates testing in production (o) [s20]
- Model consistency (o) [s25]

#### Solution 3: Model as module in modular monolith
**Evidences:** s1, s2, s3, s6, s13, s16, s19, s20

**Forces:**
- Division of labour (o) [s1, s3, s4, s5, s7, s20]
- Distributed development (o) [s1, s4, s5]
- Independent development (o) [s1, s3, s4, s5, s6, s7, s19]
- Scalability (o) [s1, s2, s3, s4, s5, s7, s11, s12, s13]
- Offline support (++) [s2, s6, s9, s11, s12, s13, s19]
- Online support (o) [s2, s6, s9, s11, s12, s13, s19]
- Model portability (o) [s2]
- Low latency (o) [s2, s4, s6, s16]
- Data throughput (-) [s2, s4, s6, s9, s12]
- Encapsulation (+) [s3]
- Separation of concerns (+) [s3, s5]
- Modularity (+) [s7, s16, s19, s25]
- Reusability (+) [s7, s13, s19, s25]
- Loose coupling (+) [s2, s5, s6, s7, s16, s19]
- Production-ready development (+) [s4, s13, s16, s19]
- Simplified deployment (o) [s20]
- Simplified model updates (o) [s20]
- Improved client heterogeneity (o) [s20]
- Improved support for numerous clients (o) [s20]
- Facilitates testing in production (o) [s20]

#### Solution 4: Model in batch prediction system
**Evidences:** s6, s20, s25

**Forces:**
- Division of labour (o) [s1, s3, s4, s5, s7, s20]
- Distributed development (o) [s1, s4, s5]
- Independent development (o) [s1, s3, s4, s5, s6, s7, s19]
- Scalability (-) [s1, s2, s3, s4, s5, s7, s11, s12, s13]
- Offline support (o) [s2, s6, s9, s11, s12, s13, s19]
- Online support (-) [s2, s6, s9, s11, s12, s13, s19]
- Model portability (o) [s2]
- Low latency (-) [s2, s4, s6, s16]
- Data throughput (-) [s2, s4, s6, s9, s12]
- Encapsulation (o) [s3]
- Separation of concerns (+) [s3, s5]
- Modularity (o) [s7, s16, s19, s25]
- Reusability (o) [s7, s13, s19, s25]
- Loose coupling (o) [s2, s5, s6, s7, s16, s19]
- Production-ready development (o) [s4, s13, s16, s19]
- Simplified deployment (o) [s20]
- Simplified model updates (o) [s20]
- Improved client heterogeneity (o) [s20]
- Improved support for numerous clients (o) [s20]
- Facilitates testing in production (o) [s20]

#### Solution 5: Event-driven model as a service
**Evidences:** s12, s20

**Forces:**
- Division of labour (++) [s1, s3, s4, s5, s7, s20]
- Distributed development (++) [s1, s4, s5]
- Independent development (++) [s1, s3, s4, s5, s6, s7, s19]
- Scalability (++) [s1, s2, s3, s4, s5, s7, s11, s12, s13]
- Offline support (-) [s2, s6, s9, s11, s12, s13, s19]
- Online support (+) [s2, s6, s9, s11, s12, s13, s19]
- Model portability (++) [s2]
- Low latency (+) [s2, s4, s6, s16]
- Data throughput (+) [s2, s4, s6, s9, s12]
- Encapsulation (++) [s3]
- Separation of concerns (++) [s3, s5]
- Modularity (++) [s7, s16, s19, s25]
- Reusability (++) [s7, s13, s19, s25]
- Loose coupling (++) [s2, s5, s6, s7, s16, s19]
- Production-ready development (++) [s4, s13, s16, s19]
- Simplified deployment (o) [s20]
- Simplified model updates (o) [s20]
- Improved client heterogeneity (o) [s20]
- Improved support for numerous clients (o) [s20]
- Facilitates testing in production (o) [s20]

#### Solution 6: Serverless model as a service
**Evidences:** s4, s7, s9, s11, s19, s20

**Forces:**
- Division of labour (++) [s1, s3, s4, s5, s7, s20]
- Distributed development (++) [s1, s4, s5]
- Independent development (++) [s1, s3, s4, s5, s6, s7, s19]
- Scalability (++) [s1, s2, s3, s4, s5, s7, s11, s12, s13]
- Offline support (-) [s2, s6, s9, s11, s12, s13, s19]
- Online support (+) [s2, s6, s9, s11, s12, s13, s19]
- Model portability (++) [s2]
- Low latency (+) [s2, s4, s6, s16]
- Data throughput (+) [s2, s4, s6, s9, s12]
- Encapsulation (++) [s3]
- Separation of concerns (++) [s3, s5]
- Modularity (++) [s7, s16, s19, s25]
- Reusability (++) [s7, s13, s19, s25]
- Loose coupling (++) [s2, s5, s6, s7, s16, s19]
- Production-ready development (++) [s4, s13, s16, s19]
- Simplified deployment (o) [s20]
- Simplified model updates (o) [s20]
- Improved client heterogeneity (o) [s20]
- Improved support for numerous clients (o) [s20]
- Facilitates testing in production (o) [s20]

#### Solution 7: No integration of the model
**Evidences:** s19, s20

**Forces:**
- Division of labour (-) [s1, s3, s4, s5, s7, s20]
- Distributed development (-) [s1, s4, s5]
- Independent development (-) [s1, s3, s4, s5, s6, s7, s19]
- Scalability (--) [s1, s2, s3, s4, s5, s7, s11, s12, s13]
- Offline support (+) [s2, s6, s9, s11, s12, s13, s19]
- Online support (--) [s2, s6, s9, s11, s12, s13, s19]
- Model portability (--) [s2]
- Low latency (o) [s2, s4, s6, s16]
- Data throughput (o) [s2, s4, s6, s9, s12]
- Encapsulation (o) [s3]
- Separation of concerns (-) [s3, s5]
- Modularity (-) [s7, s16, s19, s25]
- Reusability (--) [s7, s13, s19, s25]
- Loose coupling (-) [s2, s5, s6, s7, s16, s19]
- Production-ready development (--) [s4, s13, s16, s19]
- Simplified deployment (o) [s20]
- Simplified model updates (o) [s20]
- Improved client heterogeneity (o) [s20]
- Improved support for numerous clients (o) [s20]
- Facilitates testing in production (o) [s20]

#### **Next Decision**: How to serve model predictions or scores?


## Decision: How to store data used in machine learning applications?
**Evidences:** s1, s2, s4, s5, s8, s9, s11, s12, s13, s14, s15, s19, s20, s21

**Context:** Machine Learning Model and Application

### **Solution Options**
#### Solution 1: No data store
**Evidences:** s1, s5

**Forces:**
- Chatty data access API (+) [s5]
- Speed performance (+) [s2, s4, s5, s9, s11, s15]
- Scalability (+) [s1, s2, s4, s5, s11, s12, s13, s15]
- Data access flexibility (-) [s5]
- Data consistency (--) [s5]
- Maintainability (--) [s1, s5, s13]
- Modifiability (--) [s5, s8]
- Reliability (o) [s2, s5, s8]
- Loose coupling (o) [s2, s5, s19]
- Avoid cold start problem for training data (-) [s5]
- Computational load (+) [s5]
- Infrastructure costs (++) [s5, s21]
- Development velocity (--) [s5, s19]

#### Solution 2: Shared data store
**Evidences:** s1, s4, s5, s9, s11, s12, s13, s15

**Forces:**
- Chatty data access API (+) [s5]
- Speed performance (+) [s2, s4, s5, s9, s11, s15]
- Scalability (-) [s1, s2, s4, s5, s11, s12, s13, s15]
- Data access flexibility (+) [s5]
- Data consistency (++) [s5]
- Maintainability (o) [s1, s5, s13]
- Modifiability (o) [s5, s8]
- Reliability (o) [s2, s5, s8]
- Loose coupling (--) [s2, s5, s19]
- Avoid cold start problem for training data (++) [s5]
- Computational load (+) [s5]
- Infrastructure costs (+) [s5, s21]
- Development velocity (o) [s5, s19]

#### Solution 3: Data service
**Evidences:** s1, s2, s5, s13

**Forces:**
- Chatty data access API (-) [s5]
- Speed performance (-) [s2, s4, s5, s9, s11, s15]
- Scalability (-) [s1, s2, s4, s5, s11, s12, s13, s15]
- Data access flexibility (-) [s5]
- Data consistency (-) [s5]
- Maintainability (+) [s1, s5, s13]
- Modifiability (o) [s5, s8]
- Reliability (o) [s2, s5, s8]
- Loose coupling (+) [s2, s5, s19]
- Avoid cold start problem for training data (+) [s5]
- Computational load (o) [s5]
- Infrastructure costs (o) [s5, s21]
- Development velocity (+) [s5, s19]

#### Solution 4: Event store
**Evidences:** s5, s12

**Forces:**
- Chatty data access API (+) [s5]
- Speed performance (+) [s2, s4, s5, s9, s11, s15]
- Scalability (+) [s1, s2, s4, s5, s11, s12, s13, s15]
- Data access flexibility (+) [s5]
- Data consistency (+) [s5]
- Maintainability (+) [s1, s5, s13]
- Modifiability (+) [s5, s8]
- Reliability (+) [s2, s5, s8]
- Loose coupling (++) [s2, s5, s19]
- Avoid cold start problem for training data (+) [s5]
- Computational load (-) [s5]
- Infrastructure costs (-) [s5, s21]
- Development velocity (++) [s5, s19]

#### **Next Decision**: How to design the interface for data access? 
#### **Next Decision**: Should MLOps be applied and, if so, when?


## Decision: How to design the interface for data access? 
**Evidences:** s1, s2, s4, s5, s6, s8, s11, s12, s15

**Context:** Machine Learning Model and Application

### **Solution Options**
#### Solution 1: Data provider is accessed directly
**Evidences:** s1, s2, s12

**Forces:**
- Unified data access (-) [s1, s4, s12, s15]
- Near real-time support (--) [s1, s2, s4, s6, s11, s12, s15]
- Reliability (o) [s2, s5, s8]
- Low latency (--) [s2, s4, s6, s15]
- Data throughput (--) [s2, s4, s6, s12, s15]
- Observability (-) [s4, s8, s12]

#### Solution 2: Local data access API
**Evidences:** s1, s4, s5, s6, s8, s11, s12, s15

**Forces:**
- Unified data access (+) [s1, s4, s12, s15]
- Near real-time support (-) [s1, s2, s4, s6, s11, s12, s15]
- Reliability (o) [s2, s5, s8]
- Low latency (--) [s2, s4, s6, s15]
- Data throughput (--) [s2, s4, s6, s12, s15]
- Observability (+) [s4, s8, s12]

#### Solution 3: Service-based data access API
**Evidences:** s1, s2, s4, s5, s6, s8, s11, s12

**Forces:**
- Unified data access (+) [s1, s4, s12, s15]
- Near real-time support (o) [s1, s2, s4, s6, s11, s12, s15]
- Reliability (o) [s2, s5, s8]
- Low latency (+) [s2, s4, s6, s15]
- Data throughput (+) [s2, s4, s6, s12, s15]
- Observability (+) [s4, s8, s12]

#### Solution 4: Pub/sub data access API
**Evidences:** s2, s12, s15

**Forces:**
- Unified data access (+) [s1, s4, s12, s15]
- Near real-time support (++) [s1, s2, s4, s6, s11, s12, s15]
- Reliability (+) [s2, s5, s8]
- Low latency (++) [s2, s4, s6, s15]
- Data throughput (++) [s2, s4, s6, s12, s15]
- Observability (+) [s4, s8, s12]

#### Solution 5: Message/event queueing-based data access API
**Evidences:** s2, s5, s12, s15

**Forces:**
- Unified data access (+) [s1, s4, s12, s15]
- Near real-time support (+) [s1, s2, s4, s6, s11, s12, s15]
- Reliability (+) [s2, s5, s8]
- Low latency (++) [s2, s4, s6, s15]
- Data throughput (++) [s2, s4, s6, s12, s15]
- Observability (+) [s4, s8, s12]



## Decision: How to persist and provide access to features?
**Evidences:** s2, s4, s5, s6, s9, s10, s11, s13, s15, s22

**Context:** Machine Learning Model and Application

### **Solution Options**
#### Solution 1: Store features in data stores without specific support
**Evidences:** s2, s4, s5, s6, s13

**Forces:**
- Feature reuse (-) [s5, s6]
- Feature discovery (-) [s5, s6]
- Maintainability (-) [s5, s6, s13]
- Avoid training/serving skew (-) [s6]
- Online support (o) [s2, s6, s9, s10, s11, s13]
- Offline support (o) [s2, s6, s9, s10, s11, s13]
- Data throughput (o) [s2, s4, s6, s9, s15]
- Low latency (o) [s2, s4, s6, s15]
- Near real-time support (o) [s2, s4, s6, s10, s11, s13, s15]

#### Solution 2: Feature store
**Evidences:** s2, s4, s5, s6, s9, s10, s11, s13, s15

**Forces:**
- Feature reuse (+) [s5, s6]
- Feature discovery (+) [s5, s6]
- Maintainability (+) [s5, s6, s13]
- Avoid training/serving skew (+) [s6]
- Online support (+) [s2, s6, s9, s10, s11, s13]
- Offline support (+) [s2, s6, s9, s10, s11, s13]
- Data throughput (+) [s2, s4, s6, s9, s15]
- Low latency (+) [s2, s4, s6, s15]
- Near real-time support (+) [s2, s4, s6, s10, s11, s13, s15]

#### **Next Decision**: Should MLOps be applied and, if so, when?


## Decision: How to serve model predictions or scores?
**Evidences:** s1, s2, s3, s7, s9, s10, s11, s12, s13, s14, s15, s16, s18, s19

**Context:** Machine Learning Model and Application

### **Solution Options**
#### Solution 1: Microservice based model serving
**Evidences:** s1, s2, s3, s7, s9, s10, s11, s12, s13, s14, s16, s19

**Forces:**
- Near real-time support (++) [s1, s2, s10, s11, s12, s13, s15, s19]
- Efficiency (+) [s1]
- Maintainability (++) [s1, s13, s16]
- Scalability (++) [s1, s2, s3, s7, s11, s12, s13, s15]
- Online support (++) [s2, s9, s10, s11, s12, s13, s19]
- Offline support (-) [s2, s9, s10, s11, s12, s13, s19]
- Loose coupling (++) [s2, s7, s16, s19]
- Robustness (o) [s10]
- Modularity (++) [s7, s10, s16, s19]
- React to user event and interactions (+) [s12]
- Variety of machine learning algorithm choices (-) [s11, s12, s19]
- Data throughput (-) [s2, s9, s12, s15]

#### Solution 2: Local service/API based model serving
**Evidences:** s1, s3, s14, s19

**Forces:**
- Near real-time support (++) [s1, s2, s10, s11, s12, s13, s15, s19]
- Efficiency (o) [s1]
- Maintainability (+) [s1, s13, s16]
- Scalability (o) [s1, s2, s3, s7, s11, s12, s13, s15]
- Online support (++) [s2, s9, s10, s11, s12, s13, s19]
- Offline support (+) [s2, s9, s10, s11, s12, s13, s19]
- Loose coupling (+) [s2, s7, s16, s19]
- Robustness (o) [s10]
- Modularity (+) [s7, s10, s16, s19]
- React to user event and interactions (+) [s12]
- Variety of machine learning algorithm choices (-) [s11, s12, s19]
- Data throughput (-) [s2, s9, s12, s15]

#### Solution 3: Data batch based model serving
**Evidences:** s1, s2, s12, s19

**Forces:**
- Near real-time support (--) [s1, s2, s10, s11, s12, s13, s15, s19]
- Efficiency (--) [s1]
- Maintainability (-) [s1, s13, s16]
- Scalability (--) [s1, s2, s3, s7, s11, s12, s13, s15]
- Online support (-) [s2, s9, s10, s11, s12, s13, s19]
- Offline support (+) [s2, s9, s10, s11, s12, s13, s19]
- Loose coupling (o) [s2, s7, s16, s19]
- Robustness (o) [s10]
- Modularity (o) [s7, s10, s16, s19]
- React to user event and interactions (--) [s12]
- Variety of machine learning algorithm choices (+) [s11, s12, s19]
- Data throughput (++) [s2, s9, s12, s15]

#### Solution 4: Hybrid online/offline model serving
**Evidences:** s14, s19

**Forces:**
- Near real-time support (+) [s1, s2, s10, s11, s12, s13, s15, s19]
- Efficiency (+) [s1]
- Maintainability (-) [s1, s13, s16]
- Scalability (+) [s1, s2, s3, s7, s11, s12, s13, s15]
- Online support (++) [s2, s9, s10, s11, s12, s13, s19]
- Offline support (++) [s2, s9, s10, s11, s12, s13, s19]
- Loose coupling (+) [s2, s7, s16, s19]
- Robustness (++) [s10]
- Modularity (+) [s7, s10, s16, s19]
- React to user event and interactions (+) [s12]
- Variety of machine learning algorithm choices (--) [s11, s12, s19]
- Data throughput (o) [s2, s9, s12, s15]

#### Solution 5: Precompute serving
**Evidences:** s1, s19

**Forces:**
- Near real-time support (-) [s1, s2, s10, s11, s12, s13, s15, s19]
- Efficiency (-) [s1]
- Maintainability (-) [s1, s13, s16]
- Scalability (--) [s1, s2, s3, s7, s11, s12, s13, s15]
- Online support (-) [s2, s9, s10, s11, s12, s13, s19]
- Offline support (+) [s2, s9, s10, s11, s12, s13, s19]
- Loose coupling (-) [s2, s7, s16, s19]
- Robustness (o) [s10]
- Modularity (--) [s7, s10, s16, s19]
- React to user event and interactions (--) [s12]
- Variety of machine learning algorithm choices (+) [s11, s12, s19]
- Data throughput (+) [s2, s9, s12, s15]

#### **Next Decision**: How to persist and provide access to features?
#### **Next Decision**: How to inform clients about prediction result availability?
#### **Next Decision**: How to ingest data into ML projects or applications?


## Decision: How to inform clients about prediction result availability?
**Evidences:** s2

**Context:** Machine Learning Model and Application

### **Solution Options**
#### Solution 1: Push notification
**Evidences:** s2

**Forces:**
- Immediate result notification (+) [s2]
- Non-blocking clients (+) [s2]
- Clients must follow asynchronous programming model (-) [s2]

#### Solution 2: Polling
**Evidences:** s2

**Forces:**
- Immediate result notification (-) [s2]
- Non-blocking clients (+) [s2]
- Clients must follow asynchronous programming model (+) [s2]

#### Solution 3: Block on result
**Evidences:** s2

**Forces:**
- Immediate result notification (--) [s2]
- Non-blocking clients (--) [s2]
- Clients must follow asynchronous programming model (+) [s2]



## Decision: How to ingest data into ML projects or applications?
**Evidences:** s2, s4, s5, s6, s7, s8, s9, s10, s11, s12, s13, s14, s15, s17, s18, s19, s35

**Context:** Machine Learning Model and Application

### **Solution Options**
#### Solution 1: Streamed data ingestion
**Evidences:** s2, s4, s5, s7, s9, s11, s13, s14, s15, s19, s35

**Forces:**
- Online support (+) [s2, s6, s9, s10, s11, s12, s13, s19]
- Offline support (-) [s2, s6, s9, s10, s11, s12, s13, s19]
- Data throughput (+) [s2, s4, s6, s9, s12, s15]
- Low latency (++) [s2, s4, s6, s15, s35]
- Near real-time support (++) [s2, s4, s6, s10, s11, s12, s13, s15, s19, s35]
- Tool development effort (-) [s2, s10, s17]

#### Solution 2: Data ingestion by request
**Evidences:** s2, s4, s5, s9, s13, s14, s15, s19

**Forces:**
- Online support (o) [s2, s6, s9, s10, s11, s12, s13, s19]
- Offline support (+) [s2, s6, s9, s10, s11, s12, s13, s19]
- Data throughput (o) [s2, s4, s6, s9, s12, s15]
- Low latency (o) [s2, s4, s6, s15, s35]
- Near real-time support (+) [s2, s4, s6, s10, s11, s12, s13, s15, s19, s35]
- Tool development effort (-) [s2, s10, s17]

#### Solution 3: Data ingestion in batches
**Evidences:** s4, s5, s13, s14, s15, s19

**Forces:**
- Online support (-) [s2, s6, s9, s10, s11, s12, s13, s19]
- Offline support (o) [s2, s6, s9, s10, s11, s12, s13, s19]
- Data throughput (++) [s2, s4, s6, s9, s12, s15]
- Low latency (-) [s2, s4, s6, s15, s35]
- Near real-time support (--) [s2, s4, s6, s10, s11, s12, s13, s15, s19, s35]
- Tool development effort (-) [s2, s10, s17]

#### Solution 4: Manual data ingestion
**Evidences:** s4, s5, s6

**Forces:**
- Online support (--) [s2, s6, s9, s10, s11, s12, s13, s19]
- Offline support (-) [s2, s6, s9, s10, s11, s12, s13, s19]
- Data throughput (--) [s2, s4, s6, s9, s12, s15]
- Low latency (--) [s2, s4, s6, s15, s35]
- Near real-time support (--) [s2, s4, s6, s10, s11, s12, s13, s15, s19, s35]
- Tool development effort (+) [s2, s10, s17]

#### **Next Decision**: Should MLOps be applied and, if so, when?


## Decision: How to automate integration and delivery in a machine learning context?
**Evidences:** s1, s2, s4, s6, s8, s9, s10, s13, s14, s19, s20, s21, s22, s25, s28, s29, s31, s32, s33

**Context:** Machine Learning Model and Application

### **Solution Options**
#### Solution 1: No integration or delivery automation
**Evidences:** s1, s6, s20

**Forces:**
- Process and work automation (--) [s1, s8, s20, s22]
- Iterative development (-) [s1, s4, s22]
- Development velocity (-) [s19, s25, s29, s31]
- Deployment velocity (--) [s25, s29]
- Dependable releases (--) [s20]
- Reliability (--) [s2, s8, s10]
- Independent development (-) [s1, s4, s6, s19]
- Modifiability (--) [s6, s8, s33]
- Reproducibility (--) [s6, s8, s13, s20, s21, s22, s25, s28, s29, s31, s33]
- Testability (-) [s8, s28]
- Auditability (--) [s8, s25, s33]
- Continuous improvement (--) [s8, s21]

#### Solution 2: Build and deployment scripts
**Evidences:** s1, s9, s10

**Forces:**
- Process and work automation (+) [s1, s8, s20, s22]
- Iterative development (+) [s1, s4, s22]
- Development velocity (+) [s19, s25, s29, s31]
- Deployment velocity (++) [s25, s29]
- Dependable releases (-) [s20]
- Reliability (-) [s2, s8, s10]
- Reproducibility (+) [s6, s8, s13, s20, s21, s22, s25, s28, s29, s31, s33]
- Independent development (o) [s1, s4, s6, s19]
- Modifiability (-) [s6, s8, s33]
- Testability (o) [s8, s28]
- Auditability (-) [s8, s25, s33]
- Continuous improvement (-) [s8, s21]

#### Solution 3: CI/CD pipeline
**Evidences:** s1, s2, s4, s6, s8, s9, s10, s13, s20, s25, s31, s32, s33

**Forces:**
- Process and work automation (++) [s1, s8, s20, s22]
- Iterative development (++) [s1, s4, s22]
- Development velocity (++) [s19, s25, s29, s31]
- Deployment velocity (++) [s25, s29]
- Dependable releases (++) [s20]
- Reliability (+) [s2, s8, s10]
- Independent development (+) [s1, s4, s6, s19]
- Modifiability (++) [s6, s8, s33]
- Reproducibility (++) [s6, s8, s13, s20, s21, s22, s25, s28, s29, s31, s33]
- Testability (++) [s8, s28]
- Auditability (++) [s8, s25, s33]
- Continuous improvement (++) [s8, s21]

#### Solution 4: Machine learning orchestrator
**Evidences:** s4, s6, s8, s9, s14, s21, s29

**Forces:**
- Process and work automation (+) [s1, s8, s20, s22]
- Ability to identify whether data has changed over time (+) [s20, s25]

#### **Next Decision**: Which model versions should be deployed and how?
#### **Next Decision**: How to version data?
#### **Next Decision**: How to trigger a machine learning pipeline or orchestrator?
#### **Next Decision**: Should MLOps be applied and, if so, when?


## Decision: Which tasks can be performed by a delivery pipeline or component?
**Evidences:** s2, s4, s5, s6, s7, s8, s9, s11, s13, s17, s18, s19, s20, s21, s22, s23, s24, s25, s26, s28, s31, s32, s33, s34

**Context:** Machine Learning Model and Application

### **Solution Options**
#### Solution 1: Packaging
**Evidences:** s2, s4, s6, s25


#### Solution 2: Testing
**Evidences:** s2, s4, s5, s6, s31, s33, s34


#### Solution 3: Building
**Evidences:** s4, s6, s8


#### Solution 4: Deployment
**Evidences:** s4, s6, s8, s13, s17, s18, s19, s20, s23, s24, s25


#### Solution 5: Containerization
**Evidences:** s4, s7, s8, s9, s11, s19


#### **Next Decision**: Should MLOps be applied and, if so, when?


## Decision: Which model versions should be deployed and how?
**Evidences:** s2, s4, s6, s9, s13, s20, s22, s25

**Context:** Machine Learning Model and Application

### **Solution Options**
#### Solution 1: Single model in production
**Evidences:** s2, s6, s13

**Forces:**
- Safe transition between production models (--) [s2, s6]
- Rolling upgrades (--) [s4, s6]

#### Solution 2: N versions in production
**Evidences:** s2, s4, s6, s9, s20, s25

**Forces:**
- Safe transition between production models (++) [s2, s6]
- Rolling upgrades (++) [s4, s6]
- Shadow mode testing (++) [s6, s20, s25]

#### Solution 3: Rollback to previous model version
**Evidences:** s4, s6

**Forces:**
- Safe transition between production models (+) [s2, s6]
- Rolling upgrades (+) [s4, s6]

#### **Next Decision**: Should MLOps be applied and, if so, when?


## Decision: How to version data?
**Evidences:** s4, s8, s20, s21, s22, s25, s30, s31

**Context:** Machine Learning Model and Application

### **Solution Options**
#### Solution 1: No data versioning
**Evidences:** s4, s21, s22, s30, s31

**Forces:**
- Handling large data files (-) [s30, s31]
- Reproducibility (--) [s8, s20, s21, s22, s25, s30, s31]

#### Solution 2: Data version repository
**Evidences:** s4, s8, s20, s22, s25, s30, s31

**Forces:**
- Handling large data files (++) [s30, s31]
- Reproducibility (++) [s8, s20, s21, s22, s25, s30, s31]
- Development velocity (++) [s25, s30, s31]

#### Solution 3: Data versioning in code repository
**Evidences:** s4, s22, s30, s31

**Forces:**
- Handling large data files (--) [s30, s31]
- Reproducibility (--) [s8, s20, s21, s22, s25, s30, s31]
- Development velocity (--) [s25, s30, s31]
- Flexibility (--) [s30, s31]

#### **Next Decision**: Should MLOps be applied and, if so, when?


## Decision: How to trigger a machine learning pipeline or orchestrator?
**Evidences:** s1, s2, s4, s6, s8, s9, s12, s14, s19, s20, s21, s22, s23, s25, s33

**Context:** Machine Learning Model and Application

### **Solution Options**
#### Solution 1: On-demand trigger
**Evidences:** s2, s4, s6, s9, s12, s21, s22


#### Solution 2: On commit trigger
**Evidences:** s4, s8, s22, s25


#### Solution 3: On schedule trigger
**Evidences:** s1, s2, s6, s9, s12, s14, s21, s22, s33


#### Solution 4: On availability of new training data trigger
**Evidences:** s6, s21, s22


#### Solution 5: On model performance degradation trigger
**Evidences:** s6, s19, s21, s23


#### Solution 6: On changes in the data distribution trigger
**Evidences:** s6, s21, s22


#### **Next Decision**: Should MLOps be applied and, if so, when?


## Decision: How to automatically provision environments?
**Evidences:** s1, s6, s7, s8, s13, s14, s21

**Context:** Machine Learning Model and Application

### **Solution Options**
#### Solution 1: No automated provisioning
**Evidences:** s1, s6, s13

**Forces:**
- Process and work automation (-) [s1, s8]
- Independence of provisioning (--) [s7]
- Auto-scaling (--) [s7]
- Scalability (-) [s1, s7, s13]

#### Solution 2: Automated provisioning
**Evidences:** s1, s6, s7, s8, s13, s14

**Forces:**
- Process and work automation (++) [s1, s8]
- Independence of provisioning (++) [s7]
- Auto-scaling (++) [s7]
- Scalability (++) [s1, s7, s13]

#### **Next Decision**: Should MLOps be applied and, if so, when?


## Decision: How to automatically process the data used for model building?
**Evidences:** s1, s2, s4, s5, s6, s8, s9, s10, s13, s14, s15, s16, s17, s18, s19, s21, s33

**Context:** Machine Learning Model and Application

### **Solution Options**
#### Solution 1: No data processing automation
**Evidences:** s1, s6, s13

**Forces:**
- Automated data collection (--) [s1]
- Process and work automation (-) [s1, s8, s15, s18]
- Iterative development (-) [s1, s4]
- Reproducibility (--) [s6, s8, s13, s17, s21, s33]
- Tool development effort (+) [s1, s2, s10, s17]

#### Solution 2: Data pipeline
**Evidences:** s1, s2, s4, s5, s6, s8, s9, s13, s14, s15, s16, s17, s18, s19, s33

**Forces:**
- Automated data collection (++) [s1]
- Process and work automation (++) [s1, s8, s15, s18]
- Iterative development (+) [s1, s4]
- Reproducibility (+) [s6, s8, s13, s17, s21, s33]
- Tool development effort (-) [s1, s2, s10, s17]

#### Solution 3: ETL pipeline
**Evidences:** s4, s5, s9, s13, s15

**Forces:**
- Automated data collection (+) [s1]
- Process and work automation (+) [s1, s8, s15, s18]
- Iterative development (o) [s1, s4]
- Reproducibility (+) [s6, s8, s13, s17, s21, s33]
- Tool development effort (-) [s1, s2, s10, s17]

#### Solution 4: Data processing component
**Evidences:** s9, s13, s14

**Forces:**
- Automated data collection (+) [s1]
- Process and work automation (+) [s1, s8, s15, s18]
- Iterative development (-) [s1, s4]
- Reproducibility (o) [s6, s8, s13, s17, s21, s33]
- Tool development effort (-) [s1, s2, s10, s17]

#### **Next Decision**: How to persist and provide access to features?
#### **Next Decision**: How to ingest data into ML projects or applications?
#### **Next Decision**: How to parallelize data processing?
#### **Next Decision**: Should MLOps be applied and, if so, when?


## Decision: Should data be processed in batches or in realtime?
**Evidences:** s1, s2, s4, s5, s6, s8, s9, s10, s13, s15, s35

**Context:** Machine Learning Model and Application

### **Solution Options**
#### Solution 1: Batch-based data processing
**Evidences:** s1, s2, s5, s6, s8, s10, s13, s15

**Forces:**
- Reliability (++) [s2, s5, s8, s10]
- Data throughput (++) [s2, s4, s6, s9, s15]
- Low latency (-) [s2, s4, s6, s15, s35]
- Near real-time support (--) [s1, s2, s4, s6, s10, s13, s15, s35]
- Online support (-) [s2, s6, s9, s10, s13]
- Offline support (+) [s2, s6, s9, s10, s13]

#### Solution 2: Real-time, stream-based data processing
**Evidences:** s1, s2, s4, s5, s6, s8, s9, s10, s13, s15, s35

**Forces:**
- Reliability (+) [s2, s5, s8, s10]
- Data throughput (+) [s2, s4, s6, s9, s15]
- Low latency (++) [s2, s4, s6, s15, s35]
- Near real-time support (++) [s1, s2, s4, s6, s10, s13, s15, s35]
- Online support (++) [s2, s6, s9, s10, s13]
- Offline support (o) [s2, s6, s9, s10, s13]

#### **Next Decision**: Should MLOps be applied and, if so, when?


## Decision: Which data processing tasks can be performed by a data processing pipeline or component?
**Evidences:** s1, s2, s4, s5, s6, s8, s9, s10, s11, s13, s14, s15, s17, s18, s19, s20, s21, s23, s24, s25, s33, s35

**Context:** Machine Learning Model and Application

### **Solution Options**
#### Solution 1: Data extraction
**Evidences:** s1, s2, s6, s8, s13, s14, s15


#### Solution 2: Data transformation
**Evidences:** s2, s5, s6, s10, s13, s14, s15, s19, s33


#### Solution 3: Data preparation
**Evidences:** s1, s2, s4, s5, s6, s9, s10, s11, s13, s14, s15, s17, s18, s19, s20, s23, s24, s25, s33


#### Solution 4: Data validation
**Evidences:** s6, s9, s13, s19, s20, s24, s33


#### Solution 5: Data selection
**Evidences:** s2, s6, s14


#### Solution 6: Feature engineering
**Evidences:** s1, s2, s4, s5, s6, s8, s9, s10, s13, s14, s15, s17, s18, s19, s23, s25, s33


#### Solution 7: Data processing hyperparameter tuning
**Evidences:** s9, s11, s17, s18, s35


#### **Next Decision**: Should AutoML be applied and, if so, where?
#### **Next Decision**: Should MLOps be applied and, if so, when?


## Decision: How to parallelize data processing?
**Evidences:** s2, s9, s21, s35

**Context:** Machine Learning Model and Application

### **Solution Options**
#### Solution 1: No parallel data processing
**Evidences:** s2, s9, s35

**Forces:**
- Data throughput (--) [s2, s9]
- Speed performance (--) [s2, s9]
- Low latency (-) [s2, s35]
- Independent processing (--) [s2]

#### Solution 2: Data pipeline per data set
**Evidences:** s2

**Forces:**
- Data throughput (+) [s2, s9]
- Speed performance (+) [s2, s9]
- Low latency (+) [s2, s35]
- Independent processing (++) [s2]

#### Solution 3: Data partitioning in data pipeline
**Evidences:** s2, s9, s35

**Forces:**
- Data throughput (+) [s2, s9]
- Speed performance (+) [s2, s9]
- Low latency (+) [s2, s35]
- Independent processing (o) [s2]

#### Solution 4: Hybrid data processing parallelization
**Evidences:** s2, s9

**Forces:**
- Data throughput (++) [s2, s9]
- Speed performance (++) [s2, s9]
- Low latency (++) [s2, s35]
- Independent processing (++) [s2]

#### **Next Decision**: Should MLOps be applied and, if so, when?


## Decision: How to perform model building in an ML project?
**Evidences:** s2, s4, s6, s8, s9, s10, s11, s13, s14, s15, s17, s19, s25, s33

**Context:** Machine Learning Model and Application

### **Solution Options**
#### Solution 1: Model building in development tool
**Evidences:** s2, s4, s6, s10, s13, s15

**Forces:**
- Interchangeability of machine learning algorithms (-) [s2]
- Interactive prototyping (+) [s2, s13]
- Low latency (--) [s2, s4, s6, s15]
- Loose coupling (-) [s2, s6, s19]
- Scalability (--) [s2, s4, s11, s13, s15]
- Iterative development (+) [s4]
- Production-ready development (-) [s4, s13, s19]
- Experimental operational symmetry (-) [s6, s13]
- Reproducibility (-) [s6, s8, s13, s17, s25, s33]
- Development agility (-) [s10, s13, s17]
- Flexibility (-) [s10]
- Tool development effort (+) [s2, s10, s17]

#### Solution 2: Model building pipeline
**Evidences:** s2, s4, s6, s8, s9, s10, s13, s14, s17, s19, s25, s33

**Forces:**
- Interchangeability of machine learning algorithms (+) [s2]
- Interactive prototyping (-) [s2, s13]
- Low latency (+) [s2, s4, s6, s15]
- Loose coupling (++) [s2, s6, s19]
- Scalability (+) [s2, s4, s11, s13, s15]
- Iterative development (o) [s4]
- Production-ready development (+) [s4, s13, s19]
- Experimental operational symmetry (+) [s6, s13]
- Reproducibility (+) [s6, s8, s13, s17, s25, s33]
- Development agility (+) [s10, s13, s17]
- Flexibility (+) [s10]
- Tool development effort (-) [s2, s10, s17]

#### Solution 3: Model builder component
**Evidences:** s9, s11, s13, s14

**Forces:**
- Interchangeability of machine learning algorithms (+) [s2]
- Interactive prototyping (-) [s2, s13]
- Low latency (+) [s2, s4, s6, s15]
- Loose coupling (o) [s2, s6, s19]
- Scalability (o) [s2, s4, s11, s13, s15]
- Iterative development (o) [s4]
- Production-ready development (o) [s4, s13, s19]
- Experimental operational symmetry (+) [s6, s13]
- Reproducibility (o) [s6, s8, s13, s17, s25, s33]
- Development agility (o) [s10, s13, s17]
- Flexibility (-) [s10]
- Tool development effort (-) [s2, s10, s17]

#### **Next Decision**: How to automatically process the data used for model building?
#### **Next Decision**: How to persist and provide access to features?
#### **Next Decision**: How to trigger a machine learning pipeline or orchestrator?
#### **Next Decision**: How to parallelize model building?
#### **Next Decision**: Should MLOps be applied and, if so, when?


## Decision: When and how to train the model?
**Evidences:** s2, s4, s6, s10, s11, s12, s18, s19, s20, s25, s35

**Context:** Machine Learning Model and Application

### **Solution Options**
#### Solution 1: Batch-based learning
**Evidences:** s2, s6, s10, s11, s12, s19

**Forces:**
- React to unforeseen changes in the data (--) [s11, s19]
- Memory requirements (--) [s11]
- Handling massive amounts of data (++) [s11, s12, s35]
- Online support (-) [s2, s6, s10, s11, s12, s19]
- Offline support (+) [s2, s6, s10, s11, s12, s19]
- Speed performance (--) [s2, s4, s6, s10, s11]
- Near real-time support (-) [s2, s4, s6, s10, s11, s12, s19, s35]
- Scalability (+) [s2, s4, s11, s12]
- Variety of machine learning algorithm choices (++) [s11, s12, s19]

#### Solution 2: Incremental learning
**Evidences:** s6, s10, s11, s12, s19

**Forces:**
- React to unforeseen changes in the data (++) [s11, s19]
- Memory requirements (++) [s11]
- Handling massive amounts of data (--) [s11, s12, s35]
- Online support (+) [s2, s6, s10, s11, s12, s19]
- Offline support (-) [s2, s6, s10, s11, s12, s19]
- Speed performance (+) [s2, s4, s6, s10, s11]
- Near real-time support (+) [s2, s4, s6, s10, s11, s12, s19, s35]
- Scalability (-) [s2, s4, s11, s12]
- Variety of machine learning algorithm choices (-) [s11, s12, s19]

#### Solution 3: Hybrid batch-based and incremental learning
**Evidences:** s12, s19

**Forces:**
- React to unforeseen changes in the data (+) [s11, s19]
- Memory requirements (+) [s11]
- Handling massive amounts of data (+) [s11, s12, s35]
- Online support (+) [s2, s6, s10, s11, s12, s19]
- Offline support (+) [s2, s6, s10, s11, s12, s19]
- Speed performance (o) [s2, s4, s6, s10, s11]
- Near real-time support (o) [s2, s4, s6, s10, s11, s12, s19, s35]
- Scalability (+) [s2, s4, s11, s12]
- Variety of machine learning algorithm choices (--) [s11, s12, s19]

#### Solution 4: Ensemble learning
**Evidences:** s4, s18, s19, s25, s35

**Forces:**
- Error reduction (+) [s35]

#### **Next Decision**: Should MLOps be applied and, if so, when?


## Decision: Which tasks can be performed by a model building pipeline or component?
**Evidences:** s1, s2, s4, s5, s6, s7, s8, s9, s10, s11, s12, s13, s14, s15, s17, s18, s19, s20, s21, s23, s24, s25, s31, s33, s35

**Context:** Machine Learning Model and Application

### **Solution Options**
#### Solution 1: Model training
**Evidences:** s1, s2, s4, s5, s6, s7, s8, s9, s10, s11, s12, s13, s14, s15, s17, s18, s19, s20, s23, s24, s25, s33, s35


#### Solution 2: Data splitting
**Evidences:** s2, s4, s8, s9, s14, s19, s31


#### Solution 3: Data checkpoints
**Evidences:** s2


#### Solution 4: Model validation
**Evidences:** s4, s6, s8, s9, s10, s13, s14, s17, s18, s19, s20, s25, s31, s33

**Forces:**
- Auditability (++) [s8, s25, s33]
- Maintainability (++) [s1, s5, s6, s13, s23, s33]
- Explainability (++) [s17, s21, s25, s33]
- Align models with business needs (++) [s21, s23, s33]
- Align models with regulatory requirements (++) [s21, s23, s25, s33]
- Demonstrability (++) [s33]

#### Solution 5: Model selection
**Evidences:** s2, s4, s9, s11, s14, s17, s18, s19, s31


#### Solution 6: Train multiple model versions with different parameters and/or algorithms
**Evidences:** s2, s4, s6, s8, s9, s11, s19


#### Solution 7: Model packaging
**Evidences:** s9, s19, s21, s25


#### Solution 8: Model hyperparameter tuning
**Evidences:** s2, s6, s9, s11, s17, s18, s19, s24, s25, s35


#### Solution 9: Development tool facade
**Evidences:** s2, s4, s6


#### Solution 10: Development tool export
**Evidences:** s10, s15


#### **Next Decision**: Should AutoML be applied and, if so, where?
#### **Next Decision**: Should MLOps be applied and, if so, when?


## Decision: How to parallelize model building?
**Evidences:** s2, s4, s6, s9, s21, s35

**Context:** Machine Learning Model and Application

### **Solution Options**
#### Solution 1: No parallel model building
**Evidences:** s2, s6, s9

**Forces:**
- Speed performance (--) [s2, s4, s6, s9]
- Low latency (-) [s2, s4, s6, s35]

#### Solution 2: Model building pipeline per model
**Evidences:** s2, s4, s6, s9

**Forces:**
- Speed performance (+) [s2, s4, s6, s9]
- Low latency (+) [s2, s4, s6, s35]

#### Solution 3: Training data partitioning
**Evidences:** s2, s35

**Forces:**
- Speed performance (+) [s2, s4, s6, s9]
- Low latency (+) [s2, s4, s6, s35]
- Handling massive amounts of data (+) [s35]
- Near real-time support (+) [s2, s4, s6, s35]

#### Solution 4: Model partitioning
**Evidences:** s2, s4

**Forces:**
- Speed performance (+) [s2, s4, s6, s9]
- Low latency (+) [s2, s4, s6, s35]

#### Solution 5: Hybrid model building parallelization
**Evidences:** s2, s4, s9

**Forces:**
- Speed performance (++) [s2, s4, s6, s9]
- Low latency (++) [s2, s4, s6, s35]

#### **Next Decision**: Should MLOps be applied and, if so, when?


## Decision: How to monitor and track the model in production?
**Evidences:** s1, s2, s3, s4, s6, s8, s9, s10, s11, s13, s14, s17, s18, s19, s20, s23, s24, s25, s34

**Context:** Machine Learning Model and Application

### **Solution Options**
#### Solution 1: No in-production monitoring
**Evidences:** s1, s2, s6, s23, s24

**Forces:**
- Speed performance (-) [s2, s3, s4, s6, s9, s10, s11, s34]
- Model accuracy (-) [s2, s3, s4, s6, s9, s10, s14, s17, s18, s19, s34]
- Continuous model improvement (--) [s3, s4, s8]
- Observability (--) [s4, s8, s19]
- Avoid training/serving skew (-) [s6, s8]
- Identify potential bias or overfit (--) [s8]
- Robustness (--) [s10, s23]
- Debugging support (--) [s10]
- Successful model operation (-) [s23]
- Model stability (-) [s23]
- Model performance (-) [s23]
- Align models with business needs (-) [s23, s34]
- Align models with regulatory requirements (-) [s23, s25]
- Maintainability (-) [s1, s6, s13, s23, s34]
- Reduce cost (-) [s23, s34]
- Reliability (-) [s2, s8, s10, s23]
- Valuable models (-) [s23]
- Incident detection (-) [s23]
- Incident resolution (-) [s23]
- Fresh models (-) [s23]
- Risk mitigation (-) [s23]
- Ability to identify whether data has changed over time (-) [s20, s24, s25]
- Ability to recognise model degradation (-) [s20, s24]
- Ability to address model degradation (-) [s20, s24]

#### Solution 2: Model performance monitoring
**Evidences:** s1, s2, s3, s6, s8, s9, s13, s14, s17, s18, s19, s20, s23, s24, s25, s34

**Forces:**
- Speed performance (+) [s2, s3, s4, s6, s9, s10, s11, s34]
- Model accuracy (+) [s2, s3, s4, s6, s9, s10, s14, s17, s18, s19, s34]
- Continuous model improvement (++) [s3, s4, s8]
- Observability (++) [s4, s8, s19]
- Avoid training/serving skew (o) [s6, s8]
- Identify potential bias or overfit (+) [s8]
- Robustness (o) [s10, s23]
- Debugging support (o) [s10]
- Successful model operation (+) [s23]
- Model stability (+) [s23]
- Model performance (+) [s23]
- Align models with business needs (+) [s23, s34]
- Align models with regulatory requirements (+) [s23, s25]
- Maintainability (+) [s1, s6, s13, s23, s34]
- Reduce cost (+) [s23, s34]
- Reliability (+) [s2, s8, s10, s23]
- Valuable models (+) [s23]
- Incident detection (+) [s23]
- Incident resolution (+) [s23]
- Fresh models (+) [s23]
- Risk mitigation (+) [s23]
- Ability to identify whether data has changed over time (+) [s20, s24, s25]
- Ability to recognise model degradation (+) [s20, s24]
- Ability to address model degradation (+) [s20, s24]

#### Solution 3: Monitoring or logging data and predictions
**Evidences:** s10, s11, s23, s25

**Forces:**
- Speed performance (o) [s2, s3, s4, s6, s9, s10, s11, s34]
- Model accuracy (o) [s2, s3, s4, s6, s9, s10, s14, s17, s18, s19, s34]
- Continuous model improvement (+) [s3, s4, s8]
- Observability (+) [s4, s8, s19]
- Avoid training/serving skew (o) [s6, s8]
- Identify potential bias or overfit (o) [s8]
- Robustness (++) [s10, s23]
- Debugging support (++) [s10]
- Successful model operation (+) [s23]
- Model stability (+) [s23]
- Model performance (+) [s23]
- Align models with business needs (+) [s23, s34]
- Align models with regulatory requirements (+) [s23, s25]
- Maintainability (+) [s1, s6, s13, s23, s34]
- Reduce cost (+) [s23, s34]
- Reliability (+) [s2, s8, s10, s23]
- Valuable models (+) [s23]
- Incident detection (+) [s23]
- Incident resolution (+) [s23]
- Fresh models (+) [s23]
- Risk mitigation (+) [s23]

#### Solution 4: Model in-production tracking
**Evidences:** s8, s23

**Forces:**
- Speed performance (o) [s2, s3, s4, s6, s9, s10, s11, s34]
- Model accuracy (+) [s2, s3, s4, s6, s9, s10, s14, s17, s18, s19, s34]
- Continuous model improvement (++) [s3, s4, s8]
- Observability (++) [s4, s8, s19]
- Avoid training/serving skew (++) [s6, s8]
- Identify potential bias or overfit (++) [s8]
- Robustness (+) [s10, s23]
- Debugging support (+) [s10]
- Successful model operation (+) [s23]
- Model stability (+) [s23]
- Model performance (+) [s23]
- Align models with business needs (+) [s23, s34]
- Align models with regulatory requirements (+) [s23, s25]
- Maintainability (+) [s1, s6, s13, s23, s34]
- Reduce cost (+) [s23, s34]
- Reliability (+) [s2, s8, s10, s23]
- Valuable models (+) [s23]
- Incident detection (+) [s23]
- Incident resolution (+) [s23]
- Fresh models (+) [s23]
- Risk mitigation (+) [s23]

#### **Next Decision**: How to adjust models based on monitoring results?
#### **Next Decision**: Should MLOps be applied and, if so, when?


## Decision: Should AutoML be applied and, if so, where?
**Evidences:** s4, s6, s9, s10, s17, s18, s19, s22, s23

**Context:** 

### **Solution Options**
#### Solution 1: No AutoML
**Evidences:** s4, s6, s9, s10, s17, s18, s19, s22, s23

**Forces:**
- Reproducibility (o) [s6, s17, s22]
- Explainability (o) [s17]
- Development velocity (o) [s17, s18, s19]
- Development agility (o) [s10, s17]
- Tool development effort (o) [s10, s17]
- Process and work automation (o) [s18, s22]
- Production-ready development (+) [s4, s18, s19]

#### Solution 2: AutoML
**Evidences:** s4, s6, s9, s10, s17, s18, s19, s22, s23

**Forces:**
- Reproducibility (+) [s6, s17, s22]
- Explainability (+) [s17]
- Development velocity (+) [s17, s18, s19]
- Development agility (+) [s10, s17]
- Tool development effort (o) [s10, s17]
- Process and work automation (+) [s18, s22]
- Production-ready development (-) [s4, s18, s19]



## Decision: How to adjust models based on monitoring results?
**Evidences:** s1, s2, s4, s6, s8, s19, s21, s23, s25

**Context:** Machine Learning Model and Application

### **Solution Options**
#### Solution 1: Manual model adjustment
**Evidences:** s1, s2, s6, s8, s19, s23


#### Solution 2: Automated model adjustment
**Evidences:** s1, s2, s4, s6, s8, s19, s23, s25


#### **Next Decision**: Should MLOps be applied and, if so, when?


## Decision: How to approach deployment of machine learning models?
**Evidences:** s1, s2, s3, s4, s6, s15, s16, s19, s20, s21, s23, s25, s26, s27, s28, s35

**Context:** Machine Learning Model and Application

### **Solution Options**
#### Solution 1: No automated deployment
**Evidences:** s1, s2, s3, s4, s6, s15, s16, s26, s27, s28, s35

**Forces:**
- Process and work automation (--) [s1, s15, s20]
- Iterative development (-) [s1, s4]
- Observability (--) [s4, s19]

#### Solution 2: Build, test, and deploy models to be served and other system components in a semi-automated fashion by deploying pre-prepared pipelines
**Evidences:** s1, s2, s4, s6, s19, s20

**Forces:**
- Process and work automation (+) [s1, s15, s20]
- Iterative development (+) [s1, s4]
- Observability (++) [s4, s19]

#### Solution 3: Build, test, and deploy machine learning models based on CI/CD pipeline automation
**Evidences:** s1, s2, s6, s19, s20, s25

**Forces:**
- Process and work automation (++) [s1, s15, s20]
- Iterative development (++) [s1, s4]
- Observability (++) [s4, s19]

#### **Next Decision**: How to automate integration and delivery in a machine learning context?
#### **Next Decision**: Should MLOps be applied and, if so, when?


## Decision: What to test in a machine learning pipeline?
**Evidences:** s1, s4, s5, s6, s8, s9, s10, s11, s13, s19, s20, s21, s22, s23, s25, s31, s32, s33, s34

**Context:** Machine Learning Model and Application

### **Solution Options**
#### Solution 1: No testing
**Evidences:** s6, s13, s25, s31, s33, s34


#### Solution 2: Unit testing system components
**Evidences:** s4, s6, s13, s33

**Forces:**
- Code quality (++) [s33]
- Debugging support (++) [s10, s33]
- Maintainability (++) [s1, s5, s6, s13, s23, s33, s34]
- Explainability (+) [s21, s25, s33]

#### Solution 3: System integration testing
**Evidences:** s4, s6, s8, s13, s33

**Forces:**
- Model consistency (++) [s21, s25, s33]
- Reproducibility (++) [s6, s8, s13, s20, s21, s22, s25, s31, s33]
- Modifiability (++) [s5, s6, s8, s33]
- Data usability (++) [s33]

#### Solution 4: A/B testing
**Evidences:** s4, s6, s9, s11, s13, s20, s22, s23, s25, s31


#### Solution 5: Canary testing
**Evidences:** s4, s6, s9


#### Solution 6: Hypothesis testing
**Evidences:** s13, s31, s32, s33


#### Solution 7: Unit testing feature engineering logic
**Evidences:** s6, s13, s33

**Forces:**
- Code quality (++) [s33]
- Debugging support (++) [s10, s33]
- Maintainability (++) [s1, s5, s6, s13, s23, s33, s34]
- Explainability (+) [s21, s25, s33]

#### Solution 8: Unit testing different methods implemented in a model
**Evidences:** s6, s13, s33

**Forces:**
- Code quality (++) [s33]
- Debugging support (++) [s10, s33]
- Maintainability (++) [s1, s5, s6, s13, s23, s33, s34]
- Explainability (+) [s21, s25, s33]

#### Solution 9: Testing model training converges
**Evidences:** s4, s5, s6, s33


#### Solution 10: Testing trained model quality
**Evidences:** s4, s5, s6, s9, s10, s13, s19, s31, s33


#### Solution 11: Unit testing pipeline components
**Evidences:** s1, s6, s33

**Forces:**
- Code quality (++) [s33]
- Debugging support (++) [s10, s33]
- Maintainability (++) [s1, s5, s6, s13, s23, s33, s34]
- Explainability (+) [s21, s25, s33]

#### Solution 12: Integration testing pipeline components
**Evidences:** s1, s6, s33

**Forces:**
- Model consistency (+) [s21, s25, s33]
- Reproducibility (++) [s6, s8, s13, s20, s21, s22, s25, s31, s33]
- Modifiability (+) [s5, s6, s8, s33]
- Data usability (+) [s33]

#### Solution 13: Prediction service API testing
**Evidences:** s6, s22, s34

**Forces:**
- Align models with business needs (+) [s21, s23, s33, s34]
- Speed performance (+) [s4, s5, s6, s9, s10, s11, s34]
- Model accuracy (+) [s4, s6, s9, s10, s19, s34]
- Maintainability (+) [s1, s5, s6, s13, s23, s33, s34]
- Reduce cost (+) [s21, s23, s34]

#### Solution 14: Prediction service performance testing
**Evidences:** s6, s22, s34

**Forces:**
- Align models with business needs (+) [s21, s23, s33, s34]
- Speed performance (++) [s4, s5, s6, s9, s10, s11, s34]
- Model accuracy (o) [s4, s6, s9, s10, s19, s34]
- Maintainability (o) [s1, s5, s6, s13, s23, s33, s34]
- Reduce cost (+) [s21, s23, s34]

#### **Next Decision**: Should MLOps be applied and, if so, when?


## Decision: Should MLOps be applied and, if so, when?
**Evidences:** s4, s6, s19, s20, s21, s22, s23, s25

**Context:** 

### **Solution Options**
#### Solution 1: No MLOps
**Evidences:** s4, s6, s19, s20, s21, s22, s25

**Forces:**
- Division of labour (o) [s4, s20]
- Process and work automation (o) [s20, s22]
- Reduced time to market (o) [s20, s21]
- Better user experience (o) [s20, s21]
- Better customer satisfaction (o) [s20]
- Higher quality of predictions (o) [s20, s21, s25]
- Ability to recognise model degradation (o) [s20]
- Ability to address model degradation (o) [s20]
- Reproducibility (o) [s6, s20, s21, s22, s25]
- Ability to identify whether data has changed over time (o) [s20, s25]
- Dependable releases (o) [s20]
- Improve model management (o) [s20, s21]
- Change tracking (o) [s20]
- Shadow mode testing (o) [s6, s20, s25]
- Simplified deployment (o) [s20, s21]
- Align models with business needs (o) [s21, s23]
- Align models with regulatory requirements (o) [s21, s23, s25]
- Explainability (o) [s21, s25]
- Reusability (o) [s19, s21, s25]
- Infrastructure costs (o) [s21]
- Development agility (o) [s21]
- Model consistency (o) [s21, s25]
- Unlock new sources of revenue (o) [s21]
- Save time (o) [s21]
- Reduce cost (o) [s21, s23]
- Management agility (o) [s21]
- Continuous improvement (o) [s21]
- Experimental operational symmetry (o) [s6, s21]
- Modularity (o) [s19, s21, s25]
- Rapid experimentation (o) [s21, s25]
- Reduce technical debt (o) [s22]
- Iterative development (o) [s4, s22]
- Development velocity (o) [s19, s25]
- Deployment velocity (o) [s25]
- Auditability (o) [s25]

#### Solution 2: MLOps
**Evidences:** s4, s6, s19, s20, s21, s22, s23, s25

**Forces:**
- Division of labour (+) [s4, s20]
- Process and work automation (+) [s20, s22]
- Reduced time to market (+) [s20, s21]
- Better user experience (+) [s20, s21]
- Better customer satisfaction (+) [s20]
- Higher quality of predictions (+) [s20, s21, s25]
- Ability to recognise model degradation (+) [s20]
- Ability to address model degradation (+) [s20]
- Reproducibility (+) [s6, s20, s21, s22, s25]
- Ability to identify whether data has changed over time (+) [s20, s25]
- Dependable releases (+) [s20]
- Improve model management (+) [s20, s21]
- Change tracking (+) [s20]
- Shadow mode testing (+) [s6, s20, s25]
- Simplified deployment (+) [s20, s21]
- Align models with business needs (+) [s21, s23]
- Align models with regulatory requirements (+) [s21, s23, s25]
- Explainability (+) [s21, s25]
- Reusability (+) [s19, s21, s25]
- Infrastructure costs (+) [s21]
- Development agility (+) [s21]
- Model consistency (+) [s21, s25]
- Unlock new sources of revenue (+) [s21]
- Save time (+) [s21]
- Reduce cost (+) [s21, s23]
- Management agility (+) [s21]
- Continuous improvement (+) [s21]
- Experimental operational symmetry (+) [s6, s21]
- Modularity (+) [s19, s21, s25]
- Rapid experimentation (+) [s21, s25]
- Reduce technical debt (+) [s22]
- Iterative development (+) [s4, s22]
- Development velocity (+) [s19, s25]
- Deployment velocity (+) [s25]
- Auditability (+) [s25]



# Forces: 
- Division of labour [s1, s3, s4, s5, s7, s20]
- Distributed development [s1, s4, s5]
- Independent development [s1, s3, s4, s5, s6, s7, s19]
- Iterative development [s1, s4, s22]
- Production-ready development [s4, s13, s16, s18, s19, s29]
- Development agility [s10, s13, s17, s21, s26, s27, s28]
- Automated data collection [s1]
- Process and work automation [s1, s8, s15, s18, s20, s22]
- Maintainability [s1, s5, s6, s13, s16, s23, s26, s29, s33, s34]
- Modifiability [s5, s6, s8, s33]
- Robustness [s10, s23]
- Encapsulation [s3]
- Separation of concerns [s3, s5]
- Model portability [s2]
- Interactive prototyping [s2, s13, s26, s27, s28]
- Unified data access [s1, s4, s12, s15]
- Computational load [s5]
- Development velocity [s5, s17, s18, s19, s25, s26, s29, s30, s31]
- Tool development effort [s1, s2, s10, s17, s29]
- Deployment velocity [s25, s29]
- Modularity [s7, s10, s16, s19, s21, s25]
- Reusability [s7, s13, s19, s21, s25, s26]
- Explainability [s17, s21, s25, s29, s33]
- Testability [s8, s28]
- Auditability [s8, s25, s33]
- Continuous improvement [s8, s21]
- Flexibility [s10, s26, s27, s30, s31]
- Handling massive amounts of data [s11, s12, s15, s35]
- Dependable releases [s20]
- Reproducibility [s6, s8, s13, s17, s20, s21, s22, s25, s26, s27, s28, s29, s30, s31, s33]
- Experimental operational symmetry [s6, s13, s21]
- Infrastructure costs [s5, s21]
- Scalability [s1, s2, s3, s4, s5, s7, s11, s12, s13, s15]
- Independence of provisioning [s7, s16]
- Auto-scaling [s7]
- Near real-time support [s1, s2, s4, s6, s10, s11, s12, s13, s15, s19, s35]
- Efficiency [s1, s4, s27]
- Data throughput [s2, s4, s6, s9, s12, s15]
- Independent processing [s2, s4, s16]
- Reliability [s2, s5, s8, s10, s23]
- Low latency [s2, s4, s6, s15, s16, s35]
- Loose coupling [s2, s5, s6, s7, s16, s19]
- Chatty data access API [s5]
- Data access flexibility [s5]
- Data consistency [s5]
- Avoid cold start problem for training data [s5]
- Handling large data files [s30, s31]
- Speed performance [s2, s3, s4, s5, s6, s9, s10, s11, s15, s34]
- Model accuracy [s2, s3, s4, s6, s9, s10, s14, s15, s17, s18, s19, s34]
- Continuous model improvement [s3, s4, s8]
- Observability [s4, s8, s12, s19]
- Debugging support [s10, s29, s33]
- Identify potential bias or overfit [s8]
- Offline support [s2, s6, s9, s10, s11, s12, s13, s19]
- Online support [s2, s6, s9, s10, s11, s12, s13, s19]
- Interchangeability of machine learning algorithms [s2]
- Feature reuse [s5, s6]
- Feature discovery [s5, s6]
- Avoid training/serving skew [s6, s8]
- Safe transition between production models [s2, s6]
- Rolling upgrades [s4, s6]
- React to unforeseen changes in the data [s11, s19]
- React to user event and interactions [s12]
- Memory requirements [s11]
- Variety of machine learning algorithm choices [s11, s12, s19]
- Reduced time to market [s20, s21, s29]
- Better user experience [s20, s21]
- Better customer satisfaction [s20]
- Higher quality of predictions [s20, s21, s25]
- Ability to recognise model degradation [s20, s24]
- Ability to address model degradation [s20, s24]
- Ability to identify whether data has changed over time [s20, s24, s25]
- Improve model management [s20, s21]
- Change tracking [s20, s26]
- Shadow mode testing [s6, s20, s25, s31]
- Simplified deployment [s20, s21, s29]
- Simplified model updates [s20]
- Improved client heterogeneity [s20]
- Improved support for numerous clients [s20]
- Facilitates testing in production [s20]
- Align models with business needs [s21, s23, s33, s34]
- Align models with regulatory requirements [s21, s23, s25, s33]
- Model consistency [s21, s25, s33]
- Unlock new sources of revenue [s21]
- Save time [s21]
- Reduce cost [s21, s23, s34]
- Management agility [s21]
- Rapid experimentation [s21, s25, s26]
- Reduce technical debt [s22, s26, s29]
- Successful model operation [s23]
- Model stability [s23]
- Model performance [s23, s29]
- Valuable models [s23]
- Incident detection [s23]
- Incident resolution [s23]
- Fresh models [s23]
- Risk mitigation [s23]
- Demonstrability [s26, s27, s28, s29, s33]
- Ease of hosting [s26]
- Use IDE features [s26, s28]
- Code quality [s26, s29, s33]
- Data usability [s33]
- Error reduction [s35]
- Immediate result notification [s2]
- Non-blocking clients [s2]
- Clients must follow asynchronous programming model [s2]


