from codeable_models import CClass, add_links
from metamodels.domain_metamodel import domain_metaclass
from metamodels.guidance_metamodel import decision, design_solution, force, design_solution_dependencies

from add_models.ml_adds import division_of_labour, distributed_development, \
    independent_development, scalability, \
    data_pipeline, automated_provisioning, local_data_access_api, \
    service_based_data_access_api, \
    automated_data_collection, \
    ci_cd_pipeline_enables_automated_provisioning, iterative_development, \
    automated_model_adjustment, \
    direct_data_provider_access, data_access_interface_decision, \
    no_automated_provisioning, provisioning_decision, \
    data_processing_automation_decision, \
    no_data_processing_automation, ci_cd_pipeline, build_and_deployment_scripts, \
    build_and_deployment_scripts_can_be_combined_with_data_pipeline, \
    automated_integration_and_delivery_decision, \
    no_integration_or_delivery_automation, \
    ci_cd_pipeline_can_include_data_pipeline, \
    process_and_work_automation, model_as_a_service, \
    integrating_ml_model_decision, model_as_module_in_modular_monolith, \
    model_in_monolith, \
    model_as_module_in_modular_monolith_is_a_model_in_monolith, \
    service_based_model_serving, \
    data_batch_based_model_serving, \
    model_serving_decision, precompute_serving, near_real_time_support, \
    efficiency, maintainability, \
    shared_data_store, data_warehouse, data_lake, shared_database, \
    data_warehouse_is_a_shared_data_store, \
    data_lake_is_a_shared_data_store, shared_database_is_a_shared_data_store, \
    data_ingestion_decision, store_data_decision, \
    model_building_pipeline, model_building_decision, streamed_data_ingestion, \
    data_ingestion_by_request, data_ingestor, \
    data_pipeline_per_data_set, data_partitioning_in_pipeline, \
    data_throughput, speed_performance, no_data_processing_parallelization, \
    data_processing_parallelization_decision, \
    independent_processing, reliability, low_latency, \
    data_splitting, \
    interchangeability_of_ml_algorithms, \
    hybrid_data_processing_parallelization_can_use_data_pipeline_per_data_set, \
    hybrid_data_processing_parallelization_can_use_data_partitioning_in_pipeline, \
    hybrid_data_processing_parallelization, model_building_pipeline_per_model, \
    training_data_partitioning, \
    model_partitioning, model_building_parallelization_decision, \
    hybrid_model_building_parallelization, \
    no_model_building_parallelization, \
    hybrid_model_building_parallelization_can_use_model_building_pipeline_per_model, \
    hybrid_model_building_parallelization_can_use_training_data_partitioning, \
    hybrid_model_building_parallelization_can_use_training_model_partitioning, \
    data_checkpoints, \
    model_selection, safe_model_transition, n_versions_in_production, \
    deploying_model_versions_in_production_decision, \
    single_model_in_production, model_portability, testing, packaging, \
    offline_support, online_support, \
    interactive_prototyping, loose_coupling, immediate_result_notification, \
    non_blocking_clients, \
    clients_must_follow_asynchronous_model, \
    result_availability_information_decision, block_on_result, polling, \
    push_notification, development_tool_facade, \
    model_building_in_development_tool, model_accuracy, \
    model_performance_monitoring, speed_performance_monitoring, \
    model_performance_monitoring_can_use_speed_performance_monitoring, \
    model_performance_monitoring_requires_ml_metadata_store, \
    manual_model_adjustment, \
    automated_model_adjustment_can_use_switch_to_other_model_version, \
    model_performance_monitoring_can_use_model_accuracy_monitoring, \
    no_in_production_monitoring, \
    switch_to_other_model_version, \
    switch_to_other_model_version_requires_n_in_production, \
    monitoring_model_adjustment_decision, \
    monitoring_and_tracking_in_production_decision, model_accuracy_monitoring, \
    data_service, database_per_service, \
    microservice_based_model_serving, local_service_api_based_model_serving, \
    microservice_based_model_serving_is_a_service_based_model_serving, \
    local_service_api_based_model_serving_uses_model_as_a_service, \
    local_service_api_based_model_serving_is_a_service_based_model_serving, \
    microservice_based_model_serving_uses_model_as_a_service, \
    encapsulation, separation_of_concerns, \
    monitoring_domain_specific_metrics_per_model, \
    model_performance_monitoring_can_use_domain_specific_monitoring, \
    continuous_model_improvement, \
    production_ready_development, train_multiple_model_versions, \
    model_selection_uses_train_multiple_model_versions, \
    automated_model_adjustment_can_use_retrain_model, \
    retrain_model, retrain_model_can_use_train_multiple_model_versions, \
    data_ingestion_in_batches, \
    building, containerization, canary_testing, \
    a_b_testing, \
    observability, version_control_repository, \
    rolling_upgrades, data_version_repository, \
    data_versioning_in_code_repository, deploying_how_to_version_data_decision, \
    no_data_versioning, \
    data_versioning_in_code_repository_uses_version_control_repository, \
    manual_data_ingestion, etl_pipeline, \
    model_validation, collect_new_data, \
    automated_model_adjustment_can_use_collect_new_data, real_time_database, \
    real_time_database_is_a_shared_data_store, \
    data_service_can_use_db_per_service, chatty_data_access_api, \
    data_access_flexibility, modifiability, \
    data_consistency, event_store, event_store_can_offer_event_sourcing, \
    event_sourcing, \
    avoid_cold_start_problem_for_training_data, no_data_store, \
    computational_load, infrastructure_costs, \
    development_velocity, reproducibility, model_in_batch_prediction_system, \
    development_tool_facade_can_be_combined_with_model_building_in_development_tool, \
    experimental_operational_symmetry, data_preparation, data_extraction, \
    data_selection, data_transformation, \
    data_validation, feature_store, feature_persistence_and_access_decision, \
    store_features_without_specific_support, batch_feature_api, \
    real_time_feature_api, \
    feature_store_can_include_real_time_feature_api, \
    avoid_training_serving_skew, feature_discovery, feature_reuse, \
    event_store_is_a_shared_data_store, \
    feature_store_can_be_realized_by_event_sourcing, ml_metadata_store, \
    model_building_pipeline_can_use_ml_metadata_store, \
    rollback_to_previous_model_version_can_use_n_versions_in_production, \
    rollback_to_previous_model_version, \
    n_versions_in_production_can_use_metadata_store, \
    rollback_to_previous_model_version_can_use_metadata_store, \
    single_model_in_production_can_use_metadata_store, \
    ci_cd_pipeline_can_use_ml_metadata_store, on_demand_trigger, \
    on_schedule_trigger, on_model_performance_degradation_trigger, \
    on_changes_in_the_data_distribution_trigger, \
    trigger_pipeline_or_orchestrator_decision, \
    on_model_performance_degradation_trigger_requires_model_performance_monitoring, \
    on_commit_trigger, on_availability_of_new_training_data_trigger, \
    semi_automated_model_deployment, \
    ci_cd_pipeline_model_deployment, no_automated_deployment, \
    deployment_how_to_approach_decision, \
    model_building_pipeline_can_use_model_registry, \
    ci_cd_pipeline_can_use_model_registry, model_registry, \
    deployment, ci_cd_pipeline_can_be_combined_with_ml_orchestrator, \
    ml_orchestrator, unit_testing_different_methods_implemented_in_a_model, \
    testing_model_training_converges, unit_testing_pipeline_components, \
    integration_testing_pipeline_components, \
    unit_testing_feature_engineering_logic, no_testing, \
    what_to_test_decision, system_integration_testing, \
    unit_testing_system_components, testing_trained_model_quality, \
    prediction_service_api_testing, prediction_service_performance_testing, \
    pre_production_environment_provisioning, \
    test_environment_provisioning, production_environment_provisioning, \
    automated_provisioning_can_include_test_environment_provisioning, \
    automated_provisioning_can_include_pre_production_environment_provisioning, \
    automated_provisioning_can_include_production_environment_provisioning, \
    modularity, reusability, \
    independence_of_provisioning, auto_scaling, \
    model_as_a_service_can_use_containerization, continuous_improvement, \
    auditability, testability, \
    model_building_pipeline_can_be_combined_with_ml_orchestrator, \
    identify_potential_bias_or_overfit, \
    model_performance_monitoring_can_be_combined_with_model_in_production_tracking, \
    model_in_production_tracking_can_use_production_data_store, \
    model_performance_monitoring_can_use_production_data_store, \
    production_data_store, model_in_production_tracking, \
    model_builder_component, \
    data_processing_component, \
    model_builder_component_can_be_combined_with_ml_orchestrator, \
    data_pipeline_can_be_combined_with_ml_orchestrator, \
    data_processing_component_can_be_combined_with_ml_orchestrator, \
    ground_truth_collector, \
    ground_truth_collector_is_an_data_ingestor, automatic_data_labeller, \
    manual_data_labelling, \
    data_ingestor_can_use_data_labeller, \
    data_labeller_alternative_to_manual_data_labelling, \
    data_ingestor_can_use_manual_data_labelling, \
    streamed_data_ingestion_can_use_raw_data_store, \
    data_ingestion_by_request_can_use_raw_data_store, raw_data_store, \
    data_ingestion_in_batches_can_use_raw_data_store, \
    manual_data_ingestion_can_use_raw_data_store, \
    streamed_data_ingestion_can_be_realized_by_data_ingestor, \
    data_ingestion_by_request_can_be_realized_by_data_ingestor, \
    service_based_model_serving_can_use_predictions_data_store, \
    data_batch_based_model_serving_can_use_predictions_data_store, \
    predictions_data_store, \
    data_processing_tasks_decision, delivery_tasks_decision, \
    build_and_deployment_scripts_can_be_combined_with_model_building_pipeline, \
    ci_cd_pipeline_can_include_model_building_pipeline, \
    model_building_tasks_decision, \
    batch_or_realtime_data_processing_decision, real_time_data_processing, \
    batch_based_data_processing, \
    feature_engineering, \
    model_packaging, robustness, flexibility, development_agility, \
    monitoring_or_logging_data_and_predictions, \
    development_tool_export, model_training, memory_requirements, \
    react_to_unforeseen_changes_in_the_data, \
    batch_based_learning, incremental_learning, \
    when_and_how_to_train_the_model_decision, \
    variety_of_ml_algorithm_choices, \
    data_ingestion_queue_is_an_data_ingestor, data_ingestion_queue, \
    in_memory_data_store, database_per_service_has_variant_in_memory_data_store, \
    shared_database_has_variant_in_memory_data_store, debugging_support, \
    model_builder_component_can_use_ml_metadata_store, \
    react_to_user_events_and_interactions, \
    hybrid_online_offline_model_serving_can_use_data_batch_based_model_serving, \
    hybrid_online_offline_model_serving, \
    hybrid_online_offline_model_serving_can_use_service_based_model_serving, \
    hybrid_learning, \
    hybrid_learning_can_use_batch_based_learning, \
    hybrid_learning_can_use_incremental_learning, \
    message_event_queue_based_data_access_api, pub_sub_data_access_api, \
    unified_data_access, \
    handling_massive_amounts_of_data, hypothesis_testing, \
    feature_store_can_include_batch_feature_api, \
    no_integration_of_model, model_hyperparameter_tuning, \
    data_processing_hyperparameter_tuning, explainability, \
    auto_ml_can_use_model_hyperparameter_tuning, auto_ml, no_auto_ml, \
    auto_ml_can_use_data_processing_hyperparameter_tuning, \
    auto_ml_can_use_data_preparation, \
    auto_ml_can_use_feature_engineering, auto_ml_can_use_model_training, \
    auto_ml_requires_model_validation, \
    auto_ml_can_use_model_selection, \
    event_driven_model_as_a_service_is_a_model_as_a_service, \
    event_driven_model_as_a_service, auto_ml_decision, \
    serverless_model_as_a_service_is_a_model_as_a_service, \
    serverless_model_as_a_service, time_to_market_reduction, \
    improve_user_experience, improve_customer_satisfaction, \
    improve_prediction_quality, continuous_training, \
    mlops_can_use_model_training, mlops, no_mlops, \
    mlops_can_use_model_validation, \
    mlops_decision, \
    continuous_validation, recognise_model_degradation, \
    address_model_degradation, recognise_data_drift, dependable_releases, \
    improve_model_management, change_tracking, \
    shadow_mode_testing, \
    mlops_can_use_continuous_training, mlops_can_use_continuous_validation, \
    mlops_can_use_model_registry, \
    mlops_can_use_ci_cd_pipeline, \
    data_sourcing, \
    experiment_tracking, data_analysis, data_labelling, model_architecture, \
    training_in_production, configuration_versioning, \
    model_development, model_evaluation, \
    model_versioning, \
    hardware_scaling, training_at_scale, \
    static_code_analysis, automated_regression_tests, model_management, \
    mlops_can_use_data_sourcing, mlops_can_use_data_analysis, \
    automated_model_development, mlops_enables_experiment_tracking, \
    mlops_can_use_model_architecture, \
    model_benchmarking, \
    mlops_can_use_data_labelling, mlops_can_use_model_development, \
    mlops_can_use_model_evaluation, mlops_can_use_model_versioning, \
    mlops_can_use_hardware_scaling, \
    mlops_enables_model_benchmarking, mlops_can_use_automated_model_development, \
    mlops_can_use_model_management, \
    mlops_can_use_automated_regression_tests, \
    mlops_can_use_configuration_versioning, \
    prediction_service, stress_testing, system_monitoring, application_pipeline, \
    mlops_enables_experimentation, \
    mlops_enables_prediction_service, \
    experimentation, skew_testing, \
    mlops_enables_training_at_scale, mlops_can_use_skew_testing, \
    mlops_can_use_retrain_model, mlops_can_use_system_monitoring, \
    mlops_can_use_application_pipeline, mlops_can_use_stress_testing, \
    mlops_can_use_canary_testing, mlops_enables_training_in_production, \
    tool_development_effort, model_service_profiling, \
    use_computational_notebooks, use_ide, development_environment_decision, \
    use_computational_notebooks_rules_out_version_control_repository, \
    use_computational_notebooks_rules_out_static_code_analysis, \
    use_ide_can_use_version_control_repository, \
    cross_team_collaboration, trigger_model_retraining, \
    model_performance_analysis, production_support, production_maintenance, \
    production_operations, iterative_model_building, humans_in_the_loop, \
    use_monitoring_schedule, set_trigger_conditions_for_human_loop_activation, \
    mlops_can_use_static_code_analysis, \
    mlops_can_use_data_versioning_in_code_repository, \
    mlops_can_use_data_version_repository, handling_large_data_files, \
    mlops_can_use_prediction_service_api_testing, mlops_can_use_a_b_testing, \
    mlops_can_use_prediction_service_performance_testing, simplified_deployment, \
    simplified_model_updates, improved_client_heterogeneity, \
    facilitates_testing_in_production, improved_support_for_numerous_clients, \
    align_models_with_business_needs, align_models_with_regulatory_requirements, \
    rapid_experimentation, management_agility, reduce_cost, save_time, \
    unlock_new_sources_of_revenue, model_consistency, reduce_technical_debt, \
    model_successful_operation, model_stability, incident_detection, \
    risk_mitigation, incident_resolution, valuable_models, model_performance, \
    fresh_models, deployment_velocity, code_quality, use_ide_features, \
    demonstrability, ease_of_hosting, data_usability, error_reduction, \
    ensemble_learning, \
    training_data_partitioning_can_be_combined_with_model_hyperparameter_tuning, \
    training_data_partitioning_can_be_combined_with_data_processing_hyperparameter_tuning, \
    training_data_partitioning_can_be_combined_with_ensemble_learning, mlops_enables_deployment, \
    model_building_pipeline_can_be_combined_with_data_pipeline, n_versions_in_production_enables_a_b_testing, \
    n_versions_in_production_enables_canary_testing
from metamodels.GT_coding import source, code

# add code as superclass to all possible codes used below
for classifier in [decision, domain_metaclass, design_solution, force, design_solution_dependencies]:
    classifier.superclasses = classifier.superclasses + [code]

s1 = CClass(source, "s1", values={
    "title": "How to power up your product by machine learning with python microservice, pt. 1",
    "url": "https://towardsdatascience.com/how-to-power-up-your-product-by-machine-learning-with-python-microservice-pt-1-de0f2b434bec",
    "archive url": "https://tinyurl.com/ml-adds-u1",
    "author type": "Practitioner",
    "type": "Practitioner Audience Article",
    "example": True,
    "source code": False})
s1_codes = [ci_cd_pipeline_model_deployment, division_of_labour, distributed_development,
            independent_development, scalability, data_pipeline,
            automated_provisioning, no_automated_provisioning, provisioning_decision,
            batch_based_data_processing, real_time_data_processing, batch_or_realtime_data_processing_decision,
            data_processing_automation_decision,
            no_data_processing_automation, tool_development_effort,
            local_data_access_api, service_based_data_access_api, data_service, unified_data_access,
            automated_data_collection, data_access_interface_decision,
            direct_data_provider_access, model_training, model_building_tasks_decision,
            ci_cd_pipeline, ci_cd_pipeline_can_include_data_pipeline,
            ci_cd_pipeline_enables_automated_provisioning, build_and_deployment_scripts,
            build_and_deployment_scripts_can_be_combined_with_data_pipeline,
            automated_integration_and_delivery_decision,
            no_integration_or_delivery_automation, process_and_work_automation,
            data_preparation, feature_engineering,
            iterative_development, data_extraction, data_processing_tasks_decision,
            monitoring_and_tracking_in_production_decision, no_in_production_monitoring,
            model_performance_monitoring, monitoring_model_adjustment_decision, manual_model_adjustment,
            automated_model_adjustment, model_as_a_service, database_per_service,
            data_service_can_use_db_per_service,
            model_in_monolith, model_as_module_in_modular_monolith, integrating_ml_model_decision,
            model_as_module_in_modular_monolith_is_a_model_in_monolith,
            shared_data_store, data_warehouse, data_lake, shared_database,
            data_warehouse_is_a_shared_data_store, no_data_store,
            data_lake_is_a_shared_data_store, shared_database_is_a_shared_data_store, store_data_decision,
            service_based_model_serving, data_batch_based_model_serving,
            precompute_serving, model_serving_decision,
            microservice_based_model_serving, local_service_api_based_model_serving,
            microservice_based_model_serving_is_a_service_based_model_serving,
            local_service_api_based_model_serving_is_a_service_based_model_serving,
            local_service_api_based_model_serving_uses_model_as_a_service,
            microservice_based_model_serving_uses_model_as_a_service,
            near_real_time_support, efficiency, maintainability,
            on_schedule_trigger, trigger_pipeline_or_orchestrator_decision,
            semi_automated_model_deployment,
            no_automated_deployment,
            deployment_how_to_approach_decision,
            what_to_test_decision, unit_testing_pipeline_components, integration_testing_pipeline_components
            ]
add_links({s1: s1_codes}, role_name="contained_code")

s2 = CClass(source, "s2", values={
    "title": "Architecting a Machine Learning Pipeline: How to build scalable Machine Learning systems - Part 2/2",
    "url": "https://towardsdatascience.com/architecting-a-machine-learning-pipeline-a847f094d1c7",
    "archive url": "https://tinyurl.com/ml-adds-u2",
    "author type": "Practitioner",
    "type": "Practitioner Audience Article",
    "example": True,
    "source code": False})

s2_codes = [ci_cd_pipeline_model_deployment, model_building_pipeline, batch_or_realtime_data_processing_decision,
            batch_based_data_processing,
            data_pipeline, model_building_decision,
            data_processing_automation_decision, model_serving_decision,
            streamed_data_ingestion, data_ingestion_by_request, data_ingestion_decision,
            data_ingestor, streamed_data_ingestion_can_be_realized_by_data_ingestor,
            data_ingestion_by_request_can_be_realized_by_data_ingestor,
            tool_development_effort,
            data_pipeline_per_data_set, data_partitioning_in_pipeline, data_throughput, speed_performance,
            independent_processing, data_processing_parallelization_decision, no_data_processing_parallelization,
            hybrid_data_processing_parallelization,
            hybrid_data_processing_parallelization_can_use_data_pipeline_per_data_set,
            hybrid_data_processing_parallelization_can_use_data_partitioning_in_pipeline,
            low_latency, data_preparation, data_processing_tasks_decision,
            model_registry, ci_cd_pipeline_can_use_model_registry, model_building_pipeline_can_use_model_registry,
            ci_cd_pipeline_can_include_model_building_pipeline,
            ci_cd_pipeline_can_include_data_pipeline,
            build_and_deployment_scripts_can_be_combined_with_model_building_pipeline,
            feature_store, feature_persistence_and_access_decision, store_features_without_specific_support,
            batch_feature_api, real_time_feature_api, data_access_interface_decision,
            feature_store_can_include_real_time_feature_api,
            feature_store_can_include_batch_feature_api,
            online_support, offline_support,
            predictions_data_store, service_based_model_serving_can_use_predictions_data_store,
            data_batch_based_model_serving_can_use_predictions_data_store,
            near_real_time_support,
            real_time_data_processing, reliability,
            data_extraction,
            data_selection, data_transformation,
            data_splitting, feature_engineering, model_training,
            pub_sub_data_access_api, message_event_queue_based_data_access_api,
            interchangeability_of_ml_algorithms,
            model_building_in_development_tool, development_tool_facade,
            development_tool_facade_can_be_combined_with_model_building_in_development_tool,
            model_building_pipeline_per_model, training_data_partitioning, model_partitioning,
            hybrid_model_building_parallelization, model_building_parallelization_decision,
            no_model_building_parallelization,
            hybrid_model_building_parallelization_can_use_model_building_pipeline_per_model,
            hybrid_model_building_parallelization_can_use_training_data_partitioning,
            hybrid_model_building_parallelization_can_use_training_model_partitioning,
            data_checkpoints, model_selection, model_building_tasks_decision,
            train_multiple_model_versions,
            model_selection_uses_train_multiple_model_versions,
            safe_model_transition, n_versions_in_production, deploying_model_versions_in_production_decision,
            single_model_in_production, model_hyperparameter_tuning,
            model_as_a_service,
            model_in_monolith, model_as_module_in_modular_monolith, integrating_ml_model_decision,
            model_as_module_in_modular_monolith_is_a_model_in_monolith,
            model_portability, in_memory_data_store, database_per_service_has_variant_in_memory_data_store,
            shared_database_has_variant_in_memory_data_store,
            scalability,
            ci_cd_pipeline, packaging, testing,
            automated_integration_and_delivery_decision, delivery_tasks_decision,
            data_batch_based_model_serving, microservice_based_model_serving,
            microservice_based_model_serving_is_a_service_based_model_serving,
            local_service_api_based_model_serving_uses_model_as_a_service,
            immediate_result_notification, non_blocking_clients, clients_must_follow_asynchronous_model,
            push_notification, polling, block_on_result, result_availability_information_decision,
            interactive_prototyping, loose_coupling,
            model_accuracy, model_performance_monitoring, speed_performance_monitoring,
            model_accuracy_monitoring,
            model_performance_monitoring_can_use_speed_performance_monitoring,
            model_performance_monitoring_can_use_model_accuracy_monitoring,
            model_performance_monitoring_requires_ml_metadata_store, ml_metadata_store,
            model_building_pipeline_can_use_ml_metadata_store,
            model_building_pipeline_can_be_combined_with_data_pipeline,
            ci_cd_pipeline_can_use_ml_metadata_store,
            monitoring_and_tracking_in_production_decision, no_in_production_monitoring, manual_model_adjustment,
            automated_model_adjustment, switch_to_other_model_version,
            automated_model_adjustment_can_use_switch_to_other_model_version,
            switch_to_other_model_version_requires_n_in_production,
            monitoring_model_adjustment_decision, service_based_data_access_api, data_service, store_data_decision,
            direct_data_provider_access,
            on_schedule_trigger, trigger_pipeline_or_orchestrator_decision, on_demand_trigger,
            semi_automated_model_deployment,
            no_automated_deployment,
            deployment_how_to_approach_decision,
            raw_data_store, streamed_data_ingestion_can_use_raw_data_store,
            data_ingestion_by_request_can_use_raw_data_store,
            batch_based_learning, when_and_how_to_train_the_model_decision,
            ]
add_links({s2: s2_codes}, role_name="contained_code")

s3 = CClass(source, "s3", values={
    "title": "Some Thoughts on Modularization in Machine Learning",
    "url": "https://web.archive.org/web/20191124090916/https://medium.com/singular-distillation/some-thoughts-on-modularization-in-machine-learning-fc49f222a647",
    "archive url": "https://tinyurl.com/ml-adds-u3",
    "author type": "Practitioner",
    "type": "Practitioner Audience Article",
    "example": False,
    "source code": False})

s3_codes = [integrating_ml_model_decision, model_as_module_in_modular_monolith, model_as_a_service,
            model_serving_decision, microservice_based_model_serving, local_service_api_based_model_serving,
            service_based_model_serving, encapsulation, division_of_labour, independent_development,
            separation_of_concerns, model_in_monolith, scalability,
            model_performance_monitoring,
            speed_performance_monitoring,
            model_accuracy_monitoring,
            monitoring_domain_specific_metrics_per_model,
            model_performance_monitoring_can_use_domain_specific_monitoring,
            model_performance_monitoring_can_use_model_accuracy_monitoring,
            model_performance_monitoring_can_use_speed_performance_monitoring,
            monitoring_and_tracking_in_production_decision,
            speed_performance, model_accuracy,
            continuous_model_improvement,

            deployment_how_to_approach_decision,
            no_automated_deployment
            ]
add_links({s3: s3_codes}, role_name="contained_code")

s4 = CClass(source, "s4", values={
    "title": "Productionizing Machine Learning with a Microservices Architecture",
    "url": "https://databricks.com/de/session_na20/productionizing-machine-learning-with-a-microservices-architecture",
    "archive url": "https://tinyurl.com/ml-adds-u4",
    "author type": "Practitioner",
    "type": "Presentation Video",
    "example": False,
    "source code": False})

s4_codes = [iterative_development, production_ready_development,
            model_building_in_development_tool,
            model_building_decision,
            scalability, streamed_data_ingestion, data_ingestion_by_request,
            data_ingestion_decision,
            store_data_decision, shared_data_store, shared_database,
            shared_database_is_a_shared_data_store,
            automated_model_adjustment, monitoring_model_adjustment_decision,
            automated_model_adjustment_can_use_retrain_model, retrain_model,
            retrain_model_can_use_train_multiple_model_versions,
            train_multiple_model_versions, monitoring_and_tracking_in_production_decision,
            model_accuracy, model_accuracy_monitoring, continuous_model_improvement, division_of_labour,
            independent_development, distributed_development,
            data_ingestion_in_batches, manual_data_ingestion,
            manual_data_ingestion_can_use_raw_data_store, data_ingestion_in_batches_can_use_raw_data_store,
            raw_data_store, data_ingestion_by_request_can_use_raw_data_store,
            data_ingestion_by_request_can_be_realized_by_data_ingestor,
            streamed_data_ingestion_can_be_realized_by_data_ingestor, data_ingestor,
            packaging, testing, delivery_tasks_decision,
            building, containerization, canary_testing, a_b_testing,
            deployment,
            ml_orchestrator, ci_cd_pipeline_can_be_combined_with_ml_orchestrator,
            ci_cd_pipeline, automated_integration_and_delivery_decision, speed_performance,
            speed_performance_monitoring, low_latency, data_throughput, observability,
            version_control_repository,
            n_versions_in_production, deploying_model_versions_in_production_decision,
            rolling_upgrades, rollback_to_previous_model_version,
            rollback_to_previous_model_version_can_use_n_versions_in_production,
            data_version_repository,
            data_versioning_in_code_repository,
            deploying_how_to_version_data_decision,
            no_data_versioning,
            data_versioning_in_code_repository_uses_version_control_repository,
            etl_pipeline, data_processing_automation_decision, data_pipeline,
            real_time_data_processing, batch_or_realtime_data_processing_decision, model_building_pipeline,
            data_splitting, model_building_parallelization_decision, model_building_pipeline_per_model,
            model_partitioning, hybrid_model_building_parallelization,
            model_selection, model_building_tasks_decision,
            model_validation, model_training,
            service_based_data_access_api, local_data_access_api, unified_data_access, data_access_interface_decision,
            monitoring_domain_specific_metrics_per_model,
            model_performance_monitoring_can_use_domain_specific_monitoring,
            model_performance_monitoring_can_use_model_accuracy_monitoring,
            model_performance_monitoring_can_use_speed_performance_monitoring,
            collect_new_data, data_preparation, data_processing_tasks_decision, feature_engineering,
            serverless_model_as_a_service, serverless_model_as_a_service_is_a_model_as_a_service,
            model_as_a_service, integrating_ml_model_decision,
            automated_model_adjustment_can_use_collect_new_data,
            development_tool_facade,
            development_tool_facade_can_be_combined_with_model_building_in_development_tool,
            data_lake, data_lake_is_a_shared_data_store,
            real_time_database, real_time_database_is_a_shared_data_store,
            feature_store, feature_persistence_and_access_decision, store_features_without_specific_support,
            data_warehouse, data_warehouse_is_a_shared_data_store,
            near_real_time_support, independent_processing,
            efficiency, ml_metadata_store,
            model_building_pipeline_can_use_ml_metadata_store,
            ci_cd_pipeline_can_use_ml_metadata_store, on_demand_trigger,
            on_commit_trigger, trigger_pipeline_or_orchestrator_decision,
            semi_automated_model_deployment,
            no_automated_deployment,
            deployment_how_to_approach_decision,
            unit_testing_system_components, system_integration_testing, what_to_test_decision,
            testing_model_training_converges, testing_trained_model_quality,
            mlops, mlops_decision, no_mlops,
            auto_ml_decision,
            auto_ml,
            no_auto_ml,
            ensemble_learning,
            when_and_how_to_train_the_model_decision
            ]
add_links({s4: s4_codes}, role_name="contained_code")

s5 = CClass(source, "s5", values={
    "title": "Microservices Suck for Machine Learning (and what we did about it)",
    "url": "https://streamsql.io/blog/microservices-with-machine-learning-feature-store",
    "archive url": "https://tinyurl.com/ml-adds-u5",
    "author type": "Practitioner",
    "type": "Practitioner Audience Article",
    "example": True,
    "source code": True})

s5_codes = [data_service, data_service_can_use_db_per_service, database_per_service,
            store_data_decision, etl_pipeline, data_processing_automation_decision, integrating_ml_model_decision,
            model_in_monolith, model_training, model_building_tasks_decision,
            division_of_labour, distributed_development, independent_development,
            separation_of_concerns, chatty_data_access_api, speed_performance, scalability, data_access_flexibility,
            data_access_interface_decision, service_based_data_access_api, local_data_access_api,
            data_ingestion_in_batches, data_ingestion_decision, data_ingestion_by_request, manual_data_ingestion,
            data_ingestion_in_batches_can_use_raw_data_store, data_ingestion_by_request_can_use_raw_data_store,
            manual_data_ingestion_can_use_raw_data_store,
            raw_data_store,
            modifiability, data_consistency, maintainability,
            model_as_a_service, data_pipeline, batch_or_realtime_data_processing_decision, batch_based_data_processing,
            data_lake, data_lake_is_a_shared_data_store, shared_data_store,
            real_time_data_processing, streamed_data_ingestion,
            message_event_queue_based_data_access_api,
            event_store, event_store_is_a_shared_data_store,
            reliability, loose_coupling, event_sourcing, event_store_can_offer_event_sourcing,
            avoid_cold_start_problem_for_training_data, no_data_store,
            computational_load, infrastructure_costs, development_velocity,
            data_preparation,
            data_transformation, data_processing_tasks_decision, feature_engineering,
            feature_store, feature_persistence_and_access_decision, store_features_without_specific_support,
            feature_store_can_be_realized_by_event_sourcing, feature_discovery, feature_reuse,
            testing, delivery_tasks_decision, testing_model_training_converges, testing_trained_model_quality,
            what_to_test_decision
            ]
add_links({s5: s5_codes}, role_name="contained_code")

s6 = CClass(source, "s6", values={
    "title": "MLOps: Continuous delivery and automation pipelines in machine learning",
    "url": "https://cloud.google.com/solutions/machine-learning/mlops-continuous-delivery-and-automation-pipelines-in-machine-learning?hl=en",
    "archive url": "https://tinyurl.com/ml-adds-u6",
    "author type": "Practitioner",
    "type": "Practitioner Audience Article",
    "example": True,
    "source code": False})

s6_codes = [ci_cd_pipeline, automated_integration_and_delivery_decision,
            reproducibility, independent_development, train_multiple_model_versions,
            testing, delivery_tasks_decision, model_validation, model_training,
            model_building_tasks_decision, model_building_pipeline,
            model_building_decision, data_processing_automation_decision,
            retrain_model,
            monitoring_model_adjustment_decision, automated_model_adjustment,
            automated_model_adjustment_can_use_retrain_model,
            model_performance_monitoring,
            speed_performance_monitoring,
            model_accuracy_monitoring,
            model_performance_monitoring_can_use_model_accuracy_monitoring,
            model_performance_monitoring_can_use_speed_performance_monitoring,
            monitoring_and_tracking_in_production_decision,
            speed_performance, model_accuracy,
            version_control_repository,
            packaging,
            offline_support, online_support,
            model_as_module_in_modular_monolith, model_as_a_service,
            model_in_batch_prediction_system, integrating_ml_model_decision,
            data_ingestion_decision, manual_data_ingestion, no_data_processing_automation,
            no_integration_or_delivery_automation,
            model_building_in_development_tool, no_in_production_monitoring, manual_model_adjustment,
            low_latency, modifiability,
            building,
            data_pipeline, batch_or_realtime_data_processing_decision, real_time_data_processing,
            batch_based_data_processing,
            data_extraction, data_processing_tasks_decision, feature_engineering,
            data_validation, data_preparation, data_transformation, data_selection,
            model_hyperparameter_tuning,
            loose_coupling,
            development_tool_facade,
            development_tool_facade_can_be_combined_with_model_building_in_development_tool,
            experimental_operational_symmetry, a_b_testing,
            canary_testing,
            feature_store, feature_persistence_and_access_decision, store_features_without_specific_support,
            batch_feature_api, feature_store_can_include_batch_feature_api, real_time_feature_api,
            feature_store_can_include_real_time_feature_api,
            data_access_interface_decision,
            service_based_data_access_api, local_data_access_api,
            feature_reuse, feature_discovery, maintainability, avoid_training_serving_skew,
            data_throughput, near_real_time_support,
            ml_metadata_store, ci_cd_pipeline_can_use_ml_metadata_store,
            model_building_pipeline_can_use_ml_metadata_store,
            rollback_to_previous_model_version_can_use_n_versions_in_production,
            rollback_to_previous_model_version,
            n_versions_in_production_can_use_metadata_store,
            rollback_to_previous_model_version_can_use_metadata_store,
            single_model_in_production_can_use_metadata_store,
            rolling_upgrades, safe_model_transition,
            n_versions_in_production, single_model_in_production,
            deploying_model_versions_in_production_decision,
            on_demand_trigger, on_schedule_trigger, on_availability_of_new_training_data_trigger,
            on_model_performance_degradation_trigger, on_changes_in_the_data_distribution_trigger,
            trigger_pipeline_or_orchestrator_decision,
            on_model_performance_degradation_trigger_requires_model_performance_monitoring,
            semi_automated_model_deployment, ci_cd_pipeline_model_deployment,
            no_automated_deployment,
            deployment_how_to_approach_decision,
            model_building_parallelization_decision,
            model_building_pipeline_per_model,
            no_model_building_parallelization, ci_cd_pipeline_can_include_model_building_pipeline,
            model_registry, ci_cd_pipeline_can_use_model_registry, model_building_pipeline_can_use_model_registry,
            deployment,
            ml_orchestrator, ci_cd_pipeline_can_be_combined_with_ml_orchestrator,
            unit_testing_different_methods_implemented_in_a_model, unit_testing_feature_engineering_logic,
            testing_model_training_converges,
            unit_testing_pipeline_components, integration_testing_pipeline_components, no_testing,
            what_to_test_decision, unit_testing_system_components, system_integration_testing,
            testing_trained_model_quality,
            prediction_service_api_testing, prediction_service_performance_testing,
            test_environment_provisioning, pre_production_environment_provisioning,
            production_environment_provisioning,
            automated_provisioning_can_include_test_environment_provisioning,
            automated_provisioning_can_include_pre_production_environment_provisioning,
            automated_provisioning_can_include_production_environment_provisioning,
            automated_provisioning, no_automated_provisioning, ci_cd_pipeline_enables_automated_provisioning,
            provisioning_decision,
            mlops, mlops_decision, no_mlops,
            batch_based_learning, incremental_learning, when_and_how_to_train_the_model_decision,
            auto_ml_decision,
            auto_ml,
            no_auto_ml,
            shadow_mode_testing,
            n_versions_in_production_enables_a_b_testing,
            n_versions_in_production_enables_canary_testing
            ]
add_links({s6: s6_codes}, role_name="contained_code")

s7 = CClass(source, "s7", values={
    "title": "Composing Deep-Learning Microservices for the Hybrid Internet of Things",
    "url": "https://towardsdatascience.com/composing-deep-learning-microservices-for-the-hybrid-internet-of-things-c6cb3cb23b0f",
    "archive url": "https://tinyurl.com/ml-adds-u7",
    "author type": "Practitioner",
    "type": "Practitioner Audience Article",
    "example": True,
    "source code": False})

s7_codes = [model_as_a_service, integrating_ml_model_decision, modularity, reusability, loose_coupling,
            containerization, delivery_tasks_decision,
            model_as_a_service_can_use_containerization,
            service_based_model_serving, microservice_based_model_serving,
            microservice_based_model_serving_is_a_service_based_model_serving,
            model_serving_decision,
            microservice_based_model_serving_uses_model_as_a_service,
            automated_provisioning, provisioning_decision, independence_of_provisioning, auto_scaling, scalability,
            serverless_model_as_a_service, serverless_model_as_a_service_is_a_model_as_a_service,
            streamed_data_ingestion, data_ingestion_decision,
            division_of_labour, independent_development,
            model_training, model_building_tasks_decision
            ]
add_links({s7: s7_codes}, role_name="contained_code")

s8 = CClass(source, "s8", values={
    "title": "Continuous Intelligence: Moving Machine Learning Application into Production Reliably",
    "url": "https://github.com/ThoughtWorksInc/cd4ml-workshop/blob/master/Strata-london-2019-slides.pdf",
    "archive url": "https://tinyurl.com/ml-adds-u8",
    "author type": "Practitioner",
    "type": "Slides",
    "example": True,
    "source code": False})

s8_codes = [reproducibility, testability, auditability, continuous_improvement, modifiability,
            ci_cd_pipeline, automated_integration_and_delivery_decision,
            building, delivery_tasks_decision, version_control_repository,
            automated_provisioning, provisioning_decision, process_and_work_automation, reliability,
            store_data_decision, data_access_interface_decision, service_based_data_access_api,
            local_data_access_api,
            data_version_repository, deploying_how_to_version_data_decision,
            ci_cd_pipeline_can_be_combined_with_ml_orchestrator, ml_orchestrator,
            automated_provisioning_can_include_pre_production_environment_provisioning,
            pre_production_environment_provisioning,
            production_environment_provisioning, automated_provisioning_can_include_production_environment_provisioning,
            test_environment_provisioning, automated_provisioning_can_include_test_environment_provisioning,
            monitoring_and_tracking_in_production_decision, model_accuracy_monitoring, model_performance_monitoring,
            speed_performance_monitoring, model_performance_monitoring_can_use_speed_performance_monitoring,
            model_performance_monitoring_can_use_model_accuracy_monitoring, observability, ml_metadata_store,
            model_building_decision, model_building_pipeline,
            data_ingestion_decision, deployment, system_integration_testing,
            what_to_test_decision,
            model_validation, model_training, model_building_tasks_decision, data_pipeline,
            data_processing_automation_decision,
            containerization, trigger_pipeline_or_orchestrator_decision,
            on_commit_trigger,
            retrain_model, automated_model_adjustment_can_use_retrain_model, automated_model_adjustment,
            manual_model_adjustment, monitoring_model_adjustment_decision, data_extraction,
            data_processing_tasks_decision, batch_or_realtime_data_processing_decision, real_time_data_processing,
            batch_based_data_processing, feature_engineering,
            data_splitting,
            train_multiple_model_versions, model_building_pipeline_can_be_combined_with_ml_orchestrator,
            model_in_production_tracking, production_data_store,
            model_performance_monitoring_can_use_production_data_store,
            model_in_production_tracking_can_use_production_data_store,
            model_performance_monitoring_can_be_combined_with_model_in_production_tracking,
            avoid_training_serving_skew, identify_potential_bias_or_overfit,
            continuous_model_improvement
            ]
add_links({s8: s8_codes}, role_name="contained_code")

s9 = CClass(source, "s9", values={
    "title": "Architecture of a real-world Machine Learning system",
    "url": "https://medium.com/louis-dorard/architecture-of-a-real-world-machine-learning-system-795254bec646",
    "archive url": "https://tinyurl.com/ml-adds-u9",
    "author type": "Practitioner",
    "type": "Practitioner Audience Article",
    "example": True,
    "source code": False})

s9_codes = [offline_support, online_support, integrating_ml_model_decision, model_as_a_service,
            model_building_decision, model_builder_component,
            data_processing_component,
            model_building_pipeline, data_processing_automation_decision,
            ml_orchestrator, automated_integration_and_delivery_decision,
            model_builder_component_can_be_combined_with_ml_orchestrator,
            data_pipeline_can_be_combined_with_ml_orchestrator,
            data_processing_component_can_be_combined_with_ml_orchestrator,
            data_pipeline,
            model_validation, model_building_tasks_decision,
            model_serving_decision, service_based_model_serving, microservice_based_model_serving,
            microservice_based_model_serving_is_a_service_based_model_serving,
            serverless_model_as_a_service, serverless_model_as_a_service_is_a_model_as_a_service,

            ci_cd_pipeline_can_be_combined_with_ml_orchestrator,
            trigger_pipeline_or_orchestrator_decision, on_demand_trigger, on_schedule_trigger,

            monitoring_and_tracking_in_production_decision, model_performance_monitoring, model_accuracy_monitoring,
            monitoring_domain_specific_metrics_per_model,
            model_performance_monitoring_can_use_domain_specific_monitoring,
            model_performance_monitoring_can_use_model_accuracy_monitoring, n_versions_in_production,
            deploying_model_versions_in_production_decision, a_b_testing, canary_testing, delivery_tasks_decision,
            what_to_test_decision,
            ml_metadata_store, production_data_store, model_performance_monitoring_can_use_production_data_store,
            model_performance_monitoring_requires_ml_metadata_store,
            store_data_decision, shared_data_store,

            ground_truth_collector, ground_truth_collector_is_an_data_ingestor,
            data_ingestion_decision, streamed_data_ingestion, data_ingestion_by_request,
            raw_data_store, streamed_data_ingestion_can_use_raw_data_store,
            data_ingestion_by_request_can_use_raw_data_store,

            automatic_data_labeller, manual_data_labelling, data_ingestor_can_use_data_labeller,
            data_ingestor_can_use_manual_data_labelling, data_labeller_alternative_to_manual_data_labelling,

            data_throughput, speed_performance, speed_performance_monitoring,
            model_performance_monitoring_can_use_speed_performance_monitoring, model_accuracy,
            train_multiple_model_versions, model_selection_uses_train_multiple_model_versions,
            model_training,

            predictions_data_store, service_based_model_serving_can_use_predictions_data_store,

            feature_store, feature_persistence_and_access_decision,
            data_processing_tasks_decision, batch_or_realtime_data_processing_decision, real_time_data_processing,
            feature_engineering,

            etl_pipeline, model_building_pipeline_can_be_combined_with_ml_orchestrator,
            data_splitting, data_preparation, data_validation, model_selection,
            testing_trained_model_quality, build_and_deployment_scripts,
            data_processing_parallelization_decision, no_data_processing_parallelization,
            no_model_building_parallelization, model_building_parallelization_decision,
            model_building_pipeline_per_model, hybrid_data_processing_parallelization,
            hybrid_model_building_parallelization, data_partitioning_in_pipeline,
            ci_cd_pipeline, data_warehouse,
            data_warehouse_is_a_shared_data_store, containerization,
            data_processing_hyperparameter_tuning, model_hyperparameter_tuning,

            model_registry, model_packaging,

            auto_ml_decision,
            auto_ml,
            no_auto_ml,

            n_versions_in_production_enables_a_b_testing,
            n_versions_in_production_enables_canary_testing
            ]
add_links({s9: s9_codes}, role_name="contained_code")

s10 = CClass(source, "s10", values={
    "title": "Architecting a Machine Learning System for Risk",
    "url": "https://medium.com/airbnb-engineering/architecting-a-machine-learning-system-for-risk-941abbba5a60",
    "archive url": "https://tinyurl.com/ml-adds-u10",
    "author type": "Practitioner",
    "type": "Practitioner Audience Article",
    "example": True,
    "source code": False})

s10_codes = [online_support, offline_support, near_real_time_support, speed_performance, robustness,
             model_serving_decision, feature_engineering, data_processing_tasks_decision,
             data_processing_automation_decision,
             model_building_decision, model_building_pipeline, ci_cd_pipeline,
             automated_integration_and_delivery_decision,
             ci_cd_pipeline_can_include_model_building_pipeline,
             development_agility, tool_development_effort, flexibility, reliability,

             microservice_based_model_serving, microservice_based_model_serving_is_a_service_based_model_serving,
             service_based_model_serving, modularity, batch_based_data_processing,
             batch_or_realtime_data_processing_decision, real_time_data_processing,

             monitoring_and_tracking_in_production_decision, monitoring_or_logging_data_and_predictions,
             speed_performance_monitoring, ground_truth_collector, ground_truth_collector_is_an_data_ingestor,
             data_ingestion_decision, data_ingestor, development_tool_export,
             model_building_in_development_tool, model_building_tasks_decision,
             model_validation, debugging_support,

             feature_store, feature_persistence_and_access_decision, data_transformation, data_preparation,
             model_training, what_to_test_decision, testing_trained_model_quality, model_accuracy,
             build_and_deployment_scripts,

             batch_based_learning, incremental_learning, when_and_how_to_train_the_model_decision,

             auto_ml_decision,
             auto_ml,
             no_auto_ml
             ]
add_links({s10: s10_codes}, role_name="contained_code")

s11 = CClass(source, "s11", values={
    "title": "Architecting a Scalable Real Time Learning System",
    "url": "https://medium.com/value-stream-design/architecting-a-scalable-real-time-learning-system-95623d27dd15",
    "archive url": "https://tinyurl.com/ml-adds-u11",
    "author type": "Practitioner",
    "type": "Practitioner Audience Article",
    "example": True,
    "source code": False})

s11_codes = [react_to_unforeseen_changes_in_the_data, memory_requirements, batch_based_learning, incremental_learning,
             when_and_how_to_train_the_model_decision, online_support, offline_support, speed_performance,
             near_real_time_support, scalability, model_training,
             model_building_tasks_decision, model_building_decision, model_builder_component,
             handling_massive_amounts_of_data,

             variety_of_ml_algorithm_choices,

             data_ingestion_queue, data_ingestion_queue_is_an_data_ingestor,
             data_ingestor, streamed_data_ingestion, streamed_data_ingestion_can_be_realized_by_data_ingestor,
             data_ingestion_decision,

             model_serving_decision, service_based_model_serving, microservice_based_model_serving,
             microservice_based_model_serving_is_a_service_based_model_serving,
             train_multiple_model_versions, model_selection_uses_train_multiple_model_versions,
             model_selection, data_preparation,
             data_processing_tasks_decision,
             containerization, delivery_tasks_decision, in_memory_data_store,
             database_per_service_has_variant_in_memory_data_store,
             shared_database_has_variant_in_memory_data_store, database_per_service,
             shared_database_is_a_shared_data_store,
             shared_database, shared_data_store, store_data_decision,
             serverless_model_as_a_service, serverless_model_as_a_service_is_a_model_as_a_service,
             model_as_a_service, integrating_ml_model_decision,

             monitoring_or_logging_data_and_predictions, monitoring_and_tracking_in_production_decision,

             feature_store, feature_persistence_and_access_decision,
             real_time_feature_api, feature_store_can_include_real_time_feature_api,
             data_access_interface_decision, service_based_data_access_api, local_data_access_api,

             ml_metadata_store, model_builder_component_can_use_ml_metadata_store,
             a_b_testing, what_to_test_decision, data_processing_hyperparameter_tuning, model_hyperparameter_tuning

             ]
add_links({s11: s11_codes}, role_name="contained_code")

s12 = CClass(source, "s12", values={
    "title": "System Architectures for Personalization and Recommendation",
    "url": "https://netflixtechblog.com/system-architectures-for-personalization-and-recommendation-e081aa94b5d8",
    "archive url": "https://tinyurl.com/ml-adds-u12",
    "author type": "Practitioner",
    "type": "Practitioner Audience Article",
    "example": True,
    "source code": False})

s12_codes = [data_ingestion_decision, store_data_decision, shared_data_store, in_memory_data_store,
             shared_database_has_variant_in_memory_data_store, shared_database, shared_database_is_a_shared_data_store,
             model_serving_decision, microservice_based_model_serving, service_based_model_serving,
             microservice_based_model_serving_is_a_service_based_model_serving,
             near_real_time_support, variety_of_ml_algorithm_choices,
             react_to_user_events_and_interactions,
             online_support, offline_support, data_throughput, model_training, model_building_tasks_decision,
             batch_based_learning, when_and_how_to_train_the_model_decision,

             hybrid_online_offline_model_serving_can_use_data_batch_based_model_serving,
             hybrid_online_offline_model_serving_can_use_service_based_model_serving, data_batch_based_model_serving,
             incremental_learning, hybrid_learning, hybrid_learning_can_use_batch_based_learning,
             hybrid_learning_can_use_incremental_learning,

             trigger_pipeline_or_orchestrator_decision, on_schedule_trigger, on_demand_trigger,
             data_access_interface_decision, local_data_access_api, service_based_data_access_api,
             direct_data_provider_access, pub_sub_data_access_api, message_event_queue_based_data_access_api,
             unified_data_access, observability,
             event_driven_model_as_a_service, event_driven_model_as_a_service_is_a_model_as_a_service,
             integrating_ml_model_decision,

             event_store, event_store_is_a_shared_data_store, scalability,

             handling_massive_amounts_of_data
             ]
add_links({s12: s12_codes}, role_name="contained_code")

s13 = CClass(source, "s13", values={
    "title": "Architectural thinking in the Wild West of data science",
    "url": "https://developer.ibm.com/technologies/artificial-intelligence/articles/architectural-thinking-in-the-wild-west-of-data-science/",
    "archive url": "https://tinyurl.com/ml-adds-u13",
    "author type": "Practitioner",
    "type": "Practitioner Audience Article",
    "example": True,
    "source code": False})

s13_codes = [model_building_decision, model_building_in_development_tool, interactive_prototyping,
             production_ready_development, experimental_operational_symmetry, development_agility,
             maintainability, reproducibility, reusability, data_pipeline, data_processing_automation_decision,
             etl_pipeline, data_validation, feature_engineering, data_processing_tasks_decision, model_registry,
             scalability,

             data_preparation, model_validation, model_builder_component, model_building_tasks_decision,
             deploying_model_versions_in_production_decision, single_model_in_production, delivery_tasks_decision,
             deployment, data_warehouse, data_warehouse_is_a_shared_data_store, shared_data_store, store_data_decision,

             automated_provisioning, no_automated_provisioning, provisioning_decision,
             automated_provisioning_can_include_pre_production_environment_provisioning,
             automated_provisioning_can_include_production_environment_provisioning,
             automated_provisioning_can_include_test_environment_provisioning,
             what_to_test_decision, unit_testing_system_components, system_integration_testing,
             unit_testing_feature_engineering_logic, unit_testing_different_methods_implemented_in_a_model,
             testing_trained_model_quality,

             ci_cd_pipeline, automated_integration_and_delivery_decision, ci_cd_pipeline_can_use_model_registry,
             ci_cd_pipeline_enables_automated_provisioning, model_as_a_service, service_based_model_serving,
             microservice_based_model_serving,
             microservice_based_model_serving_is_a_service_based_model_serving, model_serving_decision,
             integrating_ml_model_decision, model_in_monolith,

             a_b_testing,
             monitoring_and_tracking_in_production_decision, model_performance_monitoring,
             monitoring_domain_specific_metrics_per_model,
             model_performance_monitoring_can_use_domain_specific_monitoring,
             hypothesis_testing,
             no_testing,

             data_ingestion_decision, data_ingestion_in_batches, streamed_data_ingestion, data_ingestion_by_request,
             raw_data_store, data_ingestor,
             no_data_processing_automation, data_processing_component,
             batch_or_realtime_data_processing_decision, real_time_data_processing,
             batch_based_data_processing,
             near_real_time_support,
             data_extraction, data_transformation,
             database_per_service, data_service, shared_database,
             feature_persistence_and_access_decision,
             feature_store, store_features_without_specific_support,
             model_building_pipeline, model_training,
             model_as_module_in_modular_monolith,
             offline_support, online_support,

             ]
add_links({s13: s13_codes}, role_name="contained_code")

s14 = CClass(source, "s14", values={
    "title": "Machine Learning Architecture: The Core Components",
    "url": "https://www.datarevenue.com/en-blog/machine-learning-project-architecture",
    "archive url": "https://tinyurl.com/ml-adds-u14",
    "author type": "Practitioner",
    "type": "Practitioner Audience Article",
    "example": False,
    "source code": False})

s14_codes = [data_ingestion_decision, data_ingestion_by_request, data_ingestion_in_batches, streamed_data_ingestion,
             data_ingestor,
             raw_data_store, store_data_decision,
             data_pipeline, data_processing_component,
             data_processing_automation_decision, data_processing_tasks_decision, data_selection,
             data_transformation, data_preparation, data_extraction, feature_engineering,
             model_training, model_building_tasks_decision, data_splitting, model_validation,
             model_selection, model_accuracy,
             ml_orchestrator, automated_integration_and_delivery_decision,
             model_building_pipeline, model_building_decision, model_builder_component,
             model_building_pipeline_can_be_combined_with_ml_orchestrator,
             model_builder_component_can_be_combined_with_ml_orchestrator,
             data_pipeline_can_be_combined_with_ml_orchestrator,
             data_processing_component_can_be_combined_with_ml_orchestrator,
             on_schedule_trigger, trigger_pipeline_or_orchestrator_decision,
             model_as_a_service, model_serving_decision, integrating_ml_model_decision,
             hybrid_online_offline_model_serving, microservice_based_model_serving, service_based_model_serving,
             microservice_based_model_serving_is_a_service_based_model_serving, local_service_api_based_model_serving,
             local_service_api_based_model_serving_is_a_service_based_model_serving,
             provisioning_decision, automated_provisioning, production_environment_provisioning,
             automated_provisioning_can_include_production_environment_provisioning,
             monitoring_and_tracking_in_production_decision, model_performance_monitoring, model_accuracy_monitoring,
             production_data_store, model_performance_monitoring_can_use_production_data_store,
             ml_metadata_store, model_performance_monitoring_requires_ml_metadata_store,
             ]
add_links({s14: s14_codes}, role_name="contained_code")

s15 = CClass(source, "s15", values={
    "title": "Scalable Software and Big Data Architecture - Big Data and Analytics Architectural Patterns",
    "url": "https://www.innoarchitech.com/blog/scalable-software-big-data-analytics-architecture-architectural-design-patterns",
    "archive url": "https://tinyurl.com/ml-adds-u15",
    "author type": "Practitioner",
    "type": "Practitioner Audience Article",
    "example": False,
    "source code": False})

s15_codes = [scalability, data_ingestion_decision, streamed_data_ingestion, raw_data_store, data_ingestor,
             data_processing_automation_decision, data_pipeline, data_processing_tasks_decision,
             store_data_decision, shared_data_store, data_extraction, data_transformation, data_preparation,
             data_access_interface_decision, local_data_access_api,
             model_building_decision, model_building_tasks_decision,
             model_serving_decision,

             in_memory_data_store, shared_database_has_variant_in_memory_data_store, shared_database,
             data_warehouse_is_a_shared_data_store, data_warehouse, data_lake, data_lake_is_a_shared_data_store,
             unified_data_access,

             data_ingestion_in_batches, data_ingestion_by_request,
             data_throughput, low_latency, speed_performance,

             batch_or_realtime_data_processing_decision, real_time_data_processing,
             batch_based_data_processing,
             near_real_time_support, handling_massive_amounts_of_data, process_and_work_automation,
             feature_engineering, feature_store, feature_persistence_and_access_decision,
             feature_store_can_include_real_time_feature_api,
             real_time_feature_api, feature_store_can_include_batch_feature_api,
             batch_feature_api, model_accuracy, etl_pipeline,

             pub_sub_data_access_api, message_event_queue_based_data_access_api,
             model_building_in_development_tool, development_tool_export, model_training,

             deployment_how_to_approach_decision,
             no_automated_deployment
             ]
add_links({s15: s15_codes}, role_name="contained_code")

s16 = CClass(source, "s16", values={
    "title": "Machine Learning in Production: Software Architecture",
    "url": "https://blog.dominodatalab.com/machine-learning-in-production-software-architecture/",
    "archive url": "https://tinyurl.com/ml-adds-u16",
    "author type": "Practitioner",
    "type": "Practitioner Audience Article",
    "example": True,
    "source code": False})

s16_codes = [integrating_ml_model_decision, production_ready_development,

             data_pipeline, data_processing_automation_decision, model_serving_decision, modularity,

             maintainability, low_latency, service_based_model_serving,

             model_as_a_service, microservice_based_model_serving_is_a_service_based_model_serving,
             microservice_based_model_serving, microservice_based_model_serving_uses_model_as_a_service,
             loose_coupling, independent_processing,
             model_in_monolith, independence_of_provisioning, model_as_module_in_modular_monolith,

             deployment_how_to_approach_decision,
             no_automated_deployment
             ]
add_links({s16: s16_codes}, role_name="contained_code")

s17 = CClass(source, "s17", values={
    "title": "AutoML",
    "url": "https://www.ibm.com/cloud/learn/automl",
    "archive url": "https://tinyurl.com/ml-adds-u17",
    "author type": "Practitioner",
    "type": "Practitioner Audience Article",
    "example": False,
    "source code": False})

s17_codes = [explainability, reproducibility, development_velocity, development_agility, auto_ml, no_auto_ml,
             tool_development_effort,
             auto_ml_decision,
             auto_ml_can_use_model_hyperparameter_tuning,
             model_hyperparameter_tuning, auto_ml_can_use_data_processing_hyperparameter_tuning,
             data_processing_hyperparameter_tuning,
             auto_ml_can_use_data_preparation,
             data_preparation,
             auto_ml_can_use_feature_engineering,
             feature_engineering, model_building_tasks_decision,
             data_processing_tasks_decision,
             model_building_pipeline, model_building_decision, data_pipeline, data_processing_automation_decision,

             data_ingestion_decision, model_training, deployment, delivery_tasks_decision,
             monitoring_and_tracking_in_production_decision,
             model_validation, auto_ml_can_use_model_training, auto_ml_requires_model_validation,

             monitoring_domain_specific_metrics_per_model, model_performance_monitoring,
             model_performance_monitoring_can_use_domain_specific_monitoring,
             model_accuracy, model_accuracy_monitoring, model_performance_monitoring_can_use_model_accuracy_monitoring,

             model_selection, auto_ml_can_use_model_selection,

             ]
add_links({s17: s17_codes}, role_name="contained_code")

s18 = CClass(source, "s18", values={
    "title": "AutoML is Overhyped",
    "url": "https://towardsdatascience.com/automl-is-overhyped-1b5511ded65f",
    "archive url": "https://tinyurl.com/ml-adds-u18",
    "author type": "Practitioner",
    "type": "Practitioner Audience Article",
    "example": True,
    "source code": False})

s18_codes = [feature_engineering, data_processing_tasks_decision, data_ingestion_decision, data_preparation,
             model_training, model_building_tasks_decision, model_accuracy, model_validation, model_selection,
             deployment,
             delivery_tasks_decision, monitoring_and_tracking_in_production_decision, model_performance_monitoring,
             model_accuracy_monitoring,
             model_performance_monitoring_can_use_model_accuracy_monitoring,
             monitoring_domain_specific_metrics_per_model,
             model_performance_monitoring_can_use_domain_specific_monitoring,

             model_serving_decision, data_pipeline, data_processing_automation_decision,
             auto_ml, no_auto_ml, auto_ml_decision,
             auto_ml_can_use_model_hyperparameter_tuning,
             model_hyperparameter_tuning, auto_ml_can_use_data_processing_hyperparameter_tuning,
             data_processing_hyperparameter_tuning,
             auto_ml_can_use_data_preparation,
             auto_ml_can_use_feature_engineering,
             auto_ml_can_use_model_training, auto_ml_requires_model_validation,
             auto_ml_can_use_model_selection,

             development_velocity, process_and_work_automation, production_ready_development,

             ensemble_learning,
             when_and_how_to_train_the_model_decision
             ]
add_links({s18: s18_codes}, role_name="contained_code")

s19 = CClass(source, "s19", values={
    "title": "Three Levels of ML Software",
    "url": "https://ml-ops.org/content/three-levels-of-ml-software",
    "archive url": "https://tinyurl.com/ml-adds-u19",
    "author type": "Practitioner",
    "type": "Practitioner Audience Article",
    "example": True,
    "source code": False})

s19_codes = [data_pipeline, data_processing_automation_decision, data_processing_tasks_decision, data_splitting,
             model_building_tasks_decision, data_ingestion_decision, data_validation, data_preparation,
             data_transformation,

             shared_database, shared_database_is_a_shared_data_store,
             store_data_decision, data_warehouse,
             data_warehouse_is_a_shared_data_store, ml_metadata_store, raw_data_store,
             data_ingestion_in_batches_can_use_raw_data_store,
             data_ingestion_in_batches, data_ingestion_by_request_can_use_raw_data_store, data_ingestion_by_request,
             streamed_data_ingestion_can_use_raw_data_store, streamed_data_ingestion, model_selection,

             model_building_pipeline, model_building_decision, model_training, model_validation, model_packaging,
             what_to_test_decision, testing_trained_model_quality, model_building_pipeline_can_use_ml_metadata_store,

             feature_engineering, train_multiple_model_versions, model_accuracy,

             offline_support, online_support, near_real_time_support, react_to_unforeseen_changes_in_the_data,
             when_and_how_to_train_the_model_decision, incremental_learning, batch_based_learning,

             model_serving_decision, data_batch_based_model_serving,
             microservice_based_model_serving, local_service_api_based_model_serving,
             service_based_model_serving, microservice_based_model_serving_is_a_service_based_model_serving,
             local_service_api_based_model_serving_is_a_service_based_model_serving,

             no_integration_of_model, integrating_ml_model_decision, production_ready_development, reusability,

             model_as_a_service, microservice_based_model_serving_uses_model_as_a_service, delivery_tasks_decision,
             deployment, retrain_model,
             retrain_model_can_use_train_multiple_model_versions, manual_model_adjustment, automated_model_adjustment,
             automated_model_adjustment_can_use_retrain_model,
             monitoring_model_adjustment_decision,

             hybrid_learning, hybrid_learning_can_use_batch_based_learning,
             hybrid_learning_can_use_incremental_learning,

             auto_ml, no_auto_ml, auto_ml_decision,
             auto_ml_can_use_model_hyperparameter_tuning,
             model_hyperparameter_tuning,
             auto_ml_can_use_model_training, auto_ml_requires_model_validation,
             auto_ml_can_use_model_selection, development_velocity,

             monitoring_and_tracking_in_production_decision, model_performance_monitoring,
             model_accuracy_monitoring,
             model_performance_monitoring_can_use_model_accuracy_monitoring,
             monitoring_domain_specific_metrics_per_model,
             model_performance_monitoring_can_use_domain_specific_monitoring, observability,

             trigger_pipeline_or_orchestrator_decision,
             on_model_performance_degradation_trigger,

             deployment_how_to_approach_decision, semi_automated_model_deployment,
             ci_cd_pipeline_model_deployment,

             # have to add following decision in order to keep 'ci_cd_pipeline_model_deployment' practice:
             automated_integration_and_delivery_decision,

             independent_development, modularity, loose_coupling,

             model_in_monolith, model_as_module_in_modular_monolith,
             model_as_module_in_modular_monolith_is_a_model_in_monolith,

             precompute_serving,

             hybrid_online_offline_model_serving,
             variety_of_ml_algorithm_choices,
             hybrid_online_offline_model_serving_can_use_data_batch_based_model_serving,
             hybrid_online_offline_model_serving_can_use_service_based_model_serving,

             containerization, model_as_a_service_can_use_containerization,
             serverless_model_as_a_service, serverless_model_as_a_service_is_a_model_as_a_service,

             mlops, mlops_decision, no_mlops,

             ensemble_learning
             ]

add_links({s19: s19_codes}, role_name="contained_code")

s20 = CClass(source, "s20", values={
    "title": "MLOps: Methods and Tools of DevOps for Machine Learning",
    "url": "https://www.altexsoft.com/blog/mlops-methods-tools/",
    "archive url": "https://tinyurl.com/ml-adds-u20",
    "author type": "Practitioner",
    "type": "Practitioner Audience Article",
    "example": False,
    "source code": False})

s20_codes = [data_preparation,
             semi_automated_model_deployment,
             model_training,
             deployment,
             retrain_model,
             ci_cd_pipeline,
             ci_cd_pipeline_model_deployment,
             model_performance_monitoring,
             data_validation,
             model_validation,
             continuous_training,
             continuous_validation,
             division_of_labour,
             process_and_work_automation,
             time_to_market_reduction,
             improve_user_experience,
             improve_customer_satisfaction,
             improve_prediction_quality,
             recognise_model_degradation,
             address_model_degradation,
             reproducibility,
             recognise_data_drift,
             dependable_releases,
             improve_model_management,
             change_tracking,
             shadow_mode_testing,
             model_registry,
             model_as_a_service,
             model_in_monolith,
             model_as_module_in_modular_monolith,
             model_in_batch_prediction_system,
             event_driven_model_as_a_service,
             serverless_model_as_a_service,
             simplified_deployment,
             simplified_model_updates,
             improved_client_heterogeneity,
             improved_support_for_numerous_clients,
             facilitates_testing_in_production,

             no_integration_of_model,
             no_integration_or_delivery_automation,
             data_version_repository,

             mlops_decision,
             mlops,
             no_mlops,

             # have to add following decisions in order to keep above practices:
             trigger_pipeline_or_orchestrator_decision,
             model_building_tasks_decision,
             delivery_tasks_decision,
             automated_integration_and_delivery_decision,
             store_data_decision,
             when_and_how_to_train_the_model_decision,
             integrating_ml_model_decision,

             mlops_can_use_continuous_training,
             mlops_can_use_continuous_validation,
             mlops_can_use_retrain_model,
             mlops_can_use_model_registry,
             mlops_can_use_model_validation,
             mlops_can_use_model_training,
             mlops_can_use_ci_cd_pipeline,
             mlops_enables_deployment,

             # decisions for existing practices
             deploying_how_to_version_data_decision,
             deploying_model_versions_in_production_decision,
             deployment_how_to_approach_decision,
             monitoring_and_tracking_in_production_decision,
             data_processing_tasks_decision,

             n_versions_in_production,
             what_to_test_decision,
             a_b_testing,
             n_versions_in_production_enables_a_b_testing
             ]

add_links({s20: s20_codes}, role_name="contained_code")

s21 = CClass(source, "s21", values={
    "title": "MLOps: What It Is, Why it Matters, and How To Implement It (from a Data Scientist Perspective)",
    "url": "https://neptune.ai/blog/mlops-what-it-is-why-it-matters-and-how-to-implement-it-from-a-data-scientist-perspective",
    "archive url": "https://tinyurl.com/ml-adds-u21",
    "author type": "Practitioner",
    "type": "Practitioner Audience Article",
    "example": False,
    "source code": False})

s21_codes = [data_sourcing,
             data_analysis,
             data_labelling,
             experiment_tracking,
             model_architecture,
             model_development,
             model_evaluation,
             model_versioning,
             model_packaging,
             hardware_scaling,
             training_at_scale,
             model_benchmarking,
             model_management,
             automated_model_development,
             configuration_versioning,
             automated_regression_tests,
             static_code_analysis,
             training_in_production,
             ml_orchestrator,
             no_data_versioning,

             simplified_deployment,
             align_models_with_business_needs,
             align_models_with_regulatory_requirements,
             explainability,
             reusability,
             infrastructure_costs,
             development_agility,
             model_consistency,
             unlock_new_sources_of_revenue,
             save_time,
             reduce_cost,
             management_agility,
             continuous_improvement,
             experimental_operational_symmetry,
             modularity,
             rapid_experimentation,
             improve_prediction_quality,
             improve_model_management,
             reproducibility,
             improve_user_experience,
             time_to_market_reduction,

             on_demand_trigger,
             on_schedule_trigger,
             on_availability_of_new_training_data_trigger,
             on_model_performance_degradation_trigger,
             on_changes_in_the_data_distribution_trigger,

             mlops_decision,
             mlops,
             no_mlops,

             deployment_how_to_approach_decision,
             data_processing_tasks_decision,
             what_to_test_decision,
             model_building_tasks_decision,
             provisioning_decision,
             data_processing_automation_decision,
             store_data_decision,
             data_processing_parallelization_decision,
             model_building_parallelization_decision,
             monitoring_model_adjustment_decision,
             delivery_tasks_decision,
             trigger_pipeline_or_orchestrator_decision,
             deploying_how_to_version_data_decision,

             mlops_can_use_data_sourcing,
             mlops_can_use_data_analysis,
             mlops_can_use_data_labelling,
             mlops_enables_experiment_tracking,
             mlops_can_use_model_architecture,
             mlops_can_use_model_development,
             mlops_can_use_model_evaluation,
             mlops_can_use_model_versioning,
             mlops_can_use_hardware_scaling,
             mlops_enables_training_at_scale,
             mlops_enables_model_benchmarking,
             mlops_can_use_model_management,
             mlops_can_use_automated_model_development,
             mlops_can_use_configuration_versioning,
             mlops_can_use_automated_regression_tests,
             mlops_can_use_static_code_analysis,
             mlops_enables_training_in_production,

             # have to add following decision in order to keep above practices:
             automated_integration_and_delivery_decision
             ]

add_links({s21: s21_codes}, role_name="contained_code")

s22 = CClass(source, "s22", values={
    "title": "MLOps Principles",
    "url": "https://ml-ops.org/content/mlops-principles",
    "archive url": "https://tinyurl.com/ml-adds-u22",
    "author type": "Practitioner",
    "type": "Practitioner Audience Article",
    "example": False,
    "source code": False})

s22_codes = [experimentation,
             prediction_service,
             skew_testing,
             stress_testing,
             system_monitoring,
             application_pipeline,

             a_b_testing,
             prediction_service_api_testing,
             prediction_service_performance_testing,

             trigger_pipeline_or_orchestrator_decision,
             feature_persistence_and_access_decision,
             automated_integration_and_delivery_decision,
             deploying_model_versions_in_production_decision,
             deploying_how_to_version_data_decision,
             delivery_tasks_decision,
             no_data_versioning,
             data_version_repository,
             data_versioning_in_code_repository,

             what_to_test_decision,

             on_demand_trigger,
             on_commit_trigger,
             on_schedule_trigger,
             on_availability_of_new_training_data_trigger,
             on_changes_in_the_data_distribution_trigger,

             reduce_technical_debt,
             iterative_development,
             reproducibility,
             process_and_work_automation,

             mlops_enables_experimentation,
             mlops_enables_prediction_service,

             mlops_can_use_skew_testing,

             mlops_can_use_system_monitoring,
             mlops_can_use_application_pipeline,
             mlops_can_use_stress_testing,
             mlops_can_use_canary_testing,
             mlops_can_use_data_version_repository,
             mlops_can_use_data_versioning_in_code_repository,

             mlops_can_use_a_b_testing,
             mlops_can_use_prediction_service_api_testing,
             mlops_can_use_prediction_service_performance_testing,

             mlops_decision,
             mlops,
             no_mlops,

             auto_ml_decision,
             auto_ml,
             no_auto_ml
             ]

add_links({s22: s22_codes}, role_name="contained_code")

s23 = CClass(source, "s23", values={
    "title": "Machine Learning Monitoring: What It Is, and What We Are Missing",
    "url": "https://towardsdatascience.com/machine-learning-monitoring-what-it-is-and-what-we-are-missing-e644268023ba",
    "archive url": "https://tinyurl.com/ml-adds-u23",
    "author type": "Practitioner",
    "type": "Practitioner Audience Article",
    "example": False,
    "source code": False})

s23_codes = [data_preparation,
             feature_engineering,
             model_training,
             model_evaluation,
             deployment,
             iterative_model_building,
             a_b_testing,
             production_operations,
             production_maintenance,
             production_support,
             model_performance_monitoring,
             speed_performance_monitoring,
             monitoring_or_logging_data_and_predictions,
             monitoring_domain_specific_metrics_per_model,
             model_accuracy_monitoring,
             no_in_production_monitoring,
             model_in_production_tracking,
             model_performance_analysis,
             cross_team_collaboration,
             model_successful_operation,
             model_stability,
             model_performance,
             valuable_models,
             incident_detection,
             incident_resolution,
             fresh_models,
             risk_mitigation,
             manual_model_adjustment,
             automated_model_adjustment,
             align_models_with_business_needs,
             switch_to_other_model_version,
             align_models_with_regulatory_requirements,
             maintainability,
             reduce_cost,
             reliability,
             robustness,

             model_development,
             retrain_model,
             trigger_model_retraining,
             on_model_performance_degradation_trigger,

             mlops,

             # have to add following decisions in order to keep above practices:
             delivery_tasks_decision,
             what_to_test_decision,
             monitoring_and_tracking_in_production_decision,
             monitoring_model_adjustment_decision,
             mlops_decision,
             deployment_how_to_approach_decision,
             data_processing_tasks_decision,
             model_building_tasks_decision,
             trigger_pipeline_or_orchestrator_decision,

             auto_ml_decision,
             auto_ml,
             no_auto_ml
             ]

add_links({s23: s23_codes}, role_name="contained_code")

s24 = CClass(source, "s24", values={
    "title": "Automated monitoring of your machine learning models with Amazon SageMaker Model Monitor and sending predictions to human review workflows using Amazon A2I",
    "url": "https://aws.amazon.com/de/blogs/machine-learning/automated-monitoring-of-your-machine-learning-models-with-amazon-sagemaker-model-monitor-and-sending-predictions-to-human-review-workflows-using-amazon-a2i",
    "archive url": "https://tinyurl.com/ml-adds-u24",
    "author type": "Practitioner",
    "type": "Blog Post",
    "example": False,
    "source code": False})

s24_codes = [deployment,
             no_in_production_monitoring,
             model_performance_monitoring,
             retrain_model,
             system_monitoring,
             production_operations,
             data_sourcing,
             data_validation,
             data_preparation,
             humans_in_the_loop,
             model_performance_analysis,
             model_training,
             model_hyperparameter_tuning,
             prediction_service,
             use_monitoring_schedule,
             set_trigger_conditions_for_human_loop_activation,
             data_labelling,

             recognise_data_drift,
             recognise_model_degradation,
             address_model_degradation,

             # have to add following decisions in order to keep above practices:
             delivery_tasks_decision,
             monitoring_and_tracking_in_production_decision,
             data_processing_tasks_decision,
             model_building_tasks_decision
             ]

add_links({s24: s24_codes}, role_name="contained_code")

s25 = CClass(source, "s25", values={
    "title": "MLOps: Model management, deployment, and monitoring with Azure Machine Learning",
    "url": "https://docs.microsoft.com/en-us/azure/machine-learning/concept-model-management-and-deployment",
    "archive url": "https://tinyurl.com/ml-adds-u25",
    "author type": "Practitioner",
    "type": "Practitioner Audience Article",
    "example": False,
    "source code": False})

s25_codes = [deployment,
             ci_cd_pipeline,
             system_monitoring,
             model_performance_monitoring,
             model_training,
             data_preparation,
             feature_engineering,
             model_hyperparameter_tuning,
             model_evaluation,
             model_building_pipeline,
             packaging,
             model_registry,
             model_service_profiling,
             model_benchmarking,
             model_development,
             model_in_batch_prediction_system,
             model_packaging,
             prediction_service,
             a_b_testing,
             no_testing,
             version_control_repository,
             data_version_repository,
             ml_metadata_store,

             monitoring_or_logging_data_and_predictions,
             retrain_model,
             model_validation,
             automated_model_adjustment,
             on_commit_trigger,
             ci_cd_pipeline_model_deployment,
             data_ingestor,
             development_velocity,
             deployment_velocity,
             reusability,
             auditability,
             explainability,
             improve_prediction_quality,
             model_consistency,
             rapid_experimentation,
             modularity,
             reproducibility,
             align_models_with_regulatory_requirements,
             recognise_data_drift,
             mlops_decision,
             mlops,
             no_mlops,

             # have to add following decisions in order to keep above practices:
             monitoring_model_adjustment_decision,
             deployment_how_to_approach_decision,
             delivery_tasks_decision,
             model_building_decision,
             model_building_tasks_decision,
             monitoring_and_tracking_in_production_decision,
             what_to_test_decision,
             automated_integration_and_delivery_decision,
             integrating_ml_model_decision,
             trigger_pipeline_or_orchestrator_decision,
             data_processing_tasks_decision,

             # decisions for existing practices
             deploying_how_to_version_data_decision,
             deploying_model_versions_in_production_decision,
             ensemble_learning,
             when_and_how_to_train_the_model_decision,

             n_versions_in_production,
             shadow_mode_testing,
             n_versions_in_production_enables_a_b_testing
             ]

add_links({s25: s25_codes}, role_name="contained_code")

s26 = CClass(source, "s26", values={
    "title": "The Pros and Cons of Using Jupyter Notebooks as Your Editor for Data Science Work TL;DR: PyCharm's probably better",
    "url": "https://betterprogramming.pub/pros-and-cons-for-jupyter-notebooks-as-your-editor-for-data-science-work-tip-pycharm-is-probably-40e88f7827cb",
    "archive url": "https://tinyurl.com/ml-adds-u26",
    "author type": "Practitioner",
    "type": "Practitioner Audience Article",
    "example": False,
    "source code": False})

s26_codes = [experimentation,
             use_computational_notebooks,
             use_ide,
             version_control_repository,

             use_computational_notebooks_rules_out_version_control_repository,
             use_computational_notebooks_rules_out_static_code_analysis,
             use_ide_can_use_version_control_repository,

             reusability,
             flexibility,
             rapid_experimentation,
             interactive_prototyping,
             demonstrability,
             ease_of_hosting,
             maintainability,
             development_agility,
             change_tracking,
             use_ide_features,
             development_velocity,
             reduce_technical_debt,
             code_quality,
             reproducibility,

             # have to add following decisions in order to keep above practices:
             delivery_tasks_decision,

             development_environment_decision,

             deployment_how_to_approach_decision,
             no_automated_deployment
             ]

add_links({s26: s26_codes}, role_name="contained_code")

s27 = CClass(source, "s27", values={
    "title": "10 reasons why data scientists love Jupyter notebooks",
    "url": "https://hub.packtpub.com/10-reasons-data-scientists-love-jupyter-notebooks/",
    "archive url": "https://tinyurl.com/ml-adds-u27",
    "author type": "Practitioner",
    "type": "Practitioner Audience Article",
    "example": False,
    "source code": False})

s27_codes = [
    use_computational_notebooks,
    development_environment_decision,

    efficiency,
    development_agility,
    flexibility,
    interactive_prototyping,
    reproducibility,
    demonstrability,

    deployment_how_to_approach_decision,
    no_automated_deployment
]

add_links({s27: s27_codes}, role_name="contained_code")

s28 = CClass(source, "s28", values={
    "title": "5 reasons why jupyter notebooks suck",
    "url": "https://towardsdatascience.com/5-reasons-why-jupyter-notebooks-suck-4dc201e27086",
    "archive url": "https://tinyurl.com/ml-adds-u28",
    "author type": "Practitioner",
    "type": "Practitioner Audience Article",
    "example": False,
    "source code": False})

s28_codes = [use_computational_notebooks,
             data_analysis,
             version_control_repository,
             static_code_analysis,

             cross_team_collaboration,
             testability,
             interactive_prototyping,
             demonstrability,
             development_agility,
             use_ide_features,
             reproducibility,

             # have to add following decisions in order to keep above practices:
             delivery_tasks_decision,
             automated_integration_and_delivery_decision,

             development_environment_decision,

             deployment_how_to_approach_decision,
             no_automated_deployment
             ]

add_links({s28: s28_codes}, role_name="contained_code")

s29 = CClass(source, "s29", values={
    "title": "Jupyter Notebook is the Cancer of ML Engineering",
    "url": "https://medium.com/skyline-ai/jupyter-notebook-is-the-cancer-of-ml-engineering-70b98685ee71",
    "archive url": "https://tinyurl.com/ml-adds-u29",
    "author type": "Practitioner",
    "type": "Practitioner Audience Article",
    "example": False,
    "source code": False})

s29_codes = [use_computational_notebooks,
             use_ide,
             development_environment_decision,
             ml_orchestrator,

             production_ready_development,
             time_to_market_reduction,
             debugging_support,
             explainability,
             tool_development_effort,
             simplified_deployment,
             model_performance,
             demonstrability,
             reduce_technical_debt,
             maintainability,
             development_velocity,
             reproducibility,
             deployment_velocity,
             code_quality,

             # have to add following decisions in order to keep above practices:
             automated_integration_and_delivery_decision
             ]

add_links({s29: s29_codes}, role_name="contained_code")

s30 = CClass(source, "s30", values={
    "title": "Comparing Data Version Control Tools - 2020",
    "url": "https://dagshub.com/blog/data-version-control-tools",
    "archive url": "https://tinyurl.com/ml-adds-u30",
    "author type": "Practitioner",
    "type": "Blog Post",
    "example": False,
    "source code": False})

s30_codes = [deploying_how_to_version_data_decision,

             data_versioning_in_code_repository,
             handling_large_data_files,
             development_velocity,
             flexibility,

             no_data_versioning,
             reproducibility,

             data_version_repository,
             ]

add_links({s30: s30_codes}, role_name="contained_code")

s31 = CClass(source, "s31", values={
    "title": "How to test your ML models from hypothesis to production",
    "url": "https://towardsdatascience.com/how-to-test-your-ml-models-from-hypothesis-to-production-7553430382a9",
    "archive url": "https://tinyurl.com/ml-adds-u31",
    "author type": "Practitioner",
    "type": "Blog Post",
    "example": False,
    "source code": False})

s31_codes = [a_b_testing,
             hypothesis_testing,
             data_splitting,
             model_validation,
             testing,
             no_testing,

             data_versioning_in_code_repository,
             handling_large_data_files,
             development_velocity,
             flexibility,
             no_data_versioning,
             reproducibility,
             data_version_repository,

             ci_cd_pipeline,
             model_selection,
             testing_trained_model_quality,
             continuous_training,
             model_benchmarking,
             monitoring_domain_specific_metrics_per_model,

             shadow_mode_testing,
             experimentation,

             automated_integration_and_delivery_decision,
             delivery_tasks_decision,
             model_building_tasks_decision,
             what_to_test_decision,
             deploying_how_to_version_data_decision
             ]

add_links({s31: s31_codes}, role_name="contained_code")

s32 = CClass(source, "s32", values={
    "title": "Evaluate ML Classifier Performance using Statistical Hypothesis Testing in Python",
    "url": "https://towardsdatascience.com/evaluate-ml-classifier-performance-using-statistical-hypothesis-testing-in-python-e4b90eb27dce",
    "archive url": "https://tinyurl.com/ml-adds-u32",
    "author type": "Practitioner",
    "type": "Blog Post",
    "example": True,
    "source code": False})

s32_codes = [hypothesis_testing,
             ci_cd_pipeline,

             automated_integration_and_delivery_decision,
             delivery_tasks_decision,
             what_to_test_decision,
             ]

add_links({s32: s32_codes}, role_name="contained_code")

s33 = CClass(source, "s33", values={
    "title": "Testing Your Machine Learning Pipelines",
    "url": "https://www.kdnuggets.com/2019/11/testing-machine-learning-pipelines.html",
    "archive url": "https://tinyurl.com/ml-adds-u33",
    "author type": "Practitioner",
    "type": "Blog Post",
    "example": True,
    "source code": False})

s33_codes = [
    testing,
    no_testing,
    experimentation,
    data_pipeline,
    model_building_pipeline,
    model_validation,
    unit_testing_pipeline_components,
    unit_testing_system_components,
    monitoring_domain_specific_metrics_per_model,
    data_transformation,
    model_training,
    data_preparation,
    data_validation,
    feature_engineering,
    unit_testing_feature_engineering_logic,
    unit_testing_different_methods_implemented_in_a_model,
    ci_cd_pipeline,
    code_quality,
    debugging_support,
    maintainability,
    explainability,

    integration_testing_pipeline_components,
    system_integration_testing,
    model_consistency,
    reproducibility,
    modifiability,
    data_usability,

    hypothesis_testing,
    testing_model_training_converges,
    testing_trained_model_quality,
    on_schedule_trigger,
    auditability,
    align_models_with_business_needs,
    align_models_with_regulatory_requirements,
    demonstrability,

    # decisions
    automated_integration_and_delivery_decision,
    delivery_tasks_decision,
    model_building_tasks_decision,
    what_to_test_decision,
    data_processing_tasks_decision,
    trigger_pipeline_or_orchestrator_decision,
    data_processing_automation_decision,
    model_building_decision
]

add_links({s33: s33_codes}, role_name="contained_code")

s34 = CClass(source, "s34", values={
    "title": "Performance Testing ML Serving APIs With Locust",
    "url": "https://www.analyticsvidhya.com/blog/2021/06/performance-testing-ml-serving-apis-with-locust",
    "archive url": "https://tinyurl.com/ml-adds-u34",
    "author type": "Practitioner",
    "type": "Blog Post",
    "example": True,
    "source code": False})

s34_codes = [
    model_performance_monitoring,
    speed_performance_monitoring,
    model_performance_analysis,
    model_as_a_service,
    testing,
    no_testing,
    stress_testing,
    prediction_service_performance_testing,
    prediction_service_api_testing,

    align_models_with_business_needs,
    speed_performance,
    model_accuracy,
    maintainability,

    reduce_cost,

    # decisions
    what_to_test_decision,
    monitoring_and_tracking_in_production_decision,
    delivery_tasks_decision,
    integrating_ml_model_decision
]

add_links({s34: s34_codes}, role_name="contained_code")

s35 = CClass(source, "s35", values={
    "title": "Machine Learning at Scale with Parallel Processing",
    "url": "https://pkghosh.wordpress.com/2017/03/29/machine-learning-at-scale-with-parallel-processing/",
    "archive url": "https://tinyurl.com/ml-adds-u35",
    "author type": "Practitioner",
    "type": "Blog Post",
    "example": True,
    "source code": False})

s35_codes = [
    data_partitioning_in_pipeline,
    training_data_partitioning,
    data_processing_hyperparameter_tuning,
    model_hyperparameter_tuning,
    ensemble_learning,
    error_reduction,
    model_training,
    streamed_data_ingestion,
    real_time_data_processing,

    # relations
    training_data_partitioning_can_be_combined_with_model_hyperparameter_tuning,
    training_data_partitioning_can_be_combined_with_data_processing_hyperparameter_tuning,
    training_data_partitioning_can_be_combined_with_ensemble_learning,

    # forces
    handling_massive_amounts_of_data,
    low_latency,
    near_real_time_support,

    # decisions
    data_ingestion_decision,
    batch_or_realtime_data_processing_decision,
    data_processing_tasks_decision,
    model_building_tasks_decision,
    model_building_parallelization_decision,
    no_data_processing_parallelization,
    data_processing_parallelization_decision,
    when_and_how_to_train_the_model_decision,

    deployment_how_to_approach_decision,
    no_automated_deployment
]

add_links({s35: s35_codes}, role_name="contained_code")
