from codeable_models import CClass, CBundle, add_links
from metamodels.domain_metamodel import domain_metaclass, and_combined_group

ml_model = CClass(domain_metaclass, "Machine Learning Model")
ml_application = CClass(domain_metaclass, "Machine Learning Application")
ml_data_source = CClass(domain_metaclass, "Data Source")

ml_application.association(ml_model, "uses: [applications] * -> [models] *")
ml_application.association(ml_data_source, "uses: [applications] * -> [data sources] *")
ml_model.association(ml_data_source, "trained and test with: [models] * -> [data sources] *")

# define combination of model and application for contexts
model_and_application = CClass(and_combined_group, "Machine Learning Model and Application")
add_links({model_and_application: [ml_model, ml_application]}, role_name="class")

# bundles

_all = CBundle("_all", elements=ml_model.get_connected_elements())

ml_adds_domain_model_views = [_all, {}]
