from metamodels.guidance_metamodel import decision
from plant_uml_renderer import PlantUMLGenerator

from add_models.ml_adds import ml_adds_views, deployment_how_to_approach_decision, model_building_decision, \
    automated_integration_and_delivery_decision, trigger_pipeline_or_orchestrator_decision, \
    deploying_model_versions_in_production_decision, store_data_decision, mlops_decision, delivery_tasks_decision, \
    what_to_test_decision, data_ingestion_decision, deploying_how_to_version_data_decision, \
    model_building_tasks_decision, when_and_how_to_train_the_model_decision, auto_ml_decision, \
    data_access_interface_decision, model_building_parallelization_decision, feature_persistence_and_access_decision, \
    data_processing_automation_decision
from add_models.ml_domain_model import ml_adds_domain_model_views
from generators.generate_latex_files import LatexTableRenderer
from generators.textual_model_rendering import TextualModelRenderer
from add_models.ml_adds_sources_codes import s1

# UML generator
generator = PlantUMLGenerator(delete_gen_dir_during_init=True)
generator.object_model_renderer.name_break_length = 30
generator.object_model_renderer.left_to_right = False

generator.generate_object_models("ml_adds", ml_adds_views)

class_models = {'domain_model': ml_adds_domain_model_views}
for key, value in class_models.items():
    generator.generate_class_models(key, value)

# TextualInfo
textual_model_renderer = TextualModelRenderer()
decisions = [d for d in decision.all_classes]
textual_model_renderer.generate_guidance_evidences(decisions, "ml_adds")
#
# Latex
source_table_renderer = LatexTableRenderer()

generate_complete_table = False
if generate_complete_table:
    source_table_renderer.generate(decisions)

else:
    decisions_deployment_paper = [deployment_how_to_approach_decision,
                                  automated_integration_and_delivery_decision,
                                  delivery_tasks_decision,
                                  trigger_pipeline_or_orchestrator_decision,
                                  deploying_how_to_version_data_decision,
                                  deploying_model_versions_in_production_decision,
                                  mlops_decision]
                                  #what_to_test_decision,
                                  #store_data_decision,

                                  #model_building_decision,
                                  #mlops_decision,
                                  #data_ingestion_decision,
                                  #model_building_tasks_decision,
                                  #when_and_how_to_train_the_model_decision,
                                  #auto_ml_decision,
                                  #data_access_interface_decision,
                                  #model_building_parallelization_decision,
                                  #feature_persistence_and_access_decision,
                                  #data_processing_automation_decision]
    source_table_renderer.generate(decisions_deployment_paper)