# source

## ID

1

## url

https://towardsdatascience.com/how-to-power-up-your-product-by-machine-learning-with-python-microservice-pt-1-de0f2b434bec

https://www.dkisler.com/europython2019/

## archive url

https://tinyurl.com/ml-adds-u1

## title

How to power up your product by machine learning with python microservice, pt. 1

## source code

no

## example

yes

## source type

Practitioner Audience Article

## author type

Practitioner

## references

**AXIAL CODING TRACE**: source and references

``` python
s1 = CClass(source, "s1", values={
    "title": "How to power up your product by machine learning with python microservice, pt. 1",
    "url": "https://towardsdatascience.com/how-to-power-up-your-product-by-machine-learning-with-python-microservice-pt-1-de0f2b434bec",
    "archive url": "TODO",
    "author type": "Practitioner",
    "type": "Practitioner Audience Article",
    "example": True,
    "source code": False})
``` 

# coding

> How to power up your product by machine learning with python microservice, pt. 1 The articles set is a summary of the workshop I gave at Europython2019. Dmitry Kisler

> Dmitry Kisler

> Aug 4, 2019·10 min read

> The main motivation is to show how to conduct data science and machine learning projects and give a hands-on walk through on how to build and integrate machine learning service into software product with microservice oriented architecture.


**OPEN CODING TRACE:**

- microservice for ML

> You may find these articles useful, if you are software engineer working on machine learning project, or data scientist/machine learning engineer/data engineer considering ways to improve your work flow and your models delivery, or project manager trying to connect the dots and improve data product delivery process, or executive manager working towards employing data science and machine learning in your organisation.

**OPEN CODING TRACE:**

- benefit: division of labour

**AXIAL CODING TRACE:**

added:

``` python
division_of_labour = CClass(force, "Division of labour")
```

added codes to source:

```
division_of_labour
```

> The set of articles is being split into different parts. This part, part 1 concerns the background/intro to the topic. Intro

> To start off, let’s define microservices/microservice oriented software architecture and machine learning.

> In a nutshell, microservices is an approach to build software when different functional application parts are independent and communicate via communication protocol over a network. Every application component is isolated and interfaces other components according to service layer agreement, SLA.

> Machine learning, or ML is a cross-disciplinary approach to extract patterns from the data using iterative computational techniques and applying mathematical algorithms. It is a sub-domain of computer science/data science. A machine learning software product follows the flow:

> train: data + result -> rules serve: rules + data -> result

> Why Microservices and Python?

> First off, you may ask yourself two reasonable question, why microservices and why python? I, as pretty much all of us, will use google to answer it :)
Python Image for post Image for post Google trends for python, microservices, machine learning, development and infrastructure related topics. Image for post Image for post Correlation of google trends for python, microservices, machine learning, development and infrastructure related topics.

> As one sees, the community interest in using python, microservices software development, machine learning and DevOps is growing over time, and these areas of interest are highly correlated. In the other words, when people search terms concern microservice, or machine learning, or DevOps topics, it is very likely that python related search terms were queried on google.

> The search trends above, the fact that python is the third most popular general programming language after C and java according to the TIOBE index (as of July’19) and relative simplicity of using python to bootstrap and execute a project makes it to be the leader for machine learning and data science. Microservices Image for post Image for post Google trends for software architecture related topics.

> As for microservice oriented software architecture, it is clear that developers community’s interest is skewed towards microservices against monolithic software architecture.


**OPEN CODING TRACE:**

- microservice for ML vs. monolithic apps

**AXIAL CODING TRACE:**

- coded below

> One of the main advantages of microservices is independency of software product feature services which enables companies for distributed development and improves software scalability. It makes this development approach to be a reasonable architecture choice to integrate machine learning into software product. Data Science/Machine Learning Project Why shall I bother?
>

**OPEN CODING TRACE:**

- benefits: distributed, independent development, scalability

**AXIAL CODING TRACE:**

added:

``` python
distributed_development = CClass(force, "Distributed Development")
independent_development = CClass(force, "Independent Development")
scalability = CClass(force, "Scalability")
```

added codes to source:

``` python
distributed_development, independent_development, scalability
```

> It is a reasonable question to ask as an executive, shall I be bothered by data science, or machine learning for my product at the moment?

> It comes with the followup questions:

> Is my organisation ready to implement machine learning services? What and how shall we improve to get to the point of readiness?

> Image for post Image for post Is my organisation ready for data science/machine learning project?

> The diagram above may be helpful to answer those questions. Let’s follow it:

> First question to answer, if there is already efficient classical solution which delivers result according to business objectives. Classical in this case means that the software product works as “data + predefined business rules = result”. If the answer, is yes, you probably should focus on other problems, or redefine the scope of the current problem prior to employing machine learning for your product. If the answer is no, we go to the point 2. Get a better picture of your resources and understand if you have, or you can afford data science experts to integrate machine learning into your product. If the answer is no, you should de-scope your problem, re-structure your organisation, consider outsourcing, or use of third party service providers for your product. If the answer is yes, we go to the point 3. What about infrastructure? Do we have what is required? Machine learning is very computation heavy and time consuming process, hence to reduce costs, it would require sufficient hardware resources and automated data pipelines. If the answer is no, you should define the strategy to provision, build and maintain infrastructure to build and host data science solutions and machine learning models. If the answer is yes, we go to the point 4.


**OPEN CODING TRACE:**

- supporting practice: automated data pipelines, (automated) provisioning
- not explicitly mentioned, but provisioning can be automated or not, here about production environment, but same goes
  for testing, etc.
- data pipelines automates data processing

**AXIAL CODING TRACE:**

added:

``` python
data_pipeline = CClass(practice, "Data pipeline")
automated_provisioning = CClass(practice, "Automated Provisioning")

provisioning_decision = CClass(decision, "How to automatically provision environments?")
no_automated_provisioning = CClass(do_nothing_design_solution, "No automated provisioning")
add_decision_option_link(automated_integration_and_delivery_in_ml_context_decision, no_automated_provisioning)
add_decision_option_link(automated_integration_and_delivery_in_ml_context_decision, automated_provisioning,
                         "automatically provision environments")


data_processing_automation_decision = CClass(decision, "How to automatically process data?")
no_data_processing_automation = CClass(do_nothing_design_solution, "No data processing automation")
add_decision_option_link(data_processing_automation_decision, no_data_processing_automation)
add_decision_option_link(automated_integration_and_delivery_in_ml_context_decision, data_pipeline, "process data automatically")
```

added codes to source:

``` python
data_pipeline, automated_provisioning, no_automated_provisioning, provisioning_decision
```

**SELECTIVE CODING TRACE**:

- After consulting source s2 added/changed to:

``` python
batch_based_data_processing = CClass(practice, "Batch-based data processing")
real_time_data_processing = CClass(practice, "Real-time, stream-based data processing")

batch_or_realtime_data_processing_decision = CClass(decision, "Should data be processed in batches or in realtime?")
add_decision_option_link(batch_or_realtime_data_processing_decision, batch_based_data_processing)
add_decision_option_link(batch_or_realtime_data_processing_decision, real_time_data_processing)

add_links({batch_or_realtime_data_processing_decision: model_and_application}, role_name="context",
          stereotype_instances=decide_for_some_instances_of)

add_links({data_pipeline: batch_or_realtime_data_processing_decision},
          role_name="next decision", stereotype_instances=consider_if_not_decided_yet)

data_processing_automation_decision = CClass(decision, "How to automatically process the data used for model building?")
no_data_processing_automation = CClass(do_nothing_design_solution, "No data processing automation")
add_decision_option_link(data_processing_automation_decision, no_data_processing_automation)
```

added codes to source:

``` python
batch_based_data_processing, real_time_data_processing, batch_or_realtime_data_processing_decision,  
data_processing_automation_decision, no_data_processing_automation
```

> Do we need all necessary data? Can all data be accessed, are they on one common storage layer? This is a very tricky question and it may require inputs from many teams like Data Engineers, DWH, Product, Developers. This question however is important to clarify because there cannot be data science without data :) If the answer is no, the foremost task prior to data science project execution is to build a unified data layer with clean and easy-to-access data and to automate collection of the data relevant for your business problem. If the answer is yes, we go to the point 5.

**OPEN CODING TRACE:**

- supporting practice:  unified data layer -> data access API (local or remote),
- force: automated data collection, but requires development effort for the tooling
- this force is positively influenced by a data pipeline (i.e. automation of collection steps).

**AXIAL CODING TRACE:**

added:

``` python
unified_data_access = CClass(force, "Unified data access")
tool_development_effort = CClass(force, "Tool development effort")

local_data_access_api = CClass(practice, "Local data access API")
service_based_data_access_api = CClass(practice, "Service-based data access API")
direct_data_provider_access = CClass(do_nothing_design_solution, "Data provider is accessed directly")

service_based_data_access_api_contains_data_services = \
    service_based_data_access_api.add_links(data_service, role_name="to", stereotype_instances=includes,
                                            label="data services and/or wrapper services for other kinds of data stores")[
        0]

data_access_interface_decision = CClass(decision, "How to design the interface for data access? ")

add_decision_option_link(data_access_interface_decision, direct_data_provider_access)
add_decision_option_link(data_access_interface_decision, local_data_access_api,
                         "data provider encapsulated by local data access API abstraction")
add_decision_option_link(data_access_interface_decision, service_based_data_access_api,
                         "data provider encapsulated by data access services")

add_force_relations({direct_data_provider_access: {unified_data_access: negative,

                                                   },
                     local_data_access_api: {unified_data_access: positive,

                                             },
                     service_based_data_access_api: {unified_data_access: positive,

                                                     },
                     })

add_links({data_access_interface_decision: model_and_application}, role_name="context",
          stereotype_instances=decide_for_some_instances_of)

add_links({store_data_decision: data_access_interface_decision},
          role_name="next decision", stereotype_instances=consider_if_not_decided_yet,
          label="offer an abstraction layer for data access")

automated_data_collection = CClass(force, "Automated data collection")

add_force_relations({no_data_processing_automation: {automated_data_collection: very_negative,
tool_development_effort: positive,
                                           },
                     data_pipeline: {automated_data_collection: very_positive,
                     tool_development_effort: negative,
                                             },
                     })
```




added codes to source:

``` python
data_service, local_data_access_api, service_based_data_access_api, 
automated_data_collection, data_access_interface_decision, direct_data_provider_access, 
unified_data_access

```

> How flexible are the work flows in my organisation? Can we adjust to new approach to solve problems? This is by far the trickiest question on the list, it may not have straight yes, or no. However, if your organisation won’t be able to support the mindset of processes and work automation, any of your data science initiatives are likely to fail. For example, if it takes weeks to get access to data, months to get recourses (GPU machines, workstations etc.) for model training, infinite hours of meetings to get sufficient support from business units to scope the problem, even small positive value is unlikely to be generated for your company with machine learning. If the answer is no, your top priority should be reorganisation of your organisation’s work flows to facilitate integration of new approaches to efficiently solve your business problems.
>
**OPEN CODING TRACE:**

- required supporting practice: automated provisioning, in the sense of / similar to delivery pipeline or deployment scripts
- force: process and work automation  (relevant for automated deployment, data pipelines and automated provisioning)
- here focused on: delivery automation combined with data pipeline. (coded below) also CD pipeline or deployment script can use a data pipeline
- model training  

**AXIAL CODING TRACE:**
see below

> If after answering all questions from the flow chart we get to the the final yes, we are ready to get to the point of working on machine learning services and on their integration into the product. Let’s start with the project flow. Data Science/Machine Learning Project Flow Image for post Image for post Data science/machine learning project cycle.

> Data science, or machine learning project’s foremost goal is to solve business problem. It is the foundation of a project, and all to be defined around the problem to be solved. Once it is set, the data science/machine learning project should go according to the cycle:

> The scope and the project objectives to be set by Business Stakeholders, Project Managers and Data Scientists.

> 2. Necessarily data to be prepared. Here, many teams are being involved:

     >   Product/Project Managers and Data Scientists to define data features for modelling. Product people are necessary to be involved to bridge data team with business. Data Engineers and Developers to implement new pipelines to send required data from the product to the data platform. Machine Learning and Data Engineers to setup data pipelines on data platform.

**OPEN CODING TRACE:**

- again data pipeline

> 3. Infrastructure to train and deploy models to be provisioned by the SRE/DevOps and Machine Learning engineers. Once the infrastructure is set, it can of course be reused for other ML projects.

**OPEN CODING TRACE:**

- automated provisioning, CD
- data preparation as part of data processing
- feature engineering as part of data processing

**AXIAL CODING TRACE:**

added:

``` python
process_and_work_automation = CClass(force, "Process and work automation")

ci_cd_pipeline = CClass(practice, "CI/CD pipeline")
build_and_deployment_scripts = CClass(practice, "Build and deployment scripts")

ci_cd_pipeline_can_be_combined_with_data_pipeline = \
    ci_cd_pipeline.add_links(data_pipeline, role_name="to", stereotype_instances=can_be_combined_with)[0]
build_and_deployment_scripts_can_be_combined_with_data_pipeline = \
    build_and_deployment_scripts.add_links(data_pipeline, role_name="to", stereotype_instances=can_be_combined_with)[0]
    
automated_integration_and_delivery_in_ml_context_decision = CClass(decision, "How to automate integration and delivery " +
                                                   "in a machine learning context?")
no_integration_or_delivery_automation = CClass(do_nothing_design_solution, "No integration or delivery automation")
add_decision_option_link(automated_integration_and_delivery_in_ml_context_decision, no_integration_or_delivery_automation)
add_decision_option_link(automated_integration_and_delivery_in_ml_context_decision, build_and_deployment_scripts,
                         "manually perform automated deployments")
add_decision_option_link(automated_integration_and_delivery_in_ml_context_decision, ci_cd_pipeline,
                         "continuously automate the deployment e.g. upon commits")

add_links({automated_integration_and_delivery_in_ml_context_decision: model_and_application}, role_name="context",
          stereotype_instances=decide_for_some_instances_of)  
          
add_force_relations({no_integration_or_delivery_automation: {process_and_work_automation: very_negative,
                                                },
                     build_and_deployment_scripts: {process_and_work_automation: positive, },
                     ci_cd_pipeline: {process_and_work_automation: very_positive, },
                     })
          
        
add_force_relations({no_automated_provisioning: {process_and_work_automation: negative,
                                           },
                     automated_provisioning: {process_and_work_automation: very_positive, },
                     })
                     
# added process_and_work_automation:
add_force_relations({no_data_processing_automation: {automated_data_collection: very_negative,
                                                     process_and_work_automation: negative,
                                                     },
                     data_pipeline: {automated_data_collection: very_positive,
                                                      process_and_work_automation: very_positive,
                     })

data_preparation = CClass(practice, "Data preparation")
add_decision_option_link(data_processing_tasks_decision, data_preparation)
feature_engineering = CClass(practice, "Feature engineering")
add_decision_option_link(data_processing_tasks_decision, feature_engineering)
```

added codes to source:

``` python
 ci_cd_pipeline, ci_cd_pipeline_can_be_combined_with_data_pipeline,
            ci_cd_pipeline_enables_automated_provisioning, build_and_deployment_scripts,
            build_and_deployment_scripts_can_be_combined_with_data_pipeline, automated_integration_and_delivery_in_ml_context_decision,
            no_integration_or_delivery_automation, process_and_work_automation,
            data_preparation, feature_engineering
```

**SELECTIVE CODING TRACE**:

- After adding model building tasks in S2: 

added codes to source:

``` python
model_training, model_building_tasks_decision
```


- After adding decision on what to deploy in S6, added codes to source:

``` python
            semi_automated_model_deployment, 
            no_automated_deployment,
            deploying_what_to_deploy_automatically_decision
```

- While writing automation and CI/CD paper, renamed some variables and reworded some decisions while developing the theory:
`deploying_what_to_deploy_automatically_decision` renamed `deployment_how_to_approach_decision` and wording updated.

`ci_cd_pipeline_can_be_combined_with_data_pipeline = \
    ci_cd_pipeline.add_links(data_pipeline, role_name="to", stereotype_instances=can_be_combined_with)[0]`
becomes:
`ci_cd_pipeline_can_include_data_pipeline = \
    ci_cd_pipeline.add_links(data_pipeline, role_name="to", stereotype_instances=can_include)[0]`

- `semi_automated_model_deployment` can include both data and model building pipelines. Added:
`semi_automated_model_deployment_can_include_data_pipeline = \
    semi_automated_model_deployment.add_links(data_pipeline, role_name="to", stereotype_instances=can_include)[0]`

- CI/CD pipelines in the context of automated provisioning is included during open coding ("automated provisioning, CD".
- Added to source:
`ci_cd_pipeline_model_deployment`

> 4. A step being the cycle itself is called machine learning experiment, it involves data scientists and analysts. The model, or the product of the machine learning project is being defined at this stage of the project.

> 5. The step build model bridges data scientist and machine learning engineers together. The product of machine learning is being built at this stage of the project.

> 6. The final stage of the cycle, the model deployment involves Machine Learning engineers, Developers and Ops/SRE/DevOps engineers. Only once this step is completed, the project can be evaluated by stakeholders. Only at this stage, the result of many teams work can be integrated into the product and hence can influence business. Without this stage, a data science/machine learning project cannot be considered as a project because it would never interface users otherwise. All machine learning project should have deployment as the foremost objective, API first design is one of the useful approaches to follow.

**OPEN CODING TRACE:**

- practice: API first design

- the above is mostly about the project steps, but contains the named practices.
- again, refers to separation of work and roles

**AXIAL CODING TRACE:**

- process aspects not coded (yet)

> Once machine learning model/product was delivered to users, the project can de-scoped, or redefined to improve existing model, or new project can be kicked-off to build a new one. Golden Rules

> There are some rules, I would refer to as golden rules when you conduct a data science/machine learning project:

> 1. Lack of problem specification → infinite time-to-release for the model

     >    If you miss the stage of the project scope, not able to gather requirements from your stakeholders and to set clear business objectives for the problem, you cannot deliver a machine learning solution.

> 2. No infrastructure ≡ not sufficient, or bad data → no, or bad model

     >    You cannot implement any machine learning solution without sufficient data platform, otherwise you very unlikely to have high enough quality of data to be used to extract systematic patterns, to train models and to implement your solution to be serving your users.

> 3. Lean/iterative development → successful ML project ≡ product delivery

**OPEN CODING TRACE:**

- benefit: iterative development
- it is a known benefit of deployment automation (CI/CD, deployment scripts, data pipeline)
  to enable iterative development
- extraction of data in data processing (one of many possible tasks)

**AXIAL CODING TRACE:**

added:

``` python
iterative_development = CClass(force, "Iterative development")

# added iterative_development as forces:

add_force_relations({no_integration_or_delivery_automation: {process_and_work_automation: very_negative,
                                                iterative_development: negative,
                                                },
                     build_and_deployment_scripts: {process_and_work_automation: positive,
                                          iterative_development: positive, },
                     ci_cd_pipeline: {process_and_work_automation: very_positive,
                                      iterative_development: very_positive},
                     })

# added iterative_development as forces:
add_force_relations({no_data_processing_automation: {automated_data_collection: very_negative,
                                                     process_and_work_automation: negative,
                                                     iterative_development: negative,
                                                     },
                     data_pipeline: {automated_data_collection: positive,
                                                      process_and_work_automation: positive,
                                                      iterative_development: positive,
                                                      },
                     })

data_extraction = CClass(practice, "Data extraction")

data_processing_tasks_decision = CClass(decision, "Which data processing tasks can be performed by " +
                                        "data processing pipeline or component?")

add_decision_option_link(data_processing_tasks_decision, data_extraction)

add_links({data_pipeline: data_processing_tasks_decision},
          role_name="next decision", stereotype_instances=consider_if_not_decided_yet,
          label="tasks to be performed by the data pipeline")

```

added codes to source:

``` python
iterative_development, data_extraction, data_processing_tasks_decision
```

> Machine learning can only be efficiently delivered using lean/iterative development approach:

> - Proof of Concept, PoC to be deployed first to test data pipelines infrastructure and to set a model baseline.

**OPEN CODING TRACE:**

- again data pipeline

**SELECTIVE CODING TRACE**:

- Reference to testing pipeline components
``` python
what_to_test_decision, unit_testing_pipeline_components, integration_testing_pipeline_components
```


> - Minimum Viable Product, MVP of the service to be delivered to stakeholders for solution evaluation.

> - Productionised version of the service to be delivered in the end as the final result with monitoring and (automated) model adjustment.

**OPEN CODING TRACE:**

- practices: monitoring, (automated) model adjustment.

**AXIAL CODING TRACE:**

added:

``` python
monitoring = CClass(practice, "Monitoring")
automated_model_adjustment = CClass(practice, "Automated model adjustment")
```

added codes to source:

``` python
monitoring, automated_model_adjustment
```

**SELECTIVE CODING TRACE**:

- changed to more precise modelling from S2:

changed codes to source:

``` python
monitoring_in_production_decision, no_in_production_monitoring,
            model_performance_monitoring, monitoring_model_adjustment_decision, manual_model_adjustment,
            automated_model_adjustment,
```

> Data Platform

> So now, when we defined machine learning project flow, let’s have a look at how machine learning services can be integrated into the product platform and what logical architecture for the data platform can be employed. Image for post Image for post Data platform integration architecture.

**OPEN CODING TRACE:**

- practices: (dedicated) machine learning services
- above contrasted to monolith (which could be modular or not)
- above forces are mentioned, like division of labour, distributed development, independent development, scalability

**AXIAL CODING TRACE:**

- whole section coded below

> The diagram above illustrates two main functional parts of software application, or so-called platforms:

> Product platform with the services communicating to each other and to third party services to deliver value to users/business customers through different interfaces, like web GUI, or REST API end-points. Data platform with services to support internal customers/business stakeholders with sufficient tools to facilitate decisions making by highlighting users activity.

**OPEN CODING TRACE:**

- practices: separate data platform, separate API services/GUI

**AXIAL CODING TRACE:**

- whole section coded below

> Data platform can be broken down into three parts with potentially three teams being involved to maintain them:

> Data Warehouse, or DWH — the part which interfaces the product platform and third party data providers to consolidate all useful data in one persistent data storage and transform loaded raw data to provide pre-defined KPIs and data marts for further consumption by analytics, data science teams and business stakeholders. Data Engineering team is responsible for this part. The team has at least three sets of SLA: DWH-to-BI+Business, DWH-to-Product, DWH-to-DS+Business. Analytics/Business Intelligence Platform, or BI — the part which consumes data from DWH and provides analytics insides to business stakeholders as reporting solutions, for example like dashboards, descriptive and prescriptive ad-hoc analyses. BI and Data Analysis teams are responsible for this part. The team has at least two sets of SLA: BI-to-DWH, BI-to-Business. Data Science Platform, or DS — the part which consumes data from DWH to build data science and machine learning services to improve analytics solutions facing internal customers/business stakeholders, or to implement new product features to improve business value for users/business costumers. Data Science and Machine Learning teams are responsible for this part. The team has at least three sets of SLA: DWH-to-DWH, DS-to-Product, DS-to-Business.
>

**OPEN CODING TRACE:**

- practices: separate data science/ML services and data providers, like data warehouse, BI
- separate data platform (containing data services, data warehouse, BI) and product platform

- data can be stored in shared data stores such as a data warehouse or a data lake or from BI.

- Optional aspects (maybe for later):
    - the data science/machine learning part can also be seen as a data provider
    - any data provider can store data in shared data stored, e.g. here the machine learning/BI results in the data
      warehouse.

-> all can be offered as a services, coded as data_access_interface_decision above.

**AXIAL CODING TRACE:**

added:

``` python
ml_service = CClass(practice, "Machine learning / data science service")
model_in_monolith = CClass(practice, "Model in monolith")
model_as_module_in_modular_monolith = CClass(practice, "Model as module in modular monolith")

model_as_module_in_modular_monolith_is_a_model_in_monolith = \
    model_as_module_in_modular_monolith.add_links(model_in_monolith, role_name="to", stereotype_instances=is_a)[0]

integrating_ml_model_decision = CClass(decision,
                                       "How to integrate a machine learning or data science model in an application?")
add_decision_option_link(integrating_ml_model_decision, ml_service,
                         "create one service per model")
add_decision_option_link(integrating_ml_model_decision, model_in_monolith,
                         "embed the model in the code of the application")
add_decision_option_link(integrating_ml_model_decision, model_as_module_in_modular_monolith,
                         "create a module for the model in the application")

add_force_relations({ml_service: {division_of_labour: very_positive,
                                     distributed_development: very_positive,
                                     independent_development: very_positive,
                                     scalability: very_positive,
                                     offline_capability: negative
                                     },
                     model_in_monolith: {division_of_labour: negative,
                                         distributed_development: negative,
                                         independent_development: negative,
                                         scalability: negative,
                                         offline_capability: very_positive},
                     model_as_module_in_modular_monolith: {division_of_labour: neutral,
                                                           distributed_development: neutral,
                                                           independent_development: neutral,
                                                           scalability: neutral,
                                                           offline_capability: very_positive},
                     })

# context
add_links({integrating_ml_model_decision: model_and_application}, role_name="context",
          stereotype_instances=decide_for_all_instances_of)


############## 
shared_data_store = CClass(practice, "Shared data store")
data_warehouse = CClass(practice, "Data warehouse")
# note modeled as two variants for data warehouse typically used
data_lake = CClass(practice, "Data lake")
shared_database = CClass(practice, "Shared database")

data_warehouse_is_a_shared_data_store = \
    data_warehouse.add_links(shared_data_store, role_name="to", stereotype_instances=is_a)[0]
data_lake_is_a_shared_data_store = \
    data_lake.add_links(shared_data_store, role_name="to", stereotype_instances=is_a)[0]
shared_database_is_a_shared_data_store = \
    shared_database.add_links(shared_data_store, role_name="to", stereotype_instances=is_a)[0]

# context
add_links({data_ingestion_source_decision: model_and_application}, role_name="context",
          stereotype_instances=decide_for_some_instances_of)


store_data_decision = CClass(decision, "How to store data used in machine learning/data science applications?")
no_data_store = CClass(do_nothing_design_solution, "No data store")
add_decision_option_link(store_data_decision, no_data_store, "get data at runtime without storing it")
add_decision_option_link(store_data_decision, shared_data_store,
                         "store data in shared data store")

add_links({data_ingestion_source_decision: [store_data_decision]},
          role_name="next decision", stereotype_instances=consider_if_not_decided_yet)

```

added codes to source:

``` python
ml_service,
model_in_monolith, model_as_module_in_modular_monolith, integrating_ml_model_decision,
model_as_module_in_modular_monolith_is_a_model_in_monolith,
             shared_data_store, data_warehouse, data_lake, shared_database, 
            data_warehouse_is_a_shared_data_store,
            data_lake_is_a_shared_data_store, shared_database_is_a_shared_data_store,
            store_data_decision
```

**SELECTIVE CODING TRACE**:

- Deleted ml_service and used model_as_a_service as an option instead here:
  integrating_ml_model_decision. In model_serving_decision used new service_based_model_serving option

``` python
add_decision_option_link(integrating_ml_model_decision, model_as_as_service,
                         "create one service per model")
```

> Machine Learning Project Delivery

> Results of data science platform can be deployed in (at least) three ways:

> Data batch processing — data science/machine learning service processes data batches on schedule to make a prediction and writes results back to the data storage, or to the analytics platform for further consumption. Reporting — data science/machine learning service generates and delivers a report as for example, dashboard, web-hook message, SMS, or e-mail report. Model as a service, MaaS — data science/machine learning service delivers result of model prediction in real time. It can be integrated into the product platform to communicate with other product feature services, for example to communicate with the items search, or content delivery service.

**OPEN CODING TRACE:**

- practices: machine learning service = Model as a Service
- alternatives on how the data platform can deliver the data: data batch processing, reporting
- benefit: predictions in real time

**AXIAL CODING TRACE:**

- whole section coded below


**SELECTIVE CODING TRACE**:

- added on schedule triggering option as codes:
``` python
          on_schedule_trigger, trigger_pipeline_or_orchestrator_decision
```

> Despite of being one of the most useful ways to deploy your machine learning solution, MaaS is barely covered on the web. For example, there were only 5 (!) model deployment related articles out of total 650 posts published on towardsdatascience.com in 2019 from April till June.

**OPEN CODING TRACE:**

- sounds like motivation for our work :)

> That brings us to the main technical objective of the articles set, an illustration of how to build MaaS. The best way to accomplish this objective is to follow the learn by doing approach. Stay tuned to read the hands-on part of this articles set where I walk you through the steps to build a machine learning model and integrate it as microservice to existing web-application. Summary

> To wrap up, the bullet-points for take-away:

> Python and microservices are reasonable choices of instruments to integrate machine learning into your product. Data science project can only be executed when your organisation is ready for such strategical move, for example if you have common data layer with easy access, follow flexible work flows and can afford data science experts. Golden rules should be satisfied for successful execution of data science projects. First, you should always keep in mind that data science/machine learning is about solving business problem, not about fancy techniques, and lack of project objectives specification tends to project failure. Second, lack of data, or absence of sufficient infrastructure tends to bad, or no data science solution at all. Third, iterative lean approach tends to successful execution of data science/machine learning project. Model as a Service is an efficient, maintainable and scalable way to deliver machine learning solution to your users, or internal clients.

**OPEN CODING TRACE:**

- MaaS benefits: efficient, maintainable and scalable
- (on stores: would offer database per service typically.)

**AXIAL CODING TRACE:**

added:

``` python

model_as_as_service = CClass(practice, "Model as a service")
data_batch_based_model_serving = CClass(practice, "Data batch based model serving")
model_result_reporting = CClass(practice, "Result reporting")

scalability = CClass(force, "Scalability")
near_real_time_support = CClass(force, "Near real-time support")
efficiency = CClass(force, "Efficiency")
maintainability = CClass(force, "Maintainability")

model_serving_decision = CClass(decision,"How to serve model predictions or scores?")
add_decision_option_link(model_serving_decision, microservice_based_model_serving,
                         "deliver predictions or scores in real time by distributed service")
add_decision_option_link(model_serving_decision, local_service_api_based_model_serving,
                         "deliver predictions or scores in real time by local service")
add_decision_option_link(model_serving_decision, data_batch_based_model_serving,
                         "process data in batches on schedule and write predictions or scores to data storage")
add_decision_option_link(model_serving_decision, model_result_reporting,
                         "generate and deliver reports e.g. in dashboards, SMS, or emails")

add_force_relations({model_as_as_service: {near_real_time_support: very_positive,
                                           efficiency: positive,
                                           maintainability: positive,
                                           scalability: very_positive,
                                           },
                     data_batch_based_model_serving: {near_real_time_support: very_negative,
                                             efficiency: very_negative,
                                             maintainability: negative,
                                             scalability: very_negative, },
                     model_result_reporting: {near_real_time_support: negative,
                                        efficiency: negative,
                                        maintainability: negative,
                                        scalability: very_negative},
                     })

# context
add_links({model_serving_decision: model_and_application}, role_name="context",
          stereotype_instances=decide_for_some_instances_of)


```

added codes to source:

``` python
model_as_as_service, data_batch_based_model_serving, model_result_reporting, model_serving_decision,
near_real_time_support, efficiency, maintainability, database_per_service

```

**SELECTIVE CODING TRACE**:

- Used model_as_a_service as an option instead in integrating_ml_model_decision (see above). Here used new option
  service_based_model_serving and linked to it.

``` python
service_based_model_serving = CClass(practice, "Service based model serving")
service_based_model_serving_can_use_model_as_as_service = \
    service_based_model_serving.add_links(model_as_a_service, role_name="to", stereotype_instances=can_use,
                                        label = "distributed service or microservice")[0]
                               
add_decision_option_link(model_serving_decision, service_based_model_serving,
                         "deliver results in real time")
```

- After studying s2 and s3, options should be to support both services or APIs locally and in distributed fashion, using
  either the MaaS or the modular monolith options. Changed to:

``` python
service_based_model_serving = CClass(practice, "Service based model serving")
microservice_based_model_serving = CClass(practice, "Microservice based model serving")
local_service_api_based_model_serving = CClass(practice, "Local service/API based model serving")
data_batch_based_model_serving = CClass(practice, "Data batch based model serving")
model_result_reporting = CClass(practice, "Model result reporting")

microservice_based_model_serving_uses_model_as_a_service = \
    microservice_based_model_serving.add_links(model_as_a_service, role_name="to", stereotype_instances=uses,
                                          label="distributed service or microservice")[0]

local_service_api_based_model_serving_uses_model_as_a_service = \
    local_service_api_based_model_serving.add_links(model_as_module_in_modular_monolith, role_name="to",
                                           stereotype_instances=uses, label="service as local module")[0]

microservice_based_model_serving_is_a_service_based_model_serving = \
    microservice_based_model_serving.add_links(microservice_based_model_serving, role_name="to", stereotype_instances=is_a)[0]
local_service_api_based_model_serving_is_a_service_based_model_serving = \
    local_service_api_based_model_serving.add_links(microservice_based_model_serving, role_name="to", stereotype_instances=is_a)[0]

model_serving_decision = CClass(decision,
                                           "How to provide prediction results of machine learning" +
                                           " or data science model?")
add_decision_option_link(model_serving_decision, microservice_based_model_serving,
                         "deliver results in real time by distributed service")
add_decision_option_link(model_serving_decision, local_service_api_based_model_serving,
                         "deliver results in real time by local service")
add_decision_option_link(model_serving_decision, data_batch_based_model_serving,
                         "process data in batches on schedule and write results to data storage")
add_decision_option_link(model_serving_decision, model_result_reporting,
                         "generate and deliver reports e.g. in dashboards, SMS, or emails")

add_force_relations({microservice_based_model_serving: {near_real_time_support: very_positive,
                                                   efficiency: positive,
                                                   maintainability: very_positive,
                                                   scalability: very_positive,
                                                   online_support: very_positive,
                                                   offline_support: negative
                                                   },
                     local_service_api_based_model_serving: {near_real_time_support: very_positive,
                                                    efficiency: neutral,
                                                    maintainability: positive,
                                                    scalability: neutral,
                                                    online_support: very_positive,
                                                    offline_support: positive
                                                    },
                     data_batch_based_model_serving: {near_real_time_support: very_negative,
                                             efficiency: very_negative,
                                             maintainability: negative,
                                             scalability: very_negative,
                                             online_support: negative,
                                             offline_support: positive
                                             },
                     model_result_reporting: {near_real_time_support: negative,
                                        efficiency: negative,
                                        maintainability: negative,
                                        scalability: very_negative,
                                        online_support: negative,
                                        offline_support: positive
                                        },
                     })
```

added codes to source:

``` python
            microservice_based_model_serving, local_service_api_based_model_serving,
            microservice_based_model_serving_is_a_service_based_model_serving,
            local_service_api_based_model_serving_is_a_service_based_model_serving,
            local_service_api_based_model_serving_uses_model_as_a_service,
            microservice_based_model_serving_uses_model_as_a_service, 
```

**SELECTIVE CODING TRACE**:

changed model_result_reporting to precompute_serving in S19:


``` python
precompute_serving = CClass(practice, "Precompute serving")
add_decision_option_link(model_serving_decision, precompute_serving,
                         "precompute models e.g. as forecasts and deliver as reports")

```
