# source
## ID
14
## url
https://www.datarevenue.com/en-blog/machine-learning-project-architecture

## archive url
https://tinyurl.com/ml-adds-u14
## title
Machine Learning Architecture: The Core Components
## source code
no
## example
no
## source type 
Practitioner Audience Article
## author type
Practitioner
## references

**AXIAL CODING TRACE**: source and references
``` python
s14 = CClass(source, "s14", values={
    "title": "Machine Learning Architecture: The Core Components",
    "url": "https://www.datarevenue.com/en-blog/machine-learning-project-architecture",
    "archive url": "TODO",
    "author type": "Practitioner",
    "type": "Practitioner Audience Article",
    "example": False,
    "source code": False})
``` 

# coding

>Machine Learning Architecture: The Core Components

>The 11 fundamental building blocks that make up any machine learning solution
datarevenue-icon
by
Markus Schmitt

>Machine learning solutions are used to solve a wide variety of problems, but in nearly all cases the core components are the same. Whether you simply want to understand the skeleton of machine learning solutions better or are embarking on building your own, understanding these components - and how they interact - can help.

>Here’s a visual and written explanation of what these are and what they do.
A diagram showing the components of a machine learning solution.
Machine learning consists of many components, not just an algorithm. (Want more content like this? Subscribe to our newsletter).

>‍The components of a machine learning solution

>    Data Generation: Every machine learning application lives off data. That data has to come from somewhere. Usually it’s generated by one of your core business functions.
> 

**OPEN CODING TRACE:**
- data ingested (generated) from core business functions (possibly in batches, by request, or streaming); component: data ingestor

>    Data Collection: Data is only useful if it’s accessible, so it needs to be stored – ideally in a consistent structure and conveniently in one place.

**OPEN CODING TRACE:**
- data collection in store

>    Feature Engineering Pipeline: Algorithms can't make sense of raw data. We have to select, transform, combine, and otherwise prepare our data so the algorithm can find useful patterns.

**OPEN CODING TRACE:**
- data pipeline or processing component
- data prep., transform., and selection, extract from raw data
- implies feature engineering (Feature Engineering Pipeline)

>    Training: This is where the magic happens. We apply algorithms, and they learn patterns from the data. Then they use these patterns to perform particular tasks.

**OPEN CODING TRACE:**
- model training

>    Evaluation: We need to carefully test how well our algorithm performs on data it hasn’t seen before (during training). This ensures we don’t use prediction models that work well on “seen” data, but not in real-world settings.

**OPEN CODING TRACE:**
- model validation (for accuracy), splitting data

>    Task Orchestration: Feature engineering, training, and prediction all need to be scheduled on our compute infrastructure (such as AWS or Azure) – usually with non-trivial interdependence. So we need to reliably orchestrate our tasks.

**OPEN CODING TRACE:**
- Task Orchestration
- model training needs some automation to be orchestrated, i.e in component or pipeline
- scheduled execution
- runs on AWS: model as a service

>    Prediction: This is the moneymaker. We use the model we’ve trained to perform new tasks and solve new problems – which usually means making a prediction.
>

**OPEN CODING TRACE:**
- model serving decision
- runs on AWS, at least some: model as a service, microservice-based, possibly local service or hybrid, too.

> 
>    Infrastructure: Even in the age of the cloud, the solution has to live and be served somewhere. This will require setup and maintenance. 

**OPEN CODING TRACE:**
- provisioning, at least a production env. in the cloud.

>    Authentication: This keeps our models secure and makes sure only those who have permission can use them.
>    Interaction: We need some way to interact with our model and give it problems to solve. Usually this takes the form of an API, a user interface, or a command-line interface.‍

**OPEN CODING TRACE:**
- out of scope/general architecture

>    Monitoring: We need to regularly check our model’s performance. This usually involves periodically generating a report or showing performance history in a dashboard.

**OPEN CODING TRACE:**
- monitoring of performance of the model
- report generation with history requires production data store or metadata store


**AXIAL CODING TRACE:**
(FOR ALL ABOVE)

added codes to source:

``` python
data_ingestion_decision, data_ingestion_by_request, data_ingestion_in_batches, streamed_data_ingestion,
             data_ingestor,
             raw_data_store, store_data_decision,
             data_pipeline, data_processing_component,
             data_processing_automation_decision, data_processing_tasks_decision, data_selection,
             data_transformation, data_preparation, data_extraction, feature_engineering,
             model_training, model_building_tasks_decision, data_splitting, model_validation,
             model_selection, model_accuracy,
             ml_orchestrator, automated_integration_and_delivery_decision, 
             model_building_pipeline, model_building_decision, model_builder_component,
             model_building_pipeline_can_be_combined_with_ml_orchestrator,
             model_builder_component_can_be_combined_with_ml_orchestrator,
             data_pipeline_can_be_combined_with_ml_orchestrator,
             data_processing_component_can_be_combined_with_ml_orchestrator,
             on_schedule_trigger, trigger_pipeline_or_orchestrator_decision,
             model_as_a_service, model_serving_decision, integrating_ml_model_decision,
             hybrid_online_offline_model_serving, microservice_based_model_serving, service_based_model_serving,
             microservice_based_model_serving_is_a_service_based_model_serving, local_service_api_based_model_serving,
             local_service_api_based_model_serving_is_a_service_based_model_serving,
             provisioning_decision, automated_provisioning, production_environment_provisioning,
             automated_provisioning_can_include_production_environment_provisioning,
             monitoring_and_tracking_in_production_decision, model_performance_monitoring, model_accuracy_monitoring,
             production_data_store, model_performance_monitoring_can_use_production_data_store,
             ml_metadata_store, model_performance_monitoring_requires_ml_metadata_store,
```


>Building your own ML Architecture

>Data generation and collection, training, and evaluation are must-haves, but you may need domain-specific components too.

>A common mistake we see is people focussing too much on the prediction component and not enough on the feature engineering pipeline (or trying to skip this component completely).

>Do you need a second opinion on how to set up the architecture for your ML applications? Schedule a call with us.


**OPEN CODING TRACE:**
- summary
