# source

## ID

2

## url

https://towardsdatascience.com/architecting-a-machine-learning-pipeline-a847f094d1c7

## archive url

TODO

## title

Architecting a Machine Learning Pipeline:
How to build scalable Machine Learning systems — Part 2/2

## source code

no

## example

no

## source type

Practitioner Audience Article

## author type

Practitioner

## references

**AXIAL CODING TRACE**: source and references

``` python
s2 = CClass(source, "s2", values={
    "title": "Architecting a Machine Learning Pipeline: How to build scalable Machine Learning systems — Part 2/2",
    "url": "https://towardsdatascience.com/architecting-a-machine-learning-pipeline-a847f094d1c7",
    "archive url": "https://tinyurl.com/ml-adds-u2",
    "author type": "Practitioner",
    "type": "Practitioner Audience Article",
    "example": True,
    "source code": False})
``` 

# coding

> Data Science in the Real World Architecting a Machine Learning Pipeline How to build scalable Machine Learning systems — Part 2/2 Semi Koen

> Semi Koen

> Apr 5, 2019·18 min read Image for post Image for postImage for post Preface

> When developing a model, data scientists work in some development environment tailored for Statistics and Machine Learning (Python, R etc) and are able to train and test models all in one ‘sandboxed’ environment while writing relatively little code. This is great for building interactive prototypes with fast time to market — they are not productionised, low latency systems though!

**OPEN CODING TRACE:**

- machine learning model trained in a sandbox, not in a pipeline
- forces: interactive prototyping, fast time to market, productionised (explained in bulled list below what it means)

> This is the 2nd in a series of articles, namely ‘Being a Data Scientist does not make you a Software Engineer!’, which covers how you can architect an end-to-end scalable Machine Learning (ML) pipeline. Revision Being a Data Scientist does not make you a Software Engineer!
How to build scalable Machine Learning systems — Part 1/2

> towardsdatascience.com

> Hopefully you have gone through the 1st part of the series, where we introduced the basic architectural styles, design patterns and the SOLID principles. Image for post Image for postImage for post

> 📌 TL;DR: In case you haven’t read it, let’s repeat the ‘holy grail’ — i.e. the problem statement that a production-ready ML system should try to address:

> The main objectives are to build a system that:
▸ Reduces latency; ▸ Is integrated but loosely coupled with the other parts of the system, e.g. data stores, reporting, graphical user interface; ▸ Can scale both horizontally and vertically; ▸ Is message driven i.e. the system communicates via asynchronous, non-blocking message passing; ▸ Provides efficient computation with regards to workload management; ▸ Is fault-tolerant and self healing i.e. breakdown management; ▸ Supports batch and real-time processing. Image for post Image for postImage for post

**OPEN CODING TRACE:**

- forces: low latency in the sense of Near real-time support, loosely coupled (data stores, reporting, UI), scalability,
  fault-tolerant/self-healing?
- practices batch and real-time processing

**SELECTIVE CODING TRACE**:

- Added forces interactive_prototyping, low_latency, loose_coupling, and scalability to model_building_decision

added:

``` python
loose_coupling= CClass(force, "Loose coupling")
interactive_prototyping = CClass(force, "Interactive prototyping")
```

added codes to source:

``` python
interactive_prototyping, low_latency, loose_coupling, scalability 
```

> 🎦 Scene Setting: So by now you have seen the fundamental concepts of Software Engineering and you already are a seasoned Data Scientist.

> Without further ado, let’s put two and two together…

> For each of the ML Pipeline steps I will be demonstrating how to design a production-grade architecture. I will intentionally not be referring to any specific technologies (apart from a couple of times that I give some examples for demonstration purposes).

> ✏️ N.B.: If you need to refresh on the ML pipeline steps, take a look at this resource. Image for post Image for postImage for post ML Pipeline Architecting a ML Pipeline

> Traditionally, pipelines involve overnight batch processing, i.e. collecting data, sending it through an enterprise message bus and processing it to provide pre-calculated results and guidance for next day’s operations. Whilst this works in some industries, it is really insufficient in others, and especially when it comes to ML applications.

**OPEN CODING TRACE:**

- batch processing data pipeline
- force: works well with large data over night

**AXIAL CODING TRACE:**
batch processing pipeline and offline support coded below

**SELECTIVE CODING TRACE**:
Pipelines based on batched data discussed (thus including learning/training).

added codes to source:

``` python
batch_based_learning, when_and_how_to_train_the_model_decision,
```
> The following diagram shows a ML pipeline applied to a real-time business problem where features and predictions are time sensitive (e.g. Netflix’s recommendation engines, Uber’s arrival time estimation, LinkedIn’s connections suggestions, Airbnb’s search engines etc). Image for post Image for postImage for post Real-Time ML

> It comprises of two clearly defined components:

> Online Model Analytics: The top row represents the operational component of the application i.e. where the model is applied for real-time decision making.
> Offline Data Discovery: The bottom row represents the learning component i.e. analysis on historical data to create the ML model in a batch-processing mode.

**OPEN CODING TRACE:**

- model building in batch processing model
- realtime predictions (requires data that gets ingested)
- automated model update through batch processing ML Model building
- here model building pipeline is different from data pipeline, in S1 it was part of
- mentions serving ml predictions online vs. offline
- in shown pipeline model: data processing is part of model building, but could also be called in separate pipeline or component

**AXIAL CODING TRACE:**

online vs. offline coded below

added:

``` python
model_building_pipeline = CClass(practice, "Model building pipeline")
model_building_in_development_tool = CClass(practice, "Model building in development tool")
model_building_pipeline_can_contain_data_pipeline = \
    model_building_pipeline.add_links(data_pipeline, role_name="to", stereotype_instance=can_include)[0]
    
model_building_decision = CClass(decision, "How to perform model building in an ML project?")
add_decision_option_link(model_building_decision, model_building_in_development_tool,
                         "model building performed in development sandbox")
add_decision_option_link(model_building_decision, model_building_pipeline,
                         "model training, evaluation, and validation in automated pipeline")
                         
add_links({model_building_decision: data_processing_automation_decision},
          role_name="next decision", stereotype_instances=consider_if_not_decided_yet,
          label="how to automate data processing tasks used by or part of model building")                        

add_links({model_serving_decision: data_ingestion_decision},
          role_name="next decision", stereotype_instances=consider_if_not_decided_yet,
          label="ingest data required during model serving")
```

added codes to source:

``` python
model_building_pipeline, batch_or_realtime_data_processing_decision, batch_based_data_processing,
 data_pipeline, model_building_decision,
data_processing_automation_decision, model_serving_decision, model_building_in_development_tool
```

**SELECTIVE CODING TRACE**:
- While writing automation and CI/CD paper
- Based on sources coming after this one, the model building pipeline is actually distinct from data pipeline, and they can be used in combination:

`model_building_pipeline_can_contain_data_pipeline = \
    model_building_pipeline.add_links(data_pipeline, role_name="to", stereotype_instance=can_include)[0]`
becomes:
`model_building_pipeline_can_be_combined_with_data_pipeline = \
    model_building_pipeline.add_links(data_pipeline, role_name="to", stereotype_instance=can_be_combined_with)[0]`

- the CI/CD pipeline MAY include a model building or data pipeline
`ci_cd_pipeline_model_deployment_realizes_model_building_pipeline = \
    ci_cd_pipeline_model_deployment.add_links(model_building_pipeline, role_name="to", stereotype_instances=realizes)[
        0]`
becomes:
ci_cd_pipeline_model_deployment_can_include_model_building_pipeline = \
    ci_cd_pipeline_model_deployment.add_links(model_building_pipeline, role_name="to", stereotype_instances=can_include)[
        0]
`ci_cd_pipeline_model_deployment_realizes_data_pipelines = \
    ci_cd_pipeline_model_deployment.add_links(data_pipeline, role_name="to", stereotype_instances=realizes)[0]`
becomes:
ci_cd_pipeline_model_deployment_can_include_data_pipelines = \
    ci_cd_pipeline_model_deployment.add_links(data_pipeline, role_name="to", stereotype_instances=can_include)[0]

The semi-automated pipelines MAY include a model building or data pipeline Added:
``` python
semi_automated_model_deployment_can_include_model_building_pipeline = \
    semi_automated_model_deployment.add_links(model_building_pipeline, role_name="to", stereotype_instances=can_include)[
        0]
semi_automated_model_deployment_can_include_data_pipelines = \
    semi_automated_model_deployment.add_links(data_pipeline, role_name="to", stereotype_instances=can_include)[0]
```

Added to source:
`ci_cd_pipeline_model_deployment`

> We will now take this simplified diagram and unfold its inner workings. — ①: Data Ingestion

> Data collection. Image for post Image for postImage for post

> Funnelling incoming data into a data store is the first step of any ML workflow. The key point is that data is persisted without undertaking any transformation at all, to allow us to have an immutable record of the original dataset. Data can be fed from various data sources; either obtained by request (pub/sub) or streamed from other services.

**OPEN CODING TRACE:**

- incoming data can be obtained by request or streamed from other services
- stored unaltered in data store
- introduced in the ML workflow aka the data processing of it

**AXIAL CODING TRACE:**

added:

``` python
streamed_data_ingestion = CClass(practice, "Streamed data ingestion")
data_ingestion_by_request = CClass(practice, "Data ingestion by request")

data_ingestion_decision = CClass(decision, "How to ingest data into ML projects or applications?")
add_decision_option_link(data_ingestion_decision, streamed_data_ingestion,
                         "receive a continuous stream of data")
add_decision_option_link(data_ingestion_decision, data_ingestion_by_request,
                         "actively get raw data from data sources")
add_links({data_ingestion_decision: model_and_application}, role_name="context",
          stereotype_instances=decide_for_some_instances_of)
          
add_links({data_ingestion_decision: [store_data_decision]},
          role_name="next decision", stereotype_instances=consider_if_not_decided_yet,
          label="how to store raw ingested data")
          
add_links({data_processing_automation_decision: data_ingestion_decision},
          role_name="next decision", stereotype_instances=consider_if_not_decided_yet,
          label="ingest data for data processing and later model building")
```

added codes to source:

``` python
streamed_data_ingestion, data_ingestion_by_request, data_ingestion_decision
```

**SELECTIVE CODING TRACE**:
- added raw data store can changed link to store_data_decision to be linked from it 

``` python
raw_data_store = CClass(practice, "Raw data store")

streamed_data_ingestion_can_use_raw_data_store = \
    streamed_data_ingestion.add_links(raw_data_store, role_name="to", stereotype_instances=can_use)[0]
data_ingestion_by_request_can_use_raw_data_store = \
    data_ingestion_by_request.add_links(raw_data_store, role_name="to", stereotype_instances=can_use)[0]
    
add_links({raw_data_store: [store_data_decision]},
          role_name="next decision", stereotype_instances=consider_if_not_decided_yet,
          label="how to store raw ingested data")
```

- added codes to source:

``` python
raw_data_store, streamed_data_ingestion_can_use_raw_data_store,
data_ingestion_by_request_can_use_raw_data_store, 
```


> NoSQL document databases are ideal for storing large volumes of rapidly changing structured and/or unstructured data, since they are schema-less. They also offer a distributed, scalable, replicated data storage. Offline

**OPEN CODING TRACE:**

- forces: distributed, scalable, replicated for data stores

**AXIAL CODING TRACE:**

- rather specific for the type of data store

> In the offline layer, data flows into the Raw Data Store via an data ingestor — a composite orchestration service, which encapsulates the data sourcing and persistence. Internally, a repository pattern is employed to interact with a data service, which in return interacts with the data store. When the data is saved in the database, a unique batch-id is assigned to the dataset, to allow for efficient querying and end-to-end data lineage and traceability.

**OPEN CODING TRACE:**

- practice: data ingestor encapsulates data sourcing and persistence, uses data stores

**AXIAL CODING TRACE:**

added:

``` python
data_ingestor = CClass(practice, "Data Ingestor")

# link to data sourcing options
streamed_data_ingestion_can_be_realized_by_data_ingestor = \
    streamed_data_ingestion.add_links(data_ingestor, role_name="to", stereotype_instances=can_be_realized_by,
                                      label="data ingestion service or component")[0]
data_ingestion_by_request_can_be_realized_by_data_ingestor = \
    data_ingestion_by_request.add_links(data_ingestor, role_name="to", stereotype_instances=can_be_realized_by,
                                        label="data ingestion service or component")[0]

# link to persistence options
add_links({...
           data_ingestion_decision: [store_data_decision]},
          role_name="next decision", stereotype_instances=consider_if_not_decided_yet)

```

added codes to source:

``` python
data_ingestor, streamed_data_ingestion_can_be_realized_by_data_ingestor, data_ingestion_by_request_can_be_realized_by_data_ingestor
```

> To be performant, the ingestion distribution is twofold:

> • there is a dedicated pipeline for each dataset so all of them are processed independently and concurrently, and • within each pipeline, the data is partitioned to take advantage of the multiple server cores, processors or even servers.


> Spreading the data preparation across multiple pipelines, horizontally and vertically, reduces the overall time to complete the job. Image for post Image for postImage for post

**OPEN CODING TRACE:**

- data pipeline per data set -> forces +: processed independently and concurrently (reduces the overall time to complete
  the job)
- data partitioning in pipeline -> force + concurrency (reduces the overall time to complete the job)
- force reduces the overall time to complete the job = here = data throughput, execution speed performance, and low
  latency
  (see also discussion below)
- data preparation

**AXIAL CODING TRACE:**

added:

``` python
data_pipeline_per_data_set = CClass(practice, "Data pipeline per data set")
data_partitioning_in_pipeline = CClass(practice, "Data partitioning in data pipeline")
hybrid_data_processing_parallelization = CClass(practice, "Hybrid data processing parallelization")

data_processing_parallelization_decision = CClass(decision, "How to parallelize data processing?")
no_data_processing_parallelization = CClass(do_nothing_design_solution, "No parallel data processing")
add_decision_option_link(data_processing_parallelization_decision, no_data_processing_parallelization)
add_decision_option_link(data_processing_parallelization_decision, data_pipeline_per_data_set,
                         "dedicated pipeline for each dataset")
add_decision_option_link(data_processing_parallelization_decision, data_partitioning_in_pipeline,
                         "within a pipeline, the data is partitioned to benefit from parallel processing")
add_decision_option_link(data_processing_parallelization_decision, hybrid_data_processing_parallelization,
                         "combining one or more of the other parallelization options")

hybrid_data_processing_parallelization_can_use_data_pipeline_per_data_set = \
    hybrid_data_processing_parallelization.add_links(data_pipeline_per_data_set, role_name="to",
                                                     stereotype_instances=can_use)[0]

hybrid_data_processing_parallelization_can_use_data_partitioning_in_pipeline = \
    hybrid_data_processing_parallelization.add_links(data_partitioning_in_pipeline, role_name="to",
                                                     stereotype_instances=can_use)[0]

add_force_relations({no_data_processing_parallelization: {data_throughput: very_negative,
                                                          speed_performance: very_negative,
                                                          low_latency: negative,
                                                          independent_processing: very_negative},
                     data_pipeline_per_data_set: {data_throughput: positive,
                                                  speed_performance: positive,
                                                  low_latency: positive,
                                                  independent_processing: very_positive},
                     data_partitioning_in_pipeline: {data_throughput: positive,
                                                     speed_performance: positive,
                                                     low_latency: positive,
                                                     independent_processing: neutral},
                     hybrid_data_processing_parallelization: {data_throughput: very_positive,
                                                     speed_performance: very_positive,
                                                     low_latency: very_positive,
                                                     independent_processing: very_positive},
                     })

add_links({data_processing_automation_decision: data_processing_parallelization_decision},
          role_name="next decision", stereotype_instances=consider_if_not_decided_yet)

```

added codes to source:

``` python
data_pipeline_per_data_set, data_partitioning_in_pipeline, data_throughput, speed_performance, 
            independent_processing, data_processing_parallelization_decision, no_data_processing_parallelization,
            data_pipeline_per_data_set_can_be_combined_with_data_partitioning, 
            hybrid_data_processing_parallelization,
            hybrid_data_processing_parallelization_can_use_data_pipeline_per_data_set,
            hybrid_data_processing_parallelization_can_use_data_partitioning_in_pipeline,low_latency, 
            data_preparation, data_processing_tasks_decision,
            
```

> The data ingestor runs regularly on a schedule (once or multiple times per day) or on a trigger: a topic decouples producers (i.e. the sources of data) from consumers (in our case the ingestion pipeline), so when source data is available, the producer system publishes a message to the broker, and the embedded notification service responds to the subscription by triggering the ingestion. The notification service also broadcasts to the broker that the source data has been successfully processed and is saved in the database. Online

> In the online layer, the Online Ingestion Service is the entry point to the streaming architecture as it decouples and manages the flow of information from data sources to the processing and storage components, by providing reliable, high throughput, low latency capabilities. It functions as an enterprise-scale ‘Data Bus’. Data is saved in a long term Raw Data Store, but is also a pass-through layer to the next online streaming service, for further real-time processing.

**OPEN CODING TRACE:**

- real-time, stream processing of data; raw data store is the trigger
- forces +: reliability, throughput, low latency

**AXIAL CODING TRACE:**

added forces:

``` python
add_force_relations({batch_based_data_processing: {reliability: very_positive,
                                                   data_throughput: very_positive,
                                                   low_latency: negative,
                                                   near_real_time_support: very_negative,
                                                   },
                     real_time_data_processing: {reliability: positive,
                                                 data_throughput: positive,
                                                 low_latency: very_positive,
                                                 near_real_time_support: very_positive,
                                                 })
```

added codes to source:

``` python
data_pipeline, reliability, real_time_data_processing, near_real_time_support, tool_development_effort
```

**SELECTIVE CODING TRACE**:

- Added online_support and offline_support, data_throughput, low_latency, near_realtime, tool_development_effort forces to data_ingestion_decision

**SELECTIVE CODING TRACE**:

- Added online_support and offline_support forces to batch_or_realtime_data_processing_decision


**SELECTIVE CODING TRACE**:

- added on schedule triggering option as codes:
``` python
          on_schedule_trigger, trigger_pipeline_or_orchestrator_decision
```

> Example technologies used here can be Apache Kafka (pub/sub messaging system) and Apache Flume (data collection to long term db), but there are more you will come across, depending on your enterprise’s tech stack. — ②: Data Preparation

> Data exploration, data transformation and feature engineering. Image for post Image for postImage for post

> Once the data is ingested, a distributed pipeline is generated which assesses the condition of the data, i.e. looks for format differences, outliers, trends, incorrect, missing, or skewed data and rectify any anomalies along the way. This step also includes the feature engineering process. There are three main phases in a feature pipeline: extraction, transformation and selection. Image for post Image for postImage for post Feature Engineering Operations

**OPEN CODING TRACE:**

- feature or data pipeline. main steps: extraction, transformation and selection
- event-based messaging or pub/sub as options for data access APIs (here raw data store, but possibly for other stores as well)
- offers near- realtime support, reliable, low latency, high troughput (see previous paragraph)

**AXIAL CODING TRACE:**

- pipeline already coded

added:

``` python
data_transformation = CClass(practice, "Data transformation")
add_decision_option_link(data_processing_tasks_decision, data_transformation)
data_selection = CClass(practice, "Data selection")
add_decision_option_link(data_processing_tasks_decision, data_selection)

pub_sub_data_access_api = CClass(practice, "Pub/sub data access API")
message_event_queue_based_data_access_api = CClass(practice, "Message/event queueing-based data access API")
add_decision_option_link(data_access_interface_decision, pub_sub_data_access_api,
                         "subscription for data access; publisher notifies upon data availability")
add_decision_option_link(data_access_interface_decision, message_event_queue_based_data_access_api,
                         "new data queued in messages/events; message/event raised upon data availability")

```
- added near_real_time_support, reliability, low_latency, data_throughput forces to data_access_interface_decision options

- already coded: near_real_time_support, reliability, low_latency, data_throughput

added codes to source:

``` python
data_extraction, data_processing_tasks_decision,
data_selection, data_transformation,  feature_engineering
pub_sub_data_access_api, message_event_queue_based_data_access_api,  
```


> As this is the most complex part of a ML project, introducing the right design patterns is crucial, so in terms of code organisation having a factory method to generate the features based on some common abstract feature behaviour as well as a strategy pattern to allow the selection of the right features at run time is a sensible approach. Both feature extractors and transformers should structured with composition and re-usability in mind.

> Selecting the features can be left to the caller, or can be automated e.g. apply a chi-squared statistical test to rank the impact of each feature on the concept label and discard the less impactful features prior to model training. A series of selector APIs can be defined to enable this. Either way, to ensure consistency on the features used as model inputs and at scoring, a unique id is assigned to each feature set.

> Broadly speaking, a data preparation pipeline should be assembled into a series of immutable transformations, that can easily be combined. This is where the significance of testing and high code coverage becomes an important factor for the project’s success. Offline

> In the offline layer, the Data Preparation Service, is triggered by the completion of the ingestion service. It sources the Raw Data, undertakes all the feature engineering logic, and saves the generated features in the Feature Data Store.

**OPEN CODING TRACE:**

- Features stored in a feature store
- Data preparation

**AXIAL CODING TRACE:**

added:

``` python
feature_store = CClass(practice, "Feature store")
    
feature_persistence_and_access_decision = CClass(decision, "How to persist and provide access to features?")
store_features_without_specific_support = \
    CClass(do_nothing_design_solution, "Store features in data stores without specific support")
add_decision_option_link(feature_persistence_and_access_decision, store_features_without_specific_support)
add_decision_option_link(feature_persistence_and_access_decision, feature_store)


add_links({feature_persistence_and_access_decision: model_and_application}, role_name="context",
          stereotype_instances=decide_for_some_instances_of)

add_links({feature_store: store_data_decision},
          role_name="next decision", stereotype_instances=consider_if_not_decided_yet,
          label="how to persist the features")

add_links({store_features_without_specific_support: store_data_decision},
          role_name="next decision", stereotype_instances=consider_if_not_decided_yet,
          label="how to persist the features")

add_links({data_processing_automation_decision: feature_persistence_and_access_decision},
          role_name="next decision", stereotype_instances=consider_if_not_decided_yet,
          label="how to store resulting features")

add_links({model_building_decision: feature_persistence_and_access_decision},
          role_name="next decision", stereotype_instances=consider_if_not_decided_yet,
          label="how to access features for model training")

```

added codes to source:

``` python
feature_store, 
feature_persistence_and_access_decision, store_features_without_specific_support, 
```

**SELECTIVE CODING TRACE**:

- added on-demand triggering option (by data ingestor) as codes to S2:
``` python
          on_demand_trigger
```


> The same partitioning applies here too (i.e. dedicated pipelines / parallelism).

> Optionally, the features from multiple data sources can be combined, so a ‘join/sync’ task is designed to aggregate all the intermediate completion events and create these new, combined features. In the end, the notification service broadcasts to the broker this process is complete and the features are available.

> When each data preparation pipeline ﬁnishes, the features are also replicated to the Online Feature Data Store, so that the features can be queried with low latency for real-time prediction.
>

**OPEN CODING TRACE:**

- online vs. offline feature store. Forces +: low latency and real-time prediction.

**AXIAL CODING TRACE:**

- goes beyond our study

**SELECTIVE CODING TRACE**:

- coded in S6, thus:

added codes to source:

``` python
batch_feature_api, real_time_feature_api, data_access_interface_decision, 
feature_store_can_include_batch_feature_api, 
feature_store_can_include_real_time_feature_api,
online_support, offline_support, data_throughput, low_latency, near_real_time_support
```

> Online

> The raw data is streamed from the ingestion pipeline into the Online Data Preparation Service. The generated features are stored in an in-memory Online Feature Data Store where they can be read at low latency at prediction time, but are also persisted in the long term Feature Data Store for future training. Additionally the in-memory database can be pre-warmed by loading features from the long term Feature Data Store.

**OPEN CODING TRACE:**

- raw data from ingestion is prepared in online data prep. for in-memory online feature data store

**AXIAL CODING TRACE:**

- in mem db coded below

> Continuing the earlier tech stack example, a frequently used streaming engine is Apache Spark. Image for post Image for postImage for post

> 🔍 Offline Drill Through: If we were to drill through the offline Ingestion and the Data Preparation services interaction, we would have something like below:

> • (1) One or more data producers publish events to a designated ‘Source Data Available’ topic of the message broker, that the data is ready for consumption. • (2) The Ingestion Service is listening to the topic. • Once the respective event is received, it handles it by: (3) sourcing the data and (4) persisting it in its raw format in the data store. • (5) When the process finishes, it raises a new event to the ‘Raw Data Extracted’ topic to notify that the raw data is ready. • (6) The Data Preparation Service is listening to the topic. • Once the respective event is received, it handles it by: (7) sourcing the raw data, preparing it and engineering new features and (8) persisting the features in the data store. • (9) When the process finishes, it raises a new event to the ‘Features Generated’ topic to notify that the features have been generated. Image for post Image for postImage for post Offline Data Ingestion / Preparation Interactions


**OPEN CODING TRACE:**

- using an event driven or pub/sub architecture to trigger data pipeline steps

**AXIAL CODING TRACE:**

- not coded for now

— ③: Data Segregation
>
> Split subsets of data to train the model and further validate how it performs against new data. Image for post Image for postImage for post

> The fundamental goal of the ML system is to use an accurate model based on the quality of its pattern prediction for data that it has not been trained on. As such, existing labelled data is used as a proxy for future/unseen data, by splitting it into training and evaluation subsets.

> There are many strategies to do that, four of the most common ones are:

> • Use a default or custom ratio to split it into the two subsets, sequentially i.e. in the order it appears in the source, making sure there is no overlapping. For instance use the first 70% of data for training and the subsequent 30% of data for testing. • Use a default or custom ratio to split it into the two subsets via a random seed. For instance select a random 70% of the source data for training and the complement of this random subset for testing. • Use either of the methods above (sequential vs. random) but also shuffle the records within each dataset. • Use a custom injected strategy to split the data, when an explicit control over the separation is needed.

> The data segregation is not a separate ML pipeline as such, but an API or service must be available to facilitate this task. The next two pipelines (model training and evaluation) must be able to call this API to get back the requested datasets. In terms of code organisation, a strategy pattern is necessary so the caller service can select the right algorithm at run time, and obviously the ability to inject the ratio or random seed is needed. Additionally, the API must be able to return the data with or without labels/traits — for training and evaluation respectively.

**OPEN CODING TRACE:**

- on splitting training and evaluation data
- service for splitting training and evaluation data
- called by model building pipeline(s)
- model training

**AXIAL CODING TRACE:**

added:

``` python
model_training = CClass(practice, "Model training")
data_splitting = CClass(practice, "Data splitting")
add_decision_option_link(model_building_tasks_decision, data_splitting)
add_decision_option_link(model_building_tasks_decision, model_training)
```

added codes to source:

``` python
model_training, data_splitting, model_building_tasks_decision
```

> To protect the caller from specifying parameters that cause an uneven data distribution, a warning should be raised and returned along with the dataset. — ④: Model Training

> Use the training subset of data to let the ML algorithm recognise the patterns in it. Image for post Image for postImage for post

> The model training pipeline is offline only and its schedule varies depending on the criticality of the application, from every couple of hours to once a day. Apart from schedulers, the service is also time and event triggered.

**OPEN CODING TRACE:**

- model building pipeline for model training
- scheduled pipeline runs

**AXIAL CODING TRACE:**

- triggers not coded for now


**SELECTIVE CODING TRACE**:

- added triggers above, here on-demand and on schedular triggers.


> It consists of a library of training model algorithms (linear regression, ARIMA, k-means, decision trees etc), which is built in a SOLID way to make provision for continuous development of new model types as well as making them interchangeable. Also containment, using the facade pattern, is a crucial technique for integrating third-party APIs (this is where your Python Jupyter notebook can be wrapped and called too).


**OPEN CODING TRACE:**

- force: pipeline enables interchangeability of model training algorithms
- practice: wrap and call data science tools like Jupyter Notebooks from pipeline

**AXIAL CODING TRACE:**

added and changed to:

``` python
interchangeability_of_ml_algorithms = CClass(force,
                                                "Interchangeability of machine learning algorithms")
add_force_relations({model_building_in_development_sandbox: {interchangeability_of_ml_algorithms: negative},
                     model_building_pipeline: {interchangeability_of_ml_algorithms: positive},
                     })
                     
model_building_in_development_tool = CClass(practice, "Model building in development tool")

add_decision_option_link(model_building_decision, model_building_in_development_tool,
                         "model building performed in development sandbox")
                     
development_tool_facade_can_be_combined_with_model_building_in_development_tool = \
    development_tool_facade.add_links(model_building_in_development_tool, role_name="to",
                                       stereotype_instances=can_be_combined_with,
                                       label="call data science tool via API")[0]

development_tool_facade = CClass(practice, "Data science tool facade")
development_tool_facade_can_be_combined_with_model_building_in_development_tool = \
    development_tool_facade.add_links(model_building_in_development_tool, role_name="to",
                                       stereotype_instances=enables)[0]
add_decision_option_link(model_building_tasks_decision, development_tool_facade,
                         "use API to integrate data science tool")

```

added codes to source:

``` python
data_splitting, interchangeability_of_ml_algorithms, development_tool_facade, development_tool_facade_can_be_combined_with_model_building_in_development_tool
```

> There are a few options for parallelisation:

> • The simplest form is to have a dedicated pipeline for each model, i.e. all models run concurrently. • Another idea is to parallelise the training data i.e. the data is partitioned and each partition has a replica of the model. This is preferred for those models that they need all fields of an instance to perform the computation (e.g. LDA, MF). • A third option is to parallelise the model itself i.e. the model is partitioned and each partition is responsible for the updates of a portion of parameters. It is ideal for Linear models, such as LR, SVM. • Finally, a hybrid approach can be used, combining one or more options. (For more info I recommend you read this publication).

**OPEN CODING TRACE:**

- parallelization options:
    - one pipeline per model
    - partition training data: the data is partitioned and each partition has a replica of the model
    - partition model: the model is partitioned and each partition is responsible for the updates of a portion of
      parameters
    - hybrid approaches
- again similar positive aspects of the parallelization: speed_performance, low_latency at least

**AXIAL CODING TRACE:**

added:

``` python
model_building_pipeline_per_model = CClass(practice, "Model building pipeline per model")
training_data_partitioning = CClass(practice, "Training data partitioning")
model_partitioning = CClass(practice, "Model partitioning")
hybrid_model_building_parallelization = CClass(practice, "Hybrid model building parallelization")

model_building_parallelization_decision = CClass(decision, "How to parallelize model_building?")
no_model_building_parallelization = CClass(do_nothing_design_solution, "No parallel model building")
add_decision_option_link(model_building_parallelization_decision, no_model_building_parallelization)
add_decision_option_link(model_building_parallelization_decision, model_building_pipeline_per_model,
                         "all models run concurrently")
add_decision_option_link(model_building_parallelization_decision, training_data_partitioning,
                         "the data is partitioned and each partition has a replica of the model")
add_decision_option_link(model_building_parallelization_decision, model_partitioning,
                         "the model is partitioned and each partition updates a portion of parameters")
add_decision_option_link(model_building_parallelization_decision, hybrid_model_building_parallelization,
                         "combining one or more of the other parallelization options")

hybrid_model_building_parallelization_can_use_model_building_pipeline_per_model = \
    hybrid_model_building_parallelization.add_links(model_building_pipeline_per_model, role_name="to",
                                                       stereotype_instances=can_use)[0]

hybrid_model_building_parallelization_can_use_training_data_partitioning = \
    hybrid_model_building_parallelization.add_links(training_data_partitioning, role_name="to",
                                                       stereotype_instances=can_use)[0]

hybrid_model_building_parallelization_can_use_training_model_partitioning = \
    hybrid_model_building_parallelization.add_links(model_partitioning, role_name="to",
                                                       stereotype_instances=can_use)[0]

add_force_relations({no_model_building_parallelization: {speed_performance: very_negative,
                                                            low_latency: negative,
                                                            },
                     model_building_pipeline_per_model: {speed_performance: positive,
                                                            low_latency: positive,
                                                            },
                     training_data_partitioning: {speed_performance: positive,
                                                  low_latency: positive,
                                                  },
                     model_partitioning: {speed_performance: positive,
                                          low_latency: positive,
                                          },
                     hybrid_model_building_parallelization: {speed_performance: very_positive,
                                                                low_latency: very_positive,
                                                                },
                     })

add_links({model_building_decision: model_building_parallelization_decision},
          role_name="next decision", stereotype_instances=consider_if_not_decided_yet)
```

added codes to source:

``` python
model_building_pipeline_per_model, training_data_partitioning, model_partitioning,
            hybrid_model_building_parallelization, model_building_parallelization_decision,
            no_model_building_parallelization,
            hybrid_model_building_parallelization_can_use_model_building_pipeline_per_model,
            hybrid_model_building_parallelization_can_use_training_data_partitioning,
            hybrid_model_building_parallelization_can_use_training_model_partitioning,
```

> Model training must be implemented with error tolerance in mind and also data checkpoints and failover on training partitions should be enabled — e.g. each partition can be retrained if the previous attempt fails due to some transient issue (e.g. timeout). Image for post Image for postImage for post

**OPEN CODING TRACE:**

- practice: data checkpoints
- enables failover, where each partition can be retrained if the previous attempt fails due to some transient issue (
  e.g. timeout).

**AXIAL CODING TRACE:**

added:

``` python
data_checkpoints = CClass(practice, "Data checkpoints")
add_decision_option_link(model_building_tasks_decision, data_checkpoints)
```

added codes to source:

``` python
data_checkpoints, model_building_tasks_decision
```

> Since we covered the capabilities of this pipeline, let’s unpack the workflow: The Model Training Service gets the training configuration parameters (e.g. model type, hyper-parameters, features to be used etc) from the Configuration Service and will then request the training dataset from the Data Segregation API. This dataset is sent to all the models in parallel and once complete, the models, the original configuration, the learned parameters, plus metadata on the training set and timings, will be saved in the Model Candidate Data Store. — ⑤: Candidate Model Evaluation

**OPEN CODING TRACE:**

- models stored in model candidate store, i.e. a model registry (terminology from S6)
- models needed by CI/CD for deploying them.
- CI/CD pipeline (or its alternative build and deployment scripts) can use the model building pipeline introduced 
  above

**AXIAL CODING TRACE:**

added:

``` python
model_registry = CClass(practice, "Model registry")
ci_cd_pipeline_can_use_model_registry = \
    ci_cd_pipeline.add_links(model_registry, role_name="to", stereotype_instances=can_use,
                             label="access models and model candidates")[0]


add_links({model_registry: store_data_decision},
          role_name="next decision", stereotype_instances=consider_if_not_decided_yet)


model_building_pipeline_can_use_model_registry = \
    model_building_pipeline.add_links(model_registry, role_name="to", stereotype_instances=can_use,
                                         label="store all models and model candidates")[0]
                                         
ci_cd_pipeline_can_be_combined_with_model_building_pipeline = \
    ci_cd_pipeline.add_links(model_building_pipeline, role_name="to", stereotype_instances=can_be_combined_with)[0]
build_and_deployment_scripts_can_be_combined_with_model_building_pipeline = \
    build_and_deployment_scripts.add_links(model_building_pipeline, role_name="to", 
                                           stereotype_instances=can_be_combined_with)[0]
```
**SELECTIVE CODING TRACE**:
- CI/CD pipelines can INCLUDE model building and data pipelines
`ci_cd_pipeline_can_be_combined_with_model_building_pipeline = \
    ci_cd_pipeline.add_links(model_building_pipeline, role_name="to", stereotype_instances=can_be_combined_with)[0]`
becomes:
`ci_cd_pipeline_can_include_model_building_pipeline = \
    ci_cd_pipeline.add_links(model_building_pipeline, role_name="to", stereotype_instances=can_include)[0]`

- CI/CD pipelines can INCLUDE model building and data pipelines

added codes to source:
``` python
model_registry, ci_cd_pipeline_can_use_model_registry, model_building_pipeline_can_use_model_registry,
ci_cd_pipeline_can_include_model_building_pipeline, 
build_and_deployment_scripts_can_be_combined_with_model_building_pipeline
```

> Assess the performance of the model using the test subset of data to understand how accurate the prediction is. Image for post Image for postImage for post

> This pipeline is also offline. The predictive performance of a model is evaluated by comparing predictions on the evaluation dataset with true values using a variety of metrics. The “best” model on the evaluation subset is selected to make predictions on future/new instances. A library of several evaluators is designed to provide a model’s accuracy metrics (e.g. ROC curve, PR curve), which are also saved against the model in the data store. Again, same patterns are applicable here to allow flexibility on combining and switching between evaluators. Image for post Image for postImage for post

**OPEN CODING TRACE:**

- Model Evaluation Service or step
- select best model based on evaluation metrics

**AXIAL CODING TRACE:**

added:

``` python
model_selection = CClass(practice, "Model selection service")
add_decision_option_link(model_building_tasks_decision, model_selection)
```

added codes to source:

``` python
model_building_tasks_decision, model_selection
```

**SELECTIVE CODING TRACE**:
- This implies that multiple model versions are trained, appears again in S4.
- Among the mupliple services the evaluation service or the pipeline can select.

added:

``` python
train_multiple_model_versions = CClass(practice,
                                       "Train multiple model versions with different parameters and/or algorithms")
add_decision_option_link(model_building_tasks_decision, train_multiple_model_versions)

model_selection_uses_train_multiple_model_versions = \
    model_selection.add_links(train_multiple_model_versions, role_name="to",
                                       stereotype_instances=uses)[0]
```

added codes to source:

``` python
train_multiple_model_versions, model_building_tasks_decision, 
model_selection_uses_train_multiple_model_versions
```

> In terms of orchestration, the Model Evaluation Service requests the evaluation dataset from the Data Segregation API, and for each model sourced from the Model Candidate repository, it applies the relevant evaluators. The evaluation results are saved back to the repository. This is an iterative process and hyperparameter optimisation as well as regularisation techniques are also applied to come up with the final model. The best model is marked for deployment. Finally, the notification service broadcasts that a model is ready for deployment.

> This pipeline also needs to live up to all the reactive traits. — ⑥: Model Deployment

> Once the chosen model is produced, it is typically deployed and embedded in decision-making frameworks. Image for post Image for postImage for post

> Model deployment is not the end; it is just the beginning!

> The best model selected is deployed for offline (asynchronous) and online (synchronous) predictions. More than one models can be deployed at any time to enable safe transition between old and new models — i.e. when deploying a new model, the services need to keep serving prediction requests.

**OPEN CODING TRACE:**

- option to deploy multiple models at once
- enable safe transition
- hyperparameter tuning of the ML model

**AXIAL CODING TRACE:**

added:

``` python
safe_model_transition = CClass(force, "Safe transition between production models")

n_versions_in_production = CClass(pattern, "N versions in production")

deploying_model_versions_in_production_decision = CClass(decision, "Which model versions should be deployed " +
                                                     "and how?")
single_model_in_production = CClass(do_nothing_design_solution, "Single model in production")
add_decision_option_link(deploying_model_versions_in_production_decision, single_model_in_production)
add_decision_option_link(deploying_model_versions_in_production_decision, n_versions_in_production,
                         "deploy multiple model versions at the same time")

add_links({deploying_model_versions_in_production_decision: model_and_application}, role_name="context",
          stereotype_instances=decide_for_some_instances_of)

add_force_relations({single_model_in_production: {safe_model_transition: very_negative
                                                  },
                     n_versions_in_production: {safe_model_transition: very_positive},
                     })

add_links({automated_integration_and_delivery_in_ml_context_decision: deploying_model_versions_in_production_decision},
          role_name="next decision", stereotype_instances=consider_if_not_decided_yet)

model_hyperparameter_tuning = CClass(practice, "Model hyperparameter tuning")
add_decision_option_link(model_building_tasks_decision, model_hyperparameter_tuning)
```

added codes to source:

``` python
safe_model_transition, n_versions_in_production, deploying_model_versions_in_production_decision, 
single_model_in_production, model_hyperparameter_tuning
```

> Traditionally, a challenge in deployment has been that the programming languages needed to operationalise models have been different from those that have been used to develop them. Porting a Python or R model into a production language like C++, C# or Java is challenging, and often results in reduced performance (speed & accuracy) of the original model. There are a few ways to address this issue. In no particular order:

> • Rewrite the code in the new language [i.e. translate from Python to CSharp]
• Create custom DSL (Domain Specific Language) to describe the model • Microservice (accessed through a RESTful API)
• API-first approach • Containerisation • Serialise the model and load into a in-memory key-value store

**OPEN CODING TRACE:**

- how to embed model that make predictions
    - in monolith (rewrite/use as is)
    - in module in monolith (DSL, Serialize, API-first)
    - Model as a service (Microservice)
    - Containerized model (can be module in monolith? or in model as a service?)
- force portability
- in memory data store (can be shared data store or db per service)

**AXIAL CODING TRACE:**
added:

``` python
model_portability = CClass(force, "Model portability")

in_memory_data_store = CClass(practice, "In-memory data store")
database_per_service_has_variant_in_memory_data_store = \
    database_per_service.add_links(in_memory_data_store, role_name="to", stereotype_instances=has_variant,
                                   label="used for low-latency online results")[0]
shared_database_has_variant_in_memory_data_store = \
    shared_database.add_links(in_memory_data_store, role_name="to", stereotype_instances=has_variant,
                              label="used for low-latency online results")[0]
```

added codes to source:

``` python
model_as_as_service,
            model_in_monolith, model_as_module_in_modular_monolith, integrating_ml_model_decision,
            model_as_module_in_modular_monolith_is_a_model_in_monolith, model_portability
   in_memory_data_store, database_per_service_has_variant_in_memory_data_store, 
   shared_database_has_variant_in_memory_data_store
```

**SELECTIVE CODING TRACE**:

- Added online_support and offline_support forces to integrating_ml_model_decision

> More specifically:
Offline

> • In an offline mode, the prediction model can be deployed to a container and run as a microservice to create predictions on demand or on a periodic schedule. • A different choice is to create a wrapper around it so you gain control over the functions available. Once a batch prediction request is made, you can load it dynamically into memory as a separate process, call the prediction functions, unload it from memory and free up the resources (native handles). • Finally another approach is to wrap the library into an API and let the caller invoke it directly or wrap it around their service to fully take over the reins of the prediction instrumentation.

**OPEN CODING TRACE:**

- module in modular monolith can also be wrapper or library

**AXIAL CODING TRACE:**

- quite clear, thus not coded

> In terms of scalability, multiple parallel pipelines can be created to accommodate the load. This involves inconsiderable effort, as the ML models are stateless.

**OPEN CODING TRACE:**

- in limited way modular monolith options and especially MaaS offer option to parallelize stateless ML predictions ->
  scalability is improved

**AXIAL CODING TRACE:**
force already coded.

added codes to source:

``` python
scalability
```

> Online

> • Here the prediction model can be deployed in a container to a service cluster, generally distributed in many servers behind a queue for load balancing to assure scalability, low latency and high throughput. The clients can send prediction requests as network remote procedure calls (RPC). • Alternatively, key-value stores (e.g Redis) support the storage of a model and its parameters, which gives a big boost on performance. Image for post Image for postImage for post

**OPEN CODING TRACE:**

- model as a service offers scalability, low latency and high throughput

**AXIAL CODING TRACE:**
added forces low_latency and data_throughput to integrating_ml_model_decision

added codes to source:

``` python
low_latency, data_throughput
```

> ✳️ With regards to the actual model deployment activity, it can be automated via a continuous delivery implementation: The required files are packaged, the model is validated by a reliable testing suite and is finally deployed into a running container. The tests are executed by an automated build pipeline: Short, self-contained, stateless unit tests are evaluated first. If they pass, the prediction model quality is measured in bigger integration or regression tests. When both levels of testing have passed, the application is deployed to the serving environment.
>
**OPEN CODING TRACE:**

- ci/cd deployment pipeline
- include packaging, various kinds testing, and deploying here
- deployed to production environment

**AXIAL CODING TRACE:**
added:

``` python
packaging = CClass(practice, "Packaging")
testing = CClass(practice, "Testing")

add_decision_option_link(delivery_tasks_decision, packaging)
add_decision_option_link(delivery_tasks_decision, testing)
```

added codes to source:

``` python
ci_cd_pipeline, packaging, testing, delivery_tasks_decision,
automated_integration_and_delivery_in_ml_context_decision
```

**SELECTIVE CODING TRACE**:

- After adding decision on what to deploy in S6, added codes to source:

``` python
            semi_automated_model_deployment, 
            no_automated_deployment,
            deployment_how_to_approach_decision,
            
```



> Enabling one-click deployment is ideal. — ⑦: Model Scoring

> Process of applying a ML model to a new dataset in order to uncover practical insights that will help solve a business problem. A.k.a. Model Serving. Image for post Image for postImage for post

> ✏️ Model Scoring and Model Serving are two terms that are used interchangeably in the industry. What scoring really means, occurred to me after reading this resource, so before moving on, let’s quickly cover the basics, in case this is not clear to you either:

> Model Scoring is the process of generating new values, given a model and some new input. The generic term score is used, rather than prediction, as it may result in different types of values:

> • A list of recommended items • Numeric values, for time series models and regression models • A probability value, indicating the likelihood that a new input belongs to some existing category • The name of a category or cluster to which a new item is most similar • A predicted class or outcome, for classification models. Image for post Image for postImage for post

> Moving on… Once models are deployed they are used for scoring based on the feature data loaded by previous pipelines or directly from a client service. Models should behave the same in both offline and online modes when serving predictions. Offline

> In the offline layer, the Scoring Service is optimised for high throughput, fire-and-forget predictions for a large collection of data. An application can send an asynchronous request to kick off the scoring process, but needs to wait until the batch scoring process completes before it can access the prediction results. The service prepares the data, generates the features, but also fetches extra features from the Feature Data Store. Once scoring takes place, the results are saved in the Score Data Store. A message is sent to the broker to notify that the scoring has completed. The application is listening to this event and when notified it fetches the scores.

> Online

> A client sends a request to the Online Scoring Service. It can optionally specify the version of the model to be invoked, so the Model Router inspects the request and sends it to the respective model. Based on the request, similarly to the offline layer, the service prepares the data, generates the features, and optionally fetches extra features from the Feature Data Store. Once scoring takes place, the results are saved in the Score Data Store and then sent back to the client over the network.

**OPEN CODING TRACE:**

- offline predictions/scoring:  high throughput, fire-and-forget predictions for a large collection of data
- batch process
- serving ml results through offline batch job  
- results stored in prediction/score data store

- online scoring in service. needs to prepare data, generate features (runs data pipeline), fetch features from feature
  store,
- results stored in prediction/score data store

**AXIAL CODING TRACE:**
added:

``` python
offline_support = CClass(force, "Offline support")
online_support = CClass(force, "Online support")

predictions_data_store = CClass(practice, "Predictions data store")

service_based_model_serving_can_use_predictions_data_store = \
    service_based_model_serving.add_links(predictions_data_store, role_name="to",
                                          stereotype_instances=can_use,
                                          label="persist predictions")[0]
data_batch_based_model_serving_can_use_predictions_data_store = \
    data_batch_based_model_serving.add_links(predictions_data_store, role_name="to",
                                             stereotype_instances=can_use,
                                             label="persist predictions")[0]
   
add_links({predictions_data_store: [store_data_decision]},
          role_name="next decision", stereotype_instances=consider_if_not_decided_yet,
          label="how to persist predictions")
          
add_links({model_serving_decision: feature_persistence_and_access_decision},
          role_name="next decision", stereotype_instances=consider_if_not_decided_yet,
          label="how to access features for model serving")
```

added forces online_support and offline_support to model_serving_decision

added codes to source:

``` python
data_batch_based_model_serving,
offline_support, online_support, microservice_based_model_serving, 
            microservice_based_model_serving_is_a_service_based_model_serving,
            local_service_api_based_model_serving_uses_model_as_a_service,
            predictions_data_store, service_based_model_serving_can_use_predictions_data_store,
            data_batch_based_model_serving_can_use_predictions_data_store

```

> Depending on the use-case, scores can also be delivered to the client asynchronously i.e. independently of the request:
• Push: Once the scores are generated, they are pushed to the caller as a notification. • Poll: Once the scores are generated, they are stored in a low read-latency database; the caller periodically polls the database for available predictions.

**OPEN CODING TRACE:**

- push or poll as options to retrieve the results, actually Poll Object / Result Callback like.
- major forces and alternative (naive option) to block on the result exist, too.

**AXIAL CODING TRACE:**
added:

``` python
immediate_result_notification = CClass(force, "Immediate result notification")
non_blocking_clients = CClass(force, "Non-blocking clients")
clients_must_follow_asynchronous_model = CClass(force, "Clients must follow asynchronous programming model")

push_notification = CClass(practice, "Push notification")
polling = CClass(practice, "Polling")
block_on_result = CClass(practice, "Block on result")

result_availability_information_decision = CClass(decision,
                                                  "How to inform clients about prediction result availability?")
add_decision_option_link(result_availability_information_decision, push_notification,
                         "notify clients about results")
add_decision_option_link(result_availability_information_decision, polling,
                         "clients poll for the results")
add_decision_option_link(result_availability_information_decision, block_on_result,
                         "clients blocks until the results are available")

add_force_relations({push_notification: {immediate_result_notification: positive,
                                         non_blocking_clients: positive,
                                         clients_must_follow_asynchronous_model: negative
                                         },
                     polling: {immediate_result_notification: negative,
                               non_blocking_clients: positive,
                               clients_must_follow_asynchronous_model: positive
                               },
                     block_on_result: {immediate_result_notification: very_negative,
                                       non_blocking_clients: very_negative,
                                       clients_must_follow_asynchronous_model: positive
                                       },

                     })

add_links({result_availability_information_decision: model_and_application}, role_name="context",
          stereotype_instances=decide_for_some_instances_of)

add_links({model_serving_decision: result_availability_information_decision},
          role_name="next decision", stereotype_instances=consider_if_not_decided_yet)

```

added codes to source:

``` python
immediate_result_notification, non_blocking_clients, clients_must_follow_asynchronous_model, 
push_notification, polling, block_on_result, result_availability_information_decision
```

> In order to minimise the time the system takes to serve the scoring when it receives the request, two methods are employed:
• the input features are stored in a low-read latency in-memory data store, • predictions precomputed in an offline batch-scoring job are cached for easy access [this is depending on the use-case, as offline predictions might not be relevant].

**OPEN CODING TRACE:**

- online low-read latency in-memory data store

**AXIAL CODING TRACE:**
added:

``` python
in_memory_data_store = CClass(practice, "In-memory data store")
database_per_service_has_variant_in_memory_data_store = \
    database_per_service.add_links(in_memory_data_store, role_name="to", stereotype_instances=variant,
                                   label="used for low-latency online results")
shared_database_has_variant_in_memory_data_store = \
    shared_database.add_links(in_memory_data_store, role_name="to", stereotype_instances=variant,
                              label="used for low-latency online results")
```

added codes to source:

``` python
in_memory_data_store
```

> — ⑧: Performance Monitoring

> The model is continuously monitored to observe how it behaved in the real world and calibrated accordingly. Image for post Image for postImage for post

**OPEN CODING TRACE:**

- model is continuously monitored
- model adjustment

**AXIAL CODING TRACE:**
coded below

> Any ML solution requires a well-defined performance monitoring solution. An example of information that we might want to see for model serving applications includes:
• model identifier, • deployment date/time, • number of times the model has been served, • average/min/max model serving times, • distribution of features used. • predicted vs. actual/observed results.

> This metadata is calculated during the model scoring and then used for monitoring.

> This is another offline pipeline. The Performance Monitoring Service, is notified when a new prediction is served, executes the performance evaluation, persists the results and the relevant notifications are raised. The evaluation itself takes place by comparing the scores to the observed outcomes generated by the data pipeline (training set). The basic implementation for monitoring can follow different approaches with the most popular being logging analytics (Kibana, Grafana, Splunk etc).

**OPEN CODING TRACE:**

- offline Performance monitoring service or pipeline
- triggered by new predictions
- receives model and prediction metadata

**AXIAL CODING TRACE:**
coded below

> To ensure built-in resilience of the ML system, a poor speed performance of the new model triggers the scores to be generated by the previous model. A “better wrong than late” philosophy is adopted: if a term in the model takes too long to be computed, the model is substituted by a previously deployed model, rather than blocking.

**OPEN CODING TRACE:**

- practice: replace too slow model by previously deployed model, rather than blocking.
- force: resilience

**AXIAL CODING TRACE:**
coded below

> Additionally, the scores are joined to the observed outcomes when they become available — that means that continuous accuracy measurements of the model are generated, and along the same lines with speed performance, any sign of degradation can be dealt with by reverting to the previous model.

**OPEN CODING TRACE:**

- monitoring of accuracy, speed performance

**AXIAL CODING TRACE:**
added:

``` python
#
# Decision: monitoring
#
model_accuracy = CClass(force, "Model accuracy")

model_performance_monitoring = CClass(practice, "Model performance monitoring")
speed_performance_monitoring = CClass(practice, "Speed performance monitoring")
model_accuracy_monitoring = CClass(practice, "Model accuracy monitoring")
model_and_prediction_metadata = CClass(practice, "Model and prediction metadata")

model_performance_monitoring_can_use_speed_performance_monitoring = \
    model_performance_monitoring.add_links(speed_performance_monitoring, role_name="to",
                                           stereotype_instances=can_use)[0]

model_performance_monitoring_can_use_model_accuracy_monitoring = \
    model_performance_monitoring.add_links(model_accuracy_monitoring, role_name="to",
                                           stereotype_instances=can_use)[0]

model_performance_monitoring_requires_model_and_prediction_metadata = \
    model_performance_monitoring.add_links(model_and_prediction_metadata, role_name="to",
                                           stereotype_instances=requires)[0]

monitoring_in_production_decision = CClass(decision, "How to monitor the model's performance in production?")
no_in_production_monitoring = CClass(do_nothing_design_solution, "No in-production monitoring")
add_decision_option_link(monitoring_in_production_decision, no_in_production_monitoring)
add_decision_option_link(monitoring_in_production_decision, model_performance_monitoring,
                         "observe specific model performance parameters")

add_force_relations({no_in_production_monitoring: {speed_performance: negative,
                                                   model_accuracy: negative,
                                                   },
                     model_performance_monitoring: {speed_performance: positive,
                                                    model_accuracy: positive,
                                                    },
                     })

add_links({monitoring_in_production_decision: model_and_application}, role_name="context",
          stereotype_instances=decide_for_some_instances_of)

#
# Decision: model adjustment
#

manual_model_adjustment = CClass(practice, "Manual model adjustment")
automated_model_adjustment = CClass(practice, "Automated model adjustment")
switch_to_other_model_version = CClass(practice, "Switch to other model version")

automated_model_adjustment_can_use_switch_to_other_model_version = \
    automated_model_adjustment.add_links(switch_to_other_model_version, role_name="to",
                                         stereotype_instances=can_use)[0]

switch_to_other_model_version_requires_n_in_production = \
    switch_to_other_model_version.add_links(n_versions_in_production, role_name="to",
                                            stereotype_instances=requires)[0]

monitoring_model_adjustment_decision = CClass(decision, "How to adjust models based on monitoring results?")
add_decision_option_link(monitoring_model_adjustment_decision, manual_model_adjustment,
                         "humans adjust and redeploy the models")
add_decision_option_link(monitoring_model_adjustment_decision, automated_model_adjustment,
                         "automated measures are triggered to adjust the models")

add_links({monitoring_model_adjustment_decision: model_and_application}, role_name="context",
          stereotype_instances=decide_for_some_instances_of)

add_links({monitoring_in_production_decision: monitoring_model_adjustment_decision},
          role_name="next decision", stereotype_instances=consider_if_not_decided_yet)
```

added codes to source:

``` python
            model_performance_monitoring, speed_performance_monitoring
            model_accuracy_monitoring, model_and_prediction_metadata,
            model_performance_monitoring_can_use_speed_performance_monitoring,
            model_performance_monitoring_can_use_model_accuracy_monitoring,
            model_performance_monitoring_requires_model_and_prediction_metadata,
            monitoring_in_production_decision, no_in_production_monitoring, manual_model_adjustment,
            automated_model_adjustment, switch_to_other_model_version,
            automated_model_adjustment_can_use_switch_to_other_model_version,
            switch_to_other_model_version_requires_n_in_production,
            monitoring_model_adjustment_decision,
```

**SELECTIVE CODING TRACE**:
- after coding S6 added metadata store
- link to it instead of model and prediction metadata

changed to:

``` python
model_performance_monitoring_requires_ml_metadata_store = \
    model_performance_monitoring.add_links(ml_metadata_store, role_name="to", stereotype_instances=requires,
                                           label="access model and prediction metadata")[0]
```


added codes to source:

``` python
model_performance_monitoring_requires_ml_metadata_store, ml_metadata_store,
model_building_pipeline_can_use_ml_metadata_store, 
ci_cd_pipeline_can_use_ml_metadata_store
```


> A chain of responsibility pattern can be used to chain the different versions together.

> Model monitoring is a continuous process: a shift in prediction might result in restructuring the model design. Providing accurate predictions / recommendations continuously to drive the business forward is what defines the benefits of ML!
Cross Cutting Concerns

> We cannot end this article by not referring to the cross cutting concerns. A ML application, like any other application, has some common functionality that spans across layers/pipelines. Even in an individual layer, such functionalities could be used across all classes/services, cutting through and crossing all the normal boundaries.

> The cross cutting concerns are normally centralised in one place, which increases the application’s modularity. They are often managed by other teams in the organisation or are off-the-shelf / thrid-party products. Dependency injection is the best way to inject these in the relevant places in the code.

> The most important concerns to be addressed, in our use-case are:

> • Notifications • Scheduling • Logging Framework (and Alert mechanism)
• Exception Management • Configuration Service • Data Service (to expose querying in a data store)
• Auditing • Data Lineage • Caching • Instrumentation And putting it all together

**OPEN CODING TRACE:**

- various specific additions to the architecture
- data access service mentioned



**AXIAL CODING TRACE:**
added codes to source:

``` python
data_service, store_data_decision, service_based_data_access_api, data_access_interface_decision, direct_data_provider_access
```


> There you have it… A production ready ML system:
Image for post Image for postImage for post End to End ML Architecture Footnote

> Congratulations! You made it till the end! I do hope you enjoyed the ride into Software Engineering for Data Science!




