# source
## ID
27
## url
https://hub.packtpub.com/10-reasons-data-scientists-love-jupyter-notebooks/
## archive url
https://tinyurl.com/ml-adds-u27
## title
10 reasons why data scientists love Jupyter notebooks
## source code
no
## example
no
## source type
Practitioner Audience Article
## author type
Practitioner

# coding

> Insights from Cyrille Rossant, Data Scientist and researcher of Neuroscience on why data scientists love using Jupyter notebooks for their projects.

> In the last twenty years, Python has been increasingly used for scientific computing and data analysis as well. Today, the main advantage of Python and one of the main reasons why it is so popular is that it brings scientific computing features to a general-purpose language that is used in many research areas and industries. This makes the transition from research to production much easier.

> IPython is a Python library that was originally meant to improve the default interactive console provided by Python and to make it scientist-friendly. In 2011, ten years after the first release of IPython, the IPython Notebook was introduced. This web-based interface to IPython combines code, text, mathematical expressions, inline plots, interactive figures, widgets, graphical interfaces, and other rich media within a standalone sharable web document. This platform provides an ideal gateway to interactive scientific computing and data analysis. IPython has become essential to researchers, engineers, data scientists, teachers and their students.

> Within a few years, IPython gained an incredible popularity among the scientific and engineering communities. The Notebook started to support more and more programming languages beyond Python. In 2014, the IPython developers announced the Jupyter project, an initiative created to improve the implementation of the Notebook and make it language-agnostic by design. The name of the project reflects the importance of three of the main scientific computing languages supported by the Notebook: Julia, Python, and R.

> Today, Jupyter is an ecosystem by itself that comprehends several alternative Notebook interfaces (JupyterLab, nteract, Hydrogen, and others), interactive visualization libraries, authoring tools compatible with notebooks. Jupyter has its own conference named JupyterCon. The project received funding from several companies as well as the Alfred P. Sloan Foundation and the Gordon and Betty Moore Foundation.

> Apart from the rich legacy that Jupyter notebooks come from and the richer ecosystem that it provides developers, here are ten more reasons for you to start using it for your next data science project if aren’t already using it now.

**OPEN CODING TRACE:**

During coding, we shall generalise from e.g. "Jupyter notebooks" to "computational notebooks".
Another abstraction: "PyCharm" etc. shall be generalised as "IDEs".
Another abstraction: "pip", "conda" etc. shall be generalised as "dependency management tools".

Specific programming languages/ecosystems and their features are not considered if they cannot be generalised.

The decision is ultimately whether to use computational notebooks or IDEs.

This section mainly consists of historical information - nothing to code.


> 1.. All in one place: The Jupyter Notebook is a web-based interactive environment that combines code, rich text, images, videos, animations, mathematical equations, plots, maps, interactive figures and widgets, and graphical user interfaces, into a single document.

> 2.. Easy to share: Notebooks are saved as structured text files (JSON format), which makes them easily shareable.

> 3.. Easy to convert: Jupyter comes with a special tool, nbconvert, which converts notebooks to other formats such as HTML and PDF. Another online tool, nbviewer, allows us to render a publicly-available notebook directly in the browser.

> 4.. Language independent: The architecture of Jupyter is language independent. The decoupling between the client and kernel makes it possible to write kernels in any language.

> 5.. Easy to create kernel wrappers: Jupyter brings a lightweight interface for kernel languages that can be wrapped in Python. Wrapper kernels can implement optional methods, notably for code completion and code inspection.

> 6.. Easy to customize: Jupyter interface can be used to create an entirely customized experience in the Jupyter Notebook (or another client application such as the console).

> 7.. Extensions with custom magic commands: Create IPython extensions with custom magic commands to make interactive computing even easier. Many third-party extensions and magic commands exist, for example, the %%cython magic that allows one to write Cython code directly in a notebook.

> 8.. Stress-free Reproducible experiments: Jupyter notebooks can help you conduct efficient and reproducible interactive computing experiments with ease. It lets you keep a detailed record of your work. Also, the ease of use of the Jupyter Notebook means that you don’t have to worry about reproducibility; just do all of your interactive work in notebooks, put them under version control, and commit regularly. Don’t forget to refactor your code into independent reusable components.

> 9.. Effective teaching-cum-learning tool: The Jupyter Notebook is not only a tool for scientific research and data analysis but also a great tool for teaching. An example is IPython Blocks – a library that allows you or your students to create grids of colorful blocks.

> 10.. Interactive code and data exploration: The ipywidgets package provides many common user interface controls for exploring code and data interactively.

**OPEN CODING TRACE:**

- **benefits/forces of notebooks:**
  - All in one place 
    (-> force: `efficiency`)
  - Easy to share
    (-> force: `development_agility`)
  - Easy to convert - not relevant to ML  
  - Language independent - neither specific nor exclusive to notebooks
  - Easy to create kernel wrappers
    (-> force: `flexibility`)
  - Easy to customize - neither specific nor exclusive to notebooks
  - Extensions with custom magic commands
    (-> force: `interactive_prototyping`)
  - Stress-free Reproducible experiments
    (-> force: `reproducibility`)
  - Effective teaching-cum-learning tool
    (-> force: `demonstrability`)
  -Interactive code and data exploration
    (-> force: `interactive_prototyping`)

**AXIAL CODING TRACE:**

existing forces:
`efficiency`
`development_agility`
`flexibility`
`interactive_prototyping`
`reproducibility`
`demonstrability`
`interactive_prototyping`

updated force relations for the above forces that were missing for `use_computational_notebooks`:


**Concluding Changes:**
**AXIAL CODING TRACE:**

source and references
added `s27`, `s27_codes` and links in `ml_adds_sources_codes.py`:
``` python
s27
s27_codes
add_links({s27: s27_codes}, role_name="contained_code")
```

**SELECTIVE CODING TRACE:**
Added to source:
``` python
deployment_how_to_approach_decision,
no_automated_deployment
```