# source

## ID

3

## url
## NOTE: original article has been deleted
https://web.archive.org/web/20191124090916/https://medium.com/singular-distillation/some-thoughts-on-modularization-in-machine-learning-fc49f222a647

## archive url

https://tinyurl.com/ml-adds-u3

## title

Some Thoughts on Modularization in Machine Learning

## source code

no

## example

no

## source type

Practitioner Audience Article

## author type

Practitioner

## references

**AXIAL CODING TRACE**: source and references

``` python
s3 = CClass(source, "s3", values={
    "title": "Some Thoughts on Modularization in Machine Learning",
    "url": "https://medium.com/singular-distillation/some-thoughts-on-modularization-in-machine-learning-fc49f222a647",
    "archive url": "TODO",
    "author type": "Practitioner",
    "type": "Practitioner Audience Article",
    "example": False,
    "source code": False})
``` 

# coding

> Some Thoughts on Modularization in Machine Learning Vincent Alexander Saulys Vincent Alexander Saulys Nov 26, 2017 · 3 min read

> Mindless coding is programming while thoughtful coding is software engineering. The latter involves a certain philosophy of design and approach, with specific and clear guidelines on how to best approach a given problem. However, when it comes to machine learning this idea seems to have fallen out of favor and needs to come back.

> I’ve talked somewhat about this in the past. Machine learning is, at this stage, more engineering and less science. Coming up with algorithms is the domain of academia. Companies and startups instead focus on taking these known algorithms and figuring out the best implementation to work in the distributed setting of the firm.

> So what’s the best way to do this?

> Modularize the machine learning aspect and silo it off from the rest of the application.

> Machine learning is an enabler of benefits and not the benefit itself. Ideally, features in an application will, under the covers, call some API to do the machine learning work. The application itself will worry about delivering that result.

**OPEN CODING TRACE:**

- modularize one learning task in one module, possible with modular monolith or service, here more focused on service
- mentions providing the ML result from such as service  (local or distributed)
- encapsulated behind an API; benefit: encapsulation leads to separation of concerns (appears below again)

**AXIAL CODING TRACE:**

added:

``` python
encapsulation = CClass(force, "Encapsulation")
separation_of_concerns = CClass(force, "Separation of concerns")
```

added encapsulation force to integrating_ml_model_decision options

added codes to source:

``` python
integrating_ml_model_decision, model_as_module_in_modular_monolith, model_as_a_service,
            model_serving_decision, microservice_based_model_serving, local_service_api_based_model_serving,
            service_based_model_serving, encapsulation,
            separation_of_concerns
```

> Why silo this way?

> There are a few reasons I can think of that encourage silo’ing. The first is that the data scientist in question is unlikely to know much about UI/UX design. The cognitive biases one needs to do well in that domain don’t have much in common with front facing work. That’s not to say the cross over can’t happen at all, just that it’s rare. Frontend work involves knowing people, having a bit of a visual eye, and knowing cross-platform development. In contrast, data science requires one to be strong in statistics, probability, and distributed computing.

**OPEN CODING TRACE:**

- benefit: division of labour, independent development

**AXIAL CODING TRACE:**

added codes to source:

``` python
division_of_labor, independent_development
```

> The second reason is that machine learning is still so complicated that it needs to be worried about on its own. Trying to bring a useful algorithm to life, complete with relevant data and proper scaling, it really hard. Trying to do that as a component within one monolithic application is only going to massively complicate the issue. This is why micro services design works best for machine learning.

**OPEN CODING TRACE:**

- one microservice per ML task to modularize one learning task in one module
- alternative ML embedded in monolithic app
- again, benefit: separation of concerns
- benefit: scalability

**AXIAL CODING TRACE:**

added codes to source:

``` python
scalability, model_in_monolith
```

> Third, the metrics that guide development of both parts may clash. Most companies have KPIs or key performance indicators that guide product development in seeing if their particular product is working or not. There’s a great book this if you’re curious for examples, but the just of the idea is that one metric matters and nothing else does. A social media company might obsess over daily user engagement as that’s a metric that sells ad space, just to cite one example.

> In machine learning, some function of accuracy or speed is desired. Which matters more depends on context. In contrast, user interface design will want to look at user engagement more than anything. This may be a function of the other two, but not always. If you don’t define the most important metric to use, then you won’t optimize for anything. People are too simple to juggle multiple metrics in their head at once and things only get more complicated once you expand beyond one person. By setting down one goal for both teams to spend their efforts optimizing for, then you can make significant progress.

**OPEN CODING TRACE:**

- mentions accuracy and speed performance monitoring
- practice define KPIs per module
- e.g. accuracy or speed for ML, user engagement for UI/UX
- this leads to continuous improvement of the model (also through 
  accuracy and speed performance monitoring, etc.)

**AXIAL CODING TRACE:**

added:

``` python
monitoring_domain_specific_metrics_per_model = CClass(practice, "Monitoring domain-specific metrics per model")
model_performance_monitoring_can_use_domain_specific_monitoring = \
    model_performance_monitoring.add_links(monitoring_domain_specific_metrics_per_model, role_name="to",
                                           stereotype_instances=can_use)[0]
                                           
continuous_model_improvement = CClass(force, "Continuous model improvement")
```

added continuous_model_improvement force to monitoring_in_production_decision options

added codes to source:

``` python
model_performance_monitoring,
speed_performance_monitoring,
model_accuracy_monitoring,
monitoring_domain_specific_metrics_per_model,
model_performance_monitoring_can_use_domain_specific_monitoring,
model_performance_monitoring_can_use_model_accuracy_monitoring, 
model_performance_monitoring_can_use_speed_performance_monitoring,
monitoring_in_production_decision,
speed_performance, model_accuracy,
continuous_model_improvement
```

> Anyways, those are my thoughts on design in machine learning. The benefit is powered by machine learning but is never the algorithm itself, no customer will ever care. By building silos, you can start to separate and leverage your different team member’s skill sets with data scientists focusing on the numbers and application developers on the experience itself. You can also focus on the specific complexities each face. Lastly, metrics that guide the development of each can be put down without conflict. All are desired when dealing with such a fast moving field.

**OPEN CODING TRACE:**
summary

**SELECTIVE CODING TRACE:**
Added to source:
``` python
deployment_how_to_approach_decision,
no_automated_deployment
```