# source

## ID

4

## url

https://databricks.com/de/session_na20/productionizing-machine-learning-with-a-microservices-architecture

slides:

https://www.slideshare.net/databricks/productionizing-machine-learning-with-a-microservices-architecture

## archive url

https://tinyurl.com/ml-adds-u4

## title

Productionizing Machine Learning with a Microservices Architecture

## source code

no

## example

yes

## source type

Presentation Video (+ Transcript and Slides)

## author type

Practitioner

## references

**AXIAL CODING TRACE**: source and references

``` python
s4 = CClass(source, "s4", values={
    "title": "Productionizing Machine Learning with a Microservices Architecture",
    "url": "https://databricks.com/de/session_na20/productionizing-machine-learning-with-a-microservices-architecture",
    "archive url": "TODO",
    "author type": "Practitioner",
    "type": "Presentation Video",
    "example": True,
    "source code": False})
``` 

# coding

>Video Transcript

>– Hi everyone. My name is Yaron. I’m CTO and Co-founder of Iguazio, a data science platform company. What I’m going to talk about in this presentation and demonstrate is how to accelerate production of machine learning and data science workloads using microservices architecture.

> Slide 3+4

>First before we dive into the solution let’s understand the problem. The key problem today for many organizations is how to move from research environments where they do experiments of machine learning workloads usually working off a small data set using CSV Excel spreadsheets, running some analysis and data science on their Jupyter notebooks and finally doing some iterative work and throwing that into production. 


**OPEN CODING TRACE:**
- Model building in data science tool
- forces: production ready, iterative development

**AXIAL CODING TRACE:**

added:

``` python
production_ready_development = CClass(force, "Production-ready development")
```

added codes to source:

``` python
iterative_development, production_ready_development,
model_building_in_development_tool, 
model_building_decision
```


> The problem is that when you’re going to real production, the work does look pretty different. You have real data which runs at scale. Data may be streaming, may arrive from operational databases to ETL, you may need integration with real APIs that produce additional data. Once you’ve brought all the data into the system you have to run preparation at scale, not on CSVs on Excel spreadsheet but on rather large files or actually work against databases in order to denormalize and create meaningful features off the data and that requires larger scale and more distributed systems. 
> 

**OPEN CODING TRACE:**
- streaming incoming data, 
- data from APIs (ingested by request)
- ingested into data stores  
- forces: scalability
- data preparation

**AXIAL CODING TRACE:**

added codes to source:

``` python
scalability, streamed_data_ingestion, data_ingestion_by_request,
data_ingestion_decision, store_data_decision, shared_data_store, shared_database,
shared_database_is_a_shared_data_store,
data_preparation, data_processing_tasks_decision,
```

>Once you’ve done that you want to run machine learning and even at that phase you want to apply automation, you want to use every time you change the model, you change the data, you see a drift happening to your model. You want to retrain and maybe even with multiple versions of parameters and algorithms in order to guarantee that you have the maximum accuracy. So that needs to go through automated mechanisms and again work on large data sets. 
> 

**OPEN CODING TRACE:**
- mentions automated model adjustment
- adds the option to retrain model in model adjustment
- this (train the model) can be done with maybe even with multiple versions of parameters and algorithms 
- this is for continuous model improvement, especially regarding accuracy
- possible by monitoring for accuracy.

**AXIAL CODING TRACE:**

added:

``` python
retrain_model = CClass(practice, "Retrain model")

automated_model_adjustment_can_use_retrain_model = \
    automated_model_adjustment.add_links(retrain_model, role_name="to", stereotype_instances=can_use)[0]
retrain_model_can_use_train_multiple_model_versions = \
    retrain_model.add_links(train_multiple_model_versions, role_name="to",
                            stereotype_instances=can_use)[0]
```


added codes to source:

``` python
automated_model_adjustment, monitoring_model_adjustment_decision, 
automated_model_adjustment_can_use_retrain_model, retrain_model,
retrain_model_can_use_train_multiple_model_versions, 
train_multiple_model_versions, monitoring_in_production_decision,
model_accuracy, model_accuracy_monitoring, continuous_model_improvement
```

>And finally when you have the model, you have to serve that model in production against real time data, real features that come from streams, from transactions, from user requests and you want to be able to monitor your models in real time, elastically scale them as needed and increase a feedback loop back into the training and data preparation. When you’re starting to do that, you understand that the basic principles of developing in research essentially doing Jumbo, Jupyter notebooks with lot of code are not really applicable to production. This is where usually large teams of people come into the picture, DevOps, analog, data engineers, ML engineers whatever in order to deliver everything and in many cases they happen to rewrite the code from scratch. 
> 


**OPEN CODING TRACE:**
- various forms of streamed ingestion or ingestion by request
- force: real time for data ingestions, model monitoring (Near real-time support supported in ingestions and supported by continuous model improvement)
- what you don't want is data ingestion in batches / maybe even fully manual ingestion (i.e. opposite of real time and automatic) as on Slide 3
- feedback loop to data preparation and training/model building (model monitoring required and continuous model improvement)
- again: data science tool based not ready for production
- large teams, different roles => division of labor, independent development, possibly
  distributed development

**AXIAL CODING TRACE:**

added:

``` python
data_ingestion_in_batches = CClass(practice, "Data ingestion in batches")
manual_data_ingestion = CClass(practice, "Manual data ingestion")

add_decision_option_link(data_ingestion_decision, data_ingestion_in_batches,
                         "get data in one or more batches, possibly only in part automated")
add_decision_option_link(data_ingestion_decision, manual_data_ingestion,
                         "provide data for ingestion manually")
manual_data_ingestion_can_use_raw_data_store = \
    manual_data_ingestion.add_links(raw_data_store, role_name="to", stereotype_instances=can_use)[0]
data_ingestion_in_batches_can_use_raw_data_store = \
    data_ingestion_in_batches.add_links(raw_data_store, role_name="to", stereotype_instances=can_use)[0] 

data_ingestion_in_batches_can_be_realized_by_data_ingestor = \
    streamed_data_ingestion.add_links(data_ingestor, role_name="to", stereotype_instances=can_be_realized_by,
                                      label="data ingestion service or component; requires fully automated " +
                                            "batch ingestion")[0]

```


added codes to source:

``` python
division_of_labour, independent_development, 
  distributed_development,         
  data_ingestion_decision, data_ingestion_by_request, streamed_data_ingestion,
data_ingestion_in_batches, manual_data_ingestion,
manual_data_ingestion_can_use_raw_data_store, data_ingestion_in_batches_can_use_raw_data_store
raw_data_store, streamed_data_ingestion_can_use_raw_data_store, data_ingestion_by_request_can_use_raw_data_store,
data_ingestion_in_batches_can_be_realized_by_data_ingestor,
data_ingestion_by_request_can_be_realized_by_data_ingestor, 
streamed_data_ingestion_can_be_realized_by_data_ingestor,
data_ingestor,
```


>So what we want to try and do is be able to build architecture that encompass the production requirements already in day one. So now just to understand further what are those things that you need to apply to a workload before you make it production worthy. So this, in this diagram you can see that once you finish developing the code, it’s not enough to have code. The next thing you need to do is essentially package it, you know create docker containers and make and build script and test script and then you need to think about scaling out your code. And there are different scaling strategies depending on your workload. If it’s data analytics or machine learning or deep learning and once you’ve done that you have to apply optimizations to make sure that it performs pretty well because this model serving function may sit behind an API gateway and serve real customer requests. If it takes too long, the latency is too high, it may not respond in time or maybe it does not have the right throughput to support your business application. And in order to provide the production aware system then you have to apply monitoring, observability, login, security, versioning for everything so you can further explain and and understand what’s going on in production and you know what you want to apply in order not to do everything manually, you want to apply automated processes so CI/CD you know, continuous integration, continuous development, grading workflows that automate the work of productizing work or generating those models and datasets that are relevant, doing rolling upgrades so you don’t have downtime, potentially doing A/B testing and Canaries. So there are many operational aspects to building a machine-learning pipeline and workflow and what you end up doing with a couple of data scientists for a few weeks, you may have with what we hear is people spend you know 12 to 18 months trying to productize those artifacts because they need larger teams with different disciplines that work on that problem. What we’re trying to show here is how to automate most of that workflow so we can rapidly go into production.

**OPEN CODING TRACE:**
- again: scalability
- packaging, testing, building, containerization
- scaling strategies: parallelization?
- speed performance, latency, throughput + monitoring, observability
- versioning for everything (code, data)
- all as part of CI/CD
- rolling upgrades as a force; supported by n models in production
- A/B testing, canary testing
- larger teams (coded about)

**AXIAL CODING TRACE:**

added:

``` python
building = CClass(practice, "Building")
deployment = CClass(practice, "Deployment")
containerization = CClass(practice, "Containerization")
canary_testing = CClass(practice, "Canary testing")
a_b_testing = CClass(practice, "A/B testing")
version_control_repository = CClass(practice, "Version control repository")

add_decision_option_link(delivery_tasks_decision, building)
add_decision_option_link(delivery_tasks_decision, deployment)
add_decision_option_link(delivery_tasks_decision, containerization)
add_decision_option_link(delivery_tasks_decision, canary_testing)
add_decision_option_link(delivery_tasks_decision, a_b_testing)
add_decision_option_link(delivery_tasks_decision, version_control_repository)

observability = CClass(force, "Observability")

rolling_upgrades = CClass(force, "Rolling upgrades")

data_version_repository = CClass(pattern, "Data version repository")
data_versioning_in_code_repository = CClass(pattern, "Data versioning in code repository")

deploying_how_to_version_data_decision = CClass(decision, "How to version data decision?")
no_data_versioning = CClass(do_nothing_design_solution, "No data versioning")

add_decision_option_link(deploying_how_to_version_data_decision, no_data_versioning)
add_decision_option_link(deploying_how_to_version_data_decision, data_version_repository,
                         "version repository with specific technology-support for data versioning")
add_decision_option_link(deploying_how_to_version_data_decision, data_versioning_in_code_repository)

data_versioning_in_code_repository_uses_version_control_repository = \
    data_versioning_in_code_repository.add_links(version_control_repository, role_name="to",
                                                 stereotype_instances=uses)

add_links({deploying_how_to_version_data_decision: model_and_application}, role_name="context",
          stereotype_instances=decide_for_some_instances_of)

add_links({automated_integration_and_delivery_in_ml_context_decision: deploying_how_to_version_data_decision},
          role_name="next decision", stereotype_instances=consider_if_not_decided_yet)

```

added observability force to monitoring_in_production_decision options

added rolling_upgrades force to deploying_model_versions_in_production_decision options

added codes to source:

``` python
packaging, testing, building, containerization, canary_testing, a_b_testing,
            deployment, delivery_tasks_decision,
             speed_performance,
            speed_performance_monitoring, low_latency, data_throughput, observability,
            ci_cd_pipeline_can_use_version_control_repository, version_control_repository,
          n_versions_in_production,   deploying_model_versions_in_production_decision,
          rolling_upgrades, data_version_repository, 
          data_versioning_in_code_repository,
          deploying_how_to_version_data_decision,
          no_data_versioning,
          data_versioning_in_code_repository_uses_version_control_repository

```

**SELECTIVE CODING TRACE**:
- This describes actually the rollback_to_previous_model_version from S6

added codes to source:

``` python
rollback_to_previous_model_version, 
rollback_to_previous_model_version_can_use_n_versions_in_production
```

**SELECTIVE CODING TRACE**:

- After adding decision on what to deploy in S6, added codes to source:

``` python
            semi_automated_model_deployment, 
            no_automated_deployment,
            how_to_approach_deployment_decision,
```

**SELECTIVE CODING TRACE**:

- Added tests mentioned above to what to test decision introduced in S6: 
``` python
unit_testing_system_components = CClass(practice, "Unit testing system components")
system_integration_testing = CClass(practice, "System integration testing")

add_decision_option_link(what_to_test_decision, unit_testing_system_components)
add_decision_option_link(what_to_test_decision, system_integration_testing)
add_decision_option_link(what_to_test_decision, a_b_testing)
add_decision_option_link(what_to_test_decision, canary_testing)

```
added codes to source:

``` python
unit_testing_system_components, system_integration_testing, what_to_test_decision
```

**SELECTIVE CODING TRACE**:
- While working on deployment / CI/CD paper - for `delivery_tasks_decision`, don't link to the three testing techniques directly (`a_b_testing`, `canary_testing`, `hypothesis_testing`) but link to them from the `testing` practice:

deleted:
``` python
add_decision_option_link(delivery_tasks_decision, canary_testing)
add_decision_option_link(delivery_tasks_decision, a_b_testing)
add_decision_option_link(delivery_tasks_decision, hypothesis_testing)
```

added:
 ``` python
testing.add_links(canary_testing, role_name="to", stereotype_instances=can_include,
                             label="testing technique")[0]

testing.add_links(a_b_testing, role_name="to", stereotype_instances=can_include,
                             label="testing technique")[0]

testing.add_links(hypothesis_testing, role_name="to", stereotype_instances=can_include,
                             label="testing technique")[0]
```

**SELECTIVE CODING TRACE**:
- While working on deployment / CI/CD paper - for `delivery_tasks_decision`, `version_control_repository` is not a task that is performed by
a delivery pipeline or component. I don't find any evidence of this in any other sources either. I think a delivery pipeline or component should be concerned with building/delivering ML models and not be responsible for a version control repository. 

deleted:
 ``` python
add_decision_option_link(delivery_tasks_decision, version_control_repository)
 ```


>What Is An Automated ML Pipeline ?
> 
> Slide 5

>So if we’re zooming into what is a machine learning pipeline? We have three different layers. We have the data layer, we have the computation layer and the pink one is served automation and orchestration layer.

>So usually in the pipeline you have different forms of data. You’re starting with row features that are being ingested through external sources using ETLs or streaming or various other mechanisms. 
Once you have the base features, you need to run analysis on those data sets and the analysis will produce a new denormalized data set or a clean or aggregated data set that we want to use for the training and so here in the preparation we may use tools like Spark or analysis or other Python tools or various database capabilities. Once we do that, we apply training. And in the training we want to try and do parallelism, we want to try different forms of training, different algorithms, different parameter combinations in order to see which one results with the best accuracy or best performance. Sometimes it has the best accuracy but it lowers our performance significantly or it takes a lot of time to compute. That it’s not really worth the extra accuracy. On the other tier, once you’ve done the training you want to run validation and the validation will take a bigger data set and compress that with the model that we just created, validated it’s working, performing et cetera. And once we have that ready we move into deployment. So this… When you do deployment, you actually deploy two different things. You deploy the model but you may also need to deploy APIs that go and query the data, bring the feature vector and essentially launch a call against the model. Those two things, the deployment of the model and the APIs, they also generate a lot of telemetry and a lot of information that’ll later be used to help us monitor the models in production, try and detect drift, detect all sorts of anomalies, monitor performance behavior of our model et cetera which also feeds back into the beginning ’cause if we find some changes in the model then we may wanna do retraining and collect new data et cetera. Above that layer of computation, we need an orchestration, we need to monitor experiments, monitor the data changes. We want to orchestrate, we don’t want to run everything manually, we want some automation systems to build those pipelines for us and monitor your activities as I mentioned before. So in our solution we have those three layers. One comprised of set of managed data services and the other one comprised of a set of serverless function engine that will describe based on few tools that can run different engines whether it’s Spark or a function more oriented towards real-time and above that a set of orchestration tools based on several open source projects.


**OPEN CODING TRACE:**
- stream-based, batch-based ingestion
- etl pipeline (as alternative to stream based data pipeline) mentioned
- after etl, data pipeline -> training (model building)
- model building parallelism
- different forms of training, different algorithms, different parameter combinations in order to see which one results with the best accuracy or best performance.
- model building (pipeline) does validation (and model selection)
- then deployment (pipeline): deploy model AND APIs  that go and query the data, bring the feature vector and essentially launch a call against the model.  => API to abstract data access (local, service), unified
- telemetry -> monitor the models in production: try and detect drift, detect all sorts of anomalies, monitor performance behavior of our model et cetera
- reaction: retraining or collect new data
- machine learning pipeline orchestrator
- model training
- serverless model as a service

**AXIAL CODING TRACE:**

- data ingestion, all coded already.
- train_multiple_model_versions, model building decision already coded.
- model_accuracy, model_accuracy_monitoring, speed_performance,
            speed_performance_monitoring already coded.
- ci_cd_pipeline already coded
- monitoring_in_production_decision already coded.
- automated_model_adjustment_can_use_retrain_model, retrain_model,
            retrain_model_can_use_train_multiple_model_versions already coded.

added:

``` python
etl_pipeline = CClass(practice, "ETL pipeline")
add_decision_option_link(data_processing_automation_decision, etl_pipeline,
                         "process data through extract, transform, and load steps")

model_validation = CClass(practice, "Model validation")
add_decision_option_link(model_building_tasks_decision, model_validation)
model_selection = CClass(practice, "Model selection")
add_decision_option_link(model_building_tasks_decision, model_selection)

ml_orchestrator = CClass(practice, "Machine learning/data science orchestrator")
ci_cd_pipeline_can_be_combined_with_ml_orchestrator = \
    ci_cd_pipeline.add_links(ml_orchestrator, role_name="to", stereotype_instances=can_be_combined_with,
                             label="orchestration of pipelines and experiments")[0]

collect_new_data = CClass(practice, "Collect new data")
automated_model_adjustment_can_use_collect_new_data = \
    automated_model_adjustment.add_links(collect_new_data, role_name="to", stereotype_instances=can_use)[0]

add_links({etl_pipeline: batch_or_realtime_data_processing_decision},
          role_name="next decision", stereotype_instances=consider_if_not_decided_yet)

serverless_model_as_a_service = CClass(practice, "Serverless model as a service")
serverless_model_as_a_service_is_a_model_as_a_service = \
    serverless_model_as_a_service.add_links(model_as_a_service, role_name="to", stereotype_instances=is_a)[0]
    
add_decision_option_link(integrating_ml_model_decision, serverless_model_as_a_service,
                     "serverless/function-as-a-service computing model for offering the model")
```

added codes to source:

``` python
etl_pipeline, data_processing_automation_decision, data_pipeline,
real_time_data_processing, batch_or_realtime_data_processing_decision, model_building_pipeline,
data_splitting, model_building_parallelization_decision, model_building_pipeline_per_model,
            model_partitioning, hybrid_model_building_parallelization, 
model_selection,
model_validation, model_training, 
model_building_tasks_decision,
local_data_access_api, service_based_data_access_api, data_service, unified_data_access, data_access_interface_decision,
monitoring_domain_specific_metrics_per_model,
            model_performance_monitoring_can_use_domain_specific_monitoring,
            model_performance_monitoring_can_use_model_accuracy_monitoring,
            model_performance_monitoring_can_use_speed_performance_monitoring,
collect_new_data,
automated_model_adjustment_can_use_collect_new_data,
ml_orchestrator, ci_cd_pipeline_can_be_combined_with_ml_orchestrator,
serverless_model_as_a_service, serverless_model_as_a_service_is_a_model_as_a_service,
model_as_a_service, integrating_ml_model_decision,
```

**SELECTIVE CODING TRACE:**
- orchestration is good for: process and work automation, monitoring data changes
Added force relations between `ml_orchestrator` and `process_and_work_automation`, `recognise_data_drift`
 
> Slide 6
>Okay. So if we need to build a stack, one of the recommended mechanism is to essentially leverage Kubernetes which is a generic micro-services orchestration framework and on top of that Kubernetes layer, we wanna plug all those different services including Spark and potentially Presto and TensorFlow, Horvod, Jupyter notebooks, service engines like Nuclio et cetera. This layer has to use some data. After all were processing some data so we may have a combination of on one end a data like in the cloud we may use S3 or objects or on Prem, we may use some fire solution like NFS or a dupe HDFS and in parallel we may want databases to do real-time, workloads and querying you know, key value stores et cetera. At the end on top, we need a framework to also run the AutoML you know, run various experiments automatically, we need a way to track the experiments, the data that is resulting from the experiments et cetera. We need a mechanisms to manage the mega data of all of our data sets and the features through a feature store and we need a workflow engine. There is one pretty good in Kubernetes called Kubeflow which is very tightly integrated into Kubernetes. So that is essentially a recommended architecture for building your micro services.

**OPEN CODING TRACE:**
- about the technical realization using different typical technologies
- mentions integration of Jupyter notebooks
- other concepts mentioned before
- data layer, data lake, object store, real time database as shared db
- feature store

**AXIAL CODING TRACE:**

- store data decision and shared dbs already coded.

added:

``` python
real_time_database = CClass(practice, "Realtime database")
real_time_database_is_a_shared_data_store = \
    real_time_database.add_links(shared_data_store, role_name="to", stereotype_instances=is_a)[0]
```

added codes to source:

``` python
            model_building_in_development_tool, development_tool_facade, 
            development_tool_facade_can_be_combined_with_model_building_in_development_tool,
            data_lake, data_lake_is_a_shared_data_store,
            real_time_database, real_time_database_is_a_shared_data_store,
            feature_store, feature_persistence_and_access_decision, store_features_without_specific_support, 
```

> Slide 7

> So we talked before about the concept of serverless. So serverless was invented few years ago by Amazon with introduction of lambda. Serverless is trying to enable two main things. One is write resource elasticity which translates to lower cost because you’re only using what you need and on the same time also translates to scaling, scaling out and being able to handle any scale of data and computation needs. The other aspect of serverless is essentially automating all those different tasks that I mentioned before. You don’t build containers, you write the function and that automatically runs on some container that’s generated for you, everything is auto scaling, it’s monitoring the workload automatically logging and it has more rigid security and all the things are automated so we don’t have to deal with those aspects but serverless also have downsides and I’ve listed here in this slide. So you can see serverless is usually event driven, very short lifespan on functions but when we drive the machine learning worker it may work for half an hour and also scaling is done through serverless using load balancer techniques while for example you take spark thence the spark scaling is out for RDDs and shuffles and reuse or in machine learning and deep learning using hyper parameters to run multiple permutation so that’s a different way of scaling the workload. In data science you have state, you have data and usually service is stateless. And finally the inputs and outputs of a function in those kind of data intensive job is more like a job meaning a parameter data set… You input a set of parameters to provide some input data set then you output with a set of results and some output data sets. So we need a different API to do serverless function but the general idea could stay the same of having essentially elastic scaling and doing fully automated deployment and operation. So with that we introduce an open-source framework, two actually one called Nuclio…


**OPEN CODING TRACE:**
- again Serverless
- reiteration of concepts introduced before.

**AXIAL CODING TRACE:**
- nothing coded for now.

> Slide 8
ML & Analytics Functions Architecture

> One called Nuclio, the other one called MLRun which working together and the general idea is to extract the computation resources and computation resource could be as far cluster, could be a dust cluster if you need, could be Horovod if you’re using deep learning or Nuclio engine which is used for mostly for real-time surveying, suggestion, et cetera And you take your code, you plug it into that runtime but you need an automation framework to do all those things that serverless do, to build containers automatically, auto scale the workloads, collect inputs and outputs, do logging, monitoring et cetera. So we came up with this concept of machine learning functions which is essentially doing all that work for you. Think of it as when you have a function, what you wanna do is inject the set of inputs, parameters, secrets, credentials in case you’re using accessing some databases or external connections and some data sets then you wanna run the workload and finally generate outputs from that function which could be results you know, accuracy et cetera. It could be operational data, logs, monitoring et cetera or could be data itself. And those functions need to plug into a framework for workflow management and work for castration so you can compose different workflows out of those individual function objects.
> 

**OPEN CODING TRACE:**
- reiteration of concepts introduced before.

**AXIAL CODING TRACE:**
- nothing coded for now.

> Slide 9
KubeFlow+ Serverless: Automated ML Pipelines

>Okay. And one of the tools that we use for composition is an open source tool called Kubeflow, originally designed by Google which allows you to compose if you’re familiar with the Apache Airflow or Jenkins and the DevOs world that you can essentially go and compose a layout, a graph, a dag and say for example go bring the data, finish bringing the data, run some data preparation, run training validation, deploy with a bunch of conditions so you can use Kubeflow and if you combine Kubeflow as a workflow engine with serverless frameworks like MLRun and Nuclio then you can essentially go and create something which is far more automated and deliver those pipelines without all the DevOps work associated with that.

**OPEN CODING TRACE:**
- reiteration of concepts introduced before.

**AXIAL CODING TRACE:**
- nothing coded for now.


> Slide 10
>Okay.
Automating The Development & Tracking Workflo

>So if we’re looking into a workflow, how would such a workflow, development workflow work? So usually you start with writing some code. So you write code in your local Jupyter or PyCharm or in a managed Jupyter notebook or some other notebook framework. While you’re doing that, you may still wanna track everything you do, runs, experimenting, you need some SDK for that like MLflow or MLRun has its own mechanism for tracking experiments. Once I wanna move to running the job and the cluster I may need to also specify some resources for example I need GPUs, I want to an amount of CPU, I need dependencies on certain images. Maybe I need to mount some data volumes into my work routes to make my work load work against something, I need to specify that. And then there’s an automated machine or any serverless engine that will do the build for me and the deployment on the cluster. So I can deploy on the cluster, I can run out a scale for example I could write a spark job or any other Python job on my notebook. It adds some configuration and metadata for the runtime on that job for you. I need this image, I need this amount of CPUs or GPUs and launch. This launch will trigger a build process and a deployment process and my job can now run distributed on the cluster and we’re gonna see that in a minute, how I can run whether it’s a spark job or regular Python job on the cluster distributed with just simply just submitting the work. Once I finish experimenting with my function unit testing that I wanna publish that into a source code repository like GitHub for example potentiating some documentation so if I later on wanna go back into that function and use it, I know what it’s doing, what’s the API et cetera or I may wanna compose a bigger workflow using Kubeflow pipelines which essentially does a multi-stage process you know, for young preferred data, training, validate et cetera. When I’m building the pipeline, I may also take functions that were built before either by me or by other members of the team. So this function of programming is allowing me to break my code to smaller pieces that are managed, could be version, could be deployed you know, in a more easy way and are fully documented and I could use experiment tracking for the entire system to see what’s going on. So that’s one type of workflow. Another automated workflow that is more, what is referred to as Gitbox, Git Based Operations or the traditional CI/CD workflow is that instead of publishing your code at the end, you first you write some code and you provide some manifest, some configuration and in publish that into a source control system like Git for example. This publishing, this pull request generate the triggers which automatically takes your code, take the dependencies, build the images, runs automatically the pipeline, reports on the results and responds back into your pull request, responds back with all the results of the training or the workflow and you can take it for that.
> 
> 
**OPEN CODING TRACE:**
- reiteration of concepts introduced before.

**AXIAL CODING TRACE:**
- nothing coded for now.
 
**SELECTIVE CODING TRACE**:
- metadata in CI/CD mentioned
**SELECTIVE CODING TRACE**:
- after coding S6 added metadata store

added codes to source:

``` python
ml_metadata_store,
model_building_pipeline_can_use_ml_metadata_store, 
ci_cd_pipeline_can_use_ml_metadata_store
```


> Slide 11
MLOpsAutomation: The Way

>That’s the benefit of that. It’s more production oriented because you can track the entire process. You could see who published, you can have reviewers that approve the process et cetera but those two processes will coexist. Usually in the initial development of a project, we’ll start with a more interactive way and as we introduce more numbers to the team and we grow, we have to move into more and more automated CI/CD based pipelines for our work.

**OPEN CODING TRACE:**
- reiteration of concepts introduced before.

**AXIAL CODING TRACE:**
- nothing coded for now.

**SELECTIVE CODING TRACE**:
- added support for "mlops" in `ml_adds_sources_codes.py` following addition of s20:
``` python
        mlops, mlops_decision, no_mlops 
```
> Slide 12
> Fraud Prevention Case Study: Payoneer

>And we’ll see how we can essentially combine both in an automated session. So with all that theory let’s look at the actual deployment example from one of our users called Payoneer. They’re doing a fraud prevention. They’re a payment company, a pretty large. They wanted to do two things. They wanna move from fraud detection to prevention meaning becoming more real-time and this provides a lot of value to their business. On the second aspect, they wanna move from to a micro-services which cuts the time for them to productize any new software artifact, any new thing bring it much faster to production. So they’ve chosen to move from a traditional active architecture which is Hadoop based to an architecture of micro-service.
Traditional Fraud Detection Architecture (Hadoop)

>So their original solution… By the way there’s a full case study. Anyone that will send me an email I can send him the case study on that. Their original solution based on the Duke was essentially doing ETL jobs from their database, running various analytics workload and then using Spark, sorry. Using our server to do predictions. The process because it was very battery and it took about 40 minutes from the minute this transaction were written to the database until they could this decide if they wanna block the fraudulent account and over the fraudulent transactions. And that’s really challenging because in 40 minutes you can empty the bank. The other challenge that working with Hadoop, it was very rigid. The process was very resource intensive and they wanted to move to more agile automated microservices architecture, pretty much like in the cloud.

**OPEN CODING TRACE:**
- mentions data warehouse on slide

**AXIAL CODING TRACE:**
added codes to source:

``` python
            data_warehouse, data_warehouse_is_a_shared_data_store,
```


> Slide 13
>Moving To Fraud Prevention

>So with that they changed into a new architecture based on real-time and micro services. So the general idea is that the database transactions are streamed, they’re not batch. They’re streamed into serverless functions that collect this stream, my serverless function gets intercepted stream they run first analysis or enrichment or rather aggregations on the data and ingest that into a real-time feature stored. In parallel we have spark functions that run analytics functions on a bigger window and trying to work and create additional insights from the data. We have now an enriched data set from historical data and real-time data so we have functions that essentially go and do model training, in this case use scikit-learn in a distributed fashion. And once we have those models, we can start serving those streaming events. So all those streaming events that are coming and getting contextualized and enriched in real time into an enriched feature vector are going into an increasing serverless function. This serverless function decides if to block the account or not and it essentially just writes into the database telling it the database block this account because there is a fraud and so this entire process from getting the data out of the database on the first transaction that is suspicious in fraud until the account was actually blocked, this entire process took about 12 seconds moving from 40 minutes. Why? Because it’s much easier to do that, those kind of things with serverless functions and streaming or message queues in this example and you can see that we combine traditional tools like spark alongside with others or more Python or other languages in a micro services and containers as workload. The major advantage beyond cutting the time to detection is also moving to an automated development and production environment using this serverless approach. If we wanna change a piece of code in any of those series, we just go and update something and push deploy and gets deployed into production. There’s no need for long build processes et cetera. It’s very automated workflow and in a rolling average it will actually without any incurring any downside it will automatically update in production. So this customer managed to move from quarterly a release cycle to a weekly release cycle because it’s so easy and automated to release new versions into production and it’s rather safe because they can always pull back and load the previous version. Now once we created a model, it’s not enough. We need to monitor our model in order to identify if the model is bad, if it’s good, if there is a drift, if there’s a problem with performance maybe we need to switch back to an older model or retrain in order to creates ensembles. So we also need a real-time system to monitor our model in production. So using this serverless or micro service architecture, once we’ve done the training and we created the serving API and model, though serving API and model also generate stream, stream of data with all the transactions of inferencing that entered that system. There is a micro service that listens on that stream and starts analyzing that stream, creating time series aggregations you know, which will show later on in a dashboard like the and essentially micro batching those streams into bigger parquet files and there is another function that periodically goes and analyze that stream of data, compares it with reference data in order to detect that there is drift. If there is a drift through a simple API call, it could launch, remodify ana assemble or do any corrective measurement. So it’s now not only the problem of creating the training and serving the model, we also need to be able to manage the model and monitor the model in production. Okay. So with that let’s go and see a demo of this architecture in action. So what we see is the… What we wanna show you is how it’s relatively easy to go and start with a notebook and write some code and turn that code into production without the local work. So we see here a notebook running on our manage platform
but that could also be running on your laptop. There’s a full documentation on that, that is using a project called MLRun in GitHub, you know.


**OPEN CODING TRACE:**
- mentions Near real-time support and efficiency forces
- MSA enables more independent processing
- continuous improvement implicitly and mentioned before.
- feature engineering 

**AXIAL CODING TRACE:**
added codes to source:

**SELECTIVE CODING TRACE**:
- After s35, adding the following practice to this source:
``` python
ensemble_learning
```


``` python
            near_real_time_support, independent_processing,
            efficiency
```


>MLRun has a repository in Git that you can just go and there’s a lot of demos, end to end demos of different use cases, image classification, face recognition you know, time series analysis. You can just load the project and go with it and start you know, customer churn prediction is an entire projects with many different complex steps that could be you know, tried out through that project. So let’s take this simple example of a project that’s just using the Iris dataset. So what we said before that we need to provide a manifest along with our code so that our code is the code that is running but sometimes we need some packages or we need some images or resources. So we can just annotate those in our notebook and give some commands to serve a compiler that will come later that those are packages that are required for production or this is the image we’re gonna use as a baseline and a docker image or potentially again multiple other configuration. Then we could just go and run or write our code and we could instrument our code, we could also add things like logging, artifacts or data set or models or just logging and notifications. I’m grabbing some secrets and credentials. There’re all sorts of things that are provided through the wrapper that runs this code. And again, it’s very simple code. There’s a context object. There’re certain parameters that aren’t injected into my code and I could just go and run it as a data scientist and play with it.

>At some point I wanna create a project that uses a bunch of functions so I can just go and create the new project and I’m gonna run my code in my notebook by just wrapping it with something that will sandbox my code and record everything that my code did. So I’m using run local and I can run it. At the same time exactly I can just go and run it on the cluster as if it was running on my notebook so that also allows me a concept of CPU or GPU as a service. I can just launch a job on the cluster. At some point I wanna turn my code in my notebook into a container object so that’s relatively easy. I just run a command called code to function, I give it a name runtime engine, again could be job, Kubernetes job or could be a spark job or other thing supported through that engine. I may wanna register my function to my project so that will appear later on as part of my project and maybe I wanna start doing other things like for example I wanna analyze my data. I’m gonna use a library function called Described with a Son tag and because that function is already showing me how to go and analyze the features and the clustering and all that of my projects. So I’m just gonna load this function. I don’t really remember how to use it so I just ask for documentation and you see I understand what this function is doing is visualization and data analysis on the data set. I can provide it all sorts of parameters and then I just wanna run this function. I loaded it from the internet with some version. I wanna run it with certain parameters, what is the label columns? What is the input data which is essentially the output of my previous job that was running? Just pointing to it. Where do I wanna drop my artifacts? And I’m just gonna launch this job. Now if you’re familiar with Kubernete, you’ll see that actually in the background it’s creating a job in the cluster but all those outputs that are generated from the function that are going back to my Jupyter so I have the experience of running from a notebook but in parallel it’s actually running on a distributed cluster and recording all those actions. At the same point I wanna create a bigger pipeline that involves scikit-learn and classification with AutoML and potentially testing my classifier using validation, distributed validation techniques and creating a model serving function. And after I created the model serving function, I wanna test that it’s actually working and performing porter. I didn’t wanna write all this ’cause I’m too lazy so I’ll just import functions that do all those things for me and I’ll add them to my project and the only thing I need to do now is define a DSL, a graph that tells me you know random ingestion, forest ingestion good you know run the analysis. Once you finish the analysis, run the training and once you finish the training with you know various algorithm options ’cause it’s AutoML, it will have run through all those, run the validation. The validation will use the data and the test set and the model from the training and so on. The serving function we use the model from the training and the testing, the live testing function will use the addresses and other things from the deployment functions. So like essentially define the graph and I could just go and execute that graph by just saying project run, okay and what it does it just, it creates a queue flow, the Kubernetes automated workflow with all of those things that I just described. So you see I have a deployment, I’m building my containers for the set up and then I’m getting some data. Data is presented here. I’m summarizing my data, I’m running analytics and feature analysis on my data so you can see the behavior of my data, the features. Again all sorts of charts automatically generated for me. I wanna run training so again I can see our C curves and various charts that are generated through the training. The training is also doing AutoML and so I can actually see that it’s ran multiple algorithms on the same data set. Once it’s done I see a testing on the model with again different test set, it’s deploying my model and after deploying my model it’s actually testing that my deployed model is performing, this is like a latency curve of my model. So I fully automated my entire pipeline by writing a single notebook, I created an end-to-end project, something that would take months and months and it all scales on a horizontal scaling cluster. Now it’s not limited to just those simple Python functions, you could do exactly the same with also Spark. So I’m on run support Spark as a runtime engine and I could define a Spark job. In fact this is a task that for example reads a couple of data sets and run some query and some joins on those two data set so I define parameters to my function which are the source data sets, I define a sequel query which I wanna run and I have some spark code that is in the background. I can run this thing using a local what we call local run-time so I’ll run it locally on my notebook environment. Great! It works. And then I can run it on a distributed as a serverless spark function on a distributed cluster by just changing my runtime client to Spark. Now it’s essentially choosing Kubernetes operators if you’re familiar with that term. Essentially it’s going to launch a spark cluster for me and run the job on that spark cluster and I could customize the resource requirements and dependencies and chores and all of that. Again with this mechanism, you see that I can fully automate my productization pipeline, I can get really nice performance. All those functions that I’m building are part of Nuclio, again an open source project where I could just go and do those functions, dig into the code of the functions and you know I can attach those functions not only as batch, I can make them work off streams like for example Kafka stream, et cetera.

>And just spend a few words, a few configuration elements on that. And the other thing I mentioned before is beyond just doing all those things manually, we can also work for everything in a Git based workflow. So we can for example publish our code, this notebook that I just mentioned. We can just publish it in to Git, to GitHub in this example. The code is also generating what we call project demo file, it’s the project configuration file of all those saying that I did those functions that I attached some other configuration and what they could do is every time I change the code through a pull request, let’s take a full request example, I can ask the Git to just run experiments on that workflow of my repository. This trigger will automatically launch a CI step so automatically MLRun will kick in, it will automatically respond. That’s a comment made by the bot. It’s automatically responding. I’m starting to run this pipeline that we just showed you. When the pipeline finishes, it will automatically plot a result. So this way we managed to create, to document the internal workflow, we can have reviewers, we can have a much more controlled workflow for our development. So without a lot of extra work, we just converted something that we worked on interactively into a fully automated CI/CD pipeline for machine learning, okay? So with that, thank you everyone.

>I hope this demo was clear. Anyone that wants to ask more questions, you can reach me out. In my Twitter is my full name Yaron Haviv. 

**OPEN CODING TRACE:**
- reiteration of concepts introduced before.

**AXIAL CODING TRACE:**
- nothing coded for now.

**SELECTIVE CODING TRACE**:
Here mentioned: trigger through GIT, can be on commit.

- added:
``` python
on_commit_trigger = CClass(practice, "On commit trigger")
add_decision_option_link(trigger_pipeline_or_orchestrator_decision, on_commit_trigger,
                         "when a commit to a source or data version control repository happens")
```


- added on schedule triggering option as codes:
``` python
          on_demand_trigger, on_commit_trigger, trigger_pipeline_or_orchestrator_decision
```

- added addition testing codes for model validation testing:

``` python
          testing_model_training_converges, ,
```

AutoML mentioned.

- added:
``` python
auto_ml_decision,
auto_ml,
no_auto_ml
```
