# source
## ID
8
## url
https://github.com/ThoughtWorksInc/cd4ml-workshop/blob/master/Strata-london-2019-slides.pdf

also:
https://github.com/ThoughtWorksInc/cd4ml-workshop/

## archive url
https://tinyurl.com/ml-adds-u8
## title
Continuous Intelligence: Moving Machine Learning Application into Production Reliably
## source code
yes
## example
yes
## source type 
Slides
## author type
Practitioner
## references

**AXIAL CODING TRACE**: source and references
``` python
s8 = CClass(source, "s8", values={
    "title": "Continuous Intelligence: Moving Machine Learning Application into Production Reliably",
    "url": "https://github.com/ThoughtWorksInc/cd4ml-workshop/blob/master/Strata-london-2019-slides.pdf",
    "archive url": "TODO",
    "author type": "Practitioner",
    "type": "Slides",
    "example": True,
    "source code": False})
``` 

# coding

S1-S7: 

**OPEN CODING TRACE:**
- no relevant content

S8 - S10:

**OPEN CODING TRACE:**
- forces for CD4ML: reproducibility, testability, auditability, continuous improvement
- modifiability force
- for: CD pipeline

**AXIAL CODING TRACE:**

added:

``` python
reproducibility= CClass(force, "Reproducibility")
testability = CClass(force, "Testability")
auditability= CClass(force, "Auditability")
continuous_improvement = CClass(force, "Continuous improvement")

```

added reproducibility, testability, auditability, continuous_improvement forces to automated_integration_and_delivery_in_ml_context_decision options

added codes to source:

``` python
reproducibility, testability, auditability, continuous_improvement, modifiability,
ci_cd_pipeline, automated_integration_and_delivery_in_ml_context_decision,
```

S11-S12

**OPEN CODING TRACE:**
- on CI/CD pipeline
- again reproducibility
- reliable process
- contains automated provisioning, build, source control, 
- continuous improvement again
- process and work automation

**AXIAL CODING TRACE:**

added codes to source:

``` python
            building, delivery_tasks_decision, version_control_repository,
            automated_provisioning, provisioning_decision, process_and_work_automation, reliability,
```

S13:
**OPEN CODING TRACE:**
- data discovery and access (local or via service)
- version control and data/artifact repo
- CD orchestration / combine pipelines
- environments / automation (also before link to CD book implies which possible environments
can be provisioned)
- model performance assessment tracking (tracked in metadata store, as part of model building)
- model monitoring / observability

**AXIAL CODING TRACE:**

added codes to source:

``` python
            store_data_decision, data_access_interface_decision, service_based_data_access_api,
            local_data_access_api,
            data_version_repository, deploying_how_to_version_data_decision,
            ci_cd_pipeline_can_be_combined_with_ml_orchestrator, ml_orchestrator,
            automated_provisioning_can_include_pre_production_environment_provisioning,
            pre_production_environment_provisioning,
            production_environment_provisioning, automated_provisioning_can_include_production_environment_provisioning,
            test_environment_provisioning, automated_provisioning_can_include_test_environment_provisioning,
            monitoring_in_production_decision, model_accuracy_monitoring, model_performance_monitoring,
            speed_performance_monitoring, model_performance_monitoring_can_use_speed_performance_monitoring,
            model_performance_monitoring_can_use_model_accuracy_monitoring, observability, ml_metadata_store,
            model_building_decision, model_building_pipeline
```


S14:
**OPEN CODING TRACE:**
- in addition to S13:
    - data ingestion, but not how
    - deployment from CI/CD pipeline
    - system integration testing
    - model validation and training, part of model building
    - data science steps / data pipeline parts.

**AXIAL CODING TRACE:**

added codes to source:

``` python
            data_ingestion_decision, deployment,  system_integration_testing,
            what_to_test_decision,
            model_validation, model_building_tasks_decision, data_pipeline,
            data_processing_automation_decision, model_training
```

S15-S20:

**OPEN CODING TRACE:**
- no new relevant content

S21:
**OPEN CODING TRACE:**
- containerization from CI/CD pipeline
- again version control
- again production deployment
- on commit trigger for pipeline

**AXIAL CODING TRACE:**

added codes to source:

``` python
    containerization,  trigger_pipeline_or_orchestrator_decision, on_commit_trigger,
```

S22-S24:

**OPEN CODING TRACE:**
- no new relevant content

S25:
**OPEN CODING TRACE:**
- retrain model option for model adjustment
- monitoring again

**AXIAL CODING TRACE:**

added codes to source:

``` python
            retrain_model, automated_model_adjustment_can_use_retrain_model, automated_model_adjustment,
            manual_model_adjustment, monitoring_model_adjustment_decision,          
```

S26:
**OPEN CODING TRACE:**
- data ingestion again
- data processing and extract features (the example here is a batch example, but spirit points more to stream processing)
- extract features
- data splitting
- model building / validate model again

**AXIAL CODING TRACE:**

added codes to source:

``` python
data_extraction,
            data_processing_tasks_decision, batch_or_realtime_data_processing_decision, real_time_data_processing,
            batch_based_data_processing,
            data_splitting, model_building_tasks_decision, feature_engineering,
```

S27-31:
**OPEN CODING TRACE:**
- data versioning again
- forces for it: large data files handling, reproducibility

**AXIAL CODING TRACE:**

added codes to source:

``` python
handling_large_data_files = CClass(force, "Handling large data files")

add_force_relations({no_data_versioning: {handling_large_data_files: negative,
                                          reproducibility: very_negative
                                          },
                     data_version_repository: {handling_large_data_files: very_positive,
                                               reproducibility: very_positive
                                               })
```

added codes to source:

``` python
no_data_versioning, 
```

S32:

**OPEN CODING TRACE:**
- no new relevant content

S33:

**OPEN CODING TRACE:**
- details on tracking experiments (stored by model building as metadata about them)
- implies multiple model versions are trained

**AXIAL CODING TRACE:**

ml_metadata_store already coded

added codes to source:

``` python
train_multiple_model_versions
```

S34:

**OPEN CODING TRACE:**
- tool for pipeline orchestration

**AXIAL CODING TRACE:**

- ci_cd_pipeline_can_be_combined_with_ml_orchestrator, ml_orchestrator, already coded
- but here focus is more on model building than ci/cd, so either both is orchestrated, or 
only model building pipelines.

added:
``` python
model_building_pipeline_can_be_combined_with_ml_orchestrator = \
    model_building_pipeline.add_links(ml_orchestrator, role_name="to",
                                         stereotype_instances=can_be_combined_with,
                                         label="orchestration of pipelines and experiments")[0]
```

added codes to source:

``` python
model_building_pipeline_can_be_combined_with_ml_orchestrator
```

S35:

**OPEN CODING TRACE:**
- no new relevant content

S36 - S39:
- tracking/logging in production as a special case of monitoring
- storing all tracked/logged data in a store
- forces: avoid training serving skew, identify potential bias or overfit
- helps to learn continuously
- model trainining

changed:
``` python
monitoring_and_tracking_in_production_decision = CClass(decision, "How to monitor and track the model in production?")

```

added:
``` python
identify_potential_bias_or_overfit = CClass(force, "Identify potential bias or overfit")

model_in_production_tracking = CClass(practice, "Model in-production tracking")
production_data_store = CClass(practice, "Production data store")
model_performance_monitoring_can_use_production_data_store = \
    model_performance_monitoring.add_links(production_data_store, role_name="to",
                                           stereotype_instances=can_use, label="store monitored production data")[0]

model_in_production_tracking_can_use_production_data_store = \
    model_in_production_tracking.add_links(production_data_store, role_name="to",
                                           stereotype_instances=can_use, label="store tracked production data")[0]

model_performance_monitoring_can_be_combined_with_model_in_production_tracking = \
    model_performance_monitoring.add_links(model_in_production_tracking, role_name="to",
                                           stereotype_instances=can_be_combined_with)[0]
                                           
add_decision_option_link(monitoring_and_tracking_in_production_decision, model_in_production_tracking,
                         "track model usage, inputs, outputs, interpretability, and fairness")

add_links({production_data_store: store_data_decision},
          role_name="next decision", stereotype_instances=consider_if_not_decided_yet)

```

added avoid_training_serving_skew, identify_potential_bias_or_overfit,  forces to  monitoring_and_tracking_in_production_decision options

added codes to source:

``` python
model_in_production_tracking, production_data_store, model_performance_monitoring_can_use_production_data_store,
model_in_production_tracking_can_use_production_data_store,
model_performance_monitoring_can_be_combined_with_model_in_production_tracking,
avoid_training_serving_skew, identify_potential_bias_or_overfit, 
continuous_model_improvement
```

S40ff:

**OPEN CODING TRACE:**
- no new relevant content, only summary





